/*  labyrinth_generation.c

  ਭ
  Version 0.2.6

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "includes_macros.h"

//int check_in_neighbor_cells(int x, int y, int const max_distance, int const size_labyrinth_length, int const size_labyrinth_width, int const *labyrinth);
int check_in_neighbor_cells_border(int x, int y, int const max_distance, short int const size_labyrinth_length, short int const size_labyrinth_width, int const *labyrinth, int i); //for debug - 뢮 ६ "i"

int check_in_neighbor_cells_around(int x, int y, unsigned short int const direction_mask, int depth, short int *cell_types, short int const size_labyrinth_length, short int const size_labyrinth_width, int const *labyrinth);

void show_labyrinth_in_progress(int x, int y, char *info_string, int info, int count, int progress, short int length, short int width, const int *labyrinth_temp);

int labyrinth_generation(int *labyrinth, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const visual, short int const no_walls_removing, short int const result, short int const rivals, short int const holes, short int *holes_array, struct players player[])
{
	//ᨢ  ⨯ ⮪ ਭ ( check_in_neighbor_cells_around() )
	short int *cell_types=(short int*)calloc(END_OF_CT_ENUM, sizeof( short int ));
	time_t start_global_generation=time(NULL); //६ 砫 饩 樨 ਭ
	// ᨢ 祭ﬨ  㬮砭
	//ࠩ    ⥭
	for (int i = 0; i < size_labyrinth_length; i++)
	{
		labyrinth[i]=WALL;
		labyrinth[(size_labyrinth_length*size_labyrinth_width-size_labyrinth_length+i)]=WALL;
	}
	//ࠩ   ࠢ ⥭
	for (int i = 1; i < size_labyrinth_width-1; i++)
	{
		labyrinth[(i*size_labyrinth_length)]=WALL;
		labyrinth[(i*size_labyrinth_length+size_labyrinth_length-1)]=WALL;
	}
	//७ 
	for (int i = 1; i < size_labyrinth_width-1; i++)
	{
		for (int j = 1; j < size_labyrinth_length-1; j++)
		{
			//if ((i%2 == 0)&&(j%2 == 0))
			if ((i%2 != 0)&&(j%2 != 0))
			{
				labyrinth[(i*size_labyrinth_length)+j]=DUMMY; //DUMMY=2 -   ⪠
			}
			else
			{
				labyrinth[(i*size_labyrinth_length)+j]=WALL; //WALL=1 -  ⥭
			}	
		}
	}
	// ਭ
	srand(time(NULL)); //樠  砩 ᥫ
	//⠭ 砫 न  樨					x y-->
	int x=0; //न 祩  ⨪ ( ப)		|
	int y=0; //न 祩  ਧ⠫ ( ⮫)		V
	//न   楫묨 묨 ᫠, ⮡    祩,  ன ᯮ ⥭,
	// 室    1  size_labyrinth_length-2/size_labyrinth_width-2 ( ਭ,  믠  ࠩ ⥭)
	do
	{
		x=rand()%(size_labyrinth_width-2)+1;
	} while (x%2 == 0);

	do
	{
		y=rand()%(size_labyrinth_length-2)+1;
	} while (y%2 == 0);
	
	labyrinth[(x*size_labyrinth_length)+y]=CELL; //ਧ ᬮ७ 祩 (CELL=0 -  ⪠)
	int cells_for_review[(size_labyrinth_width*size_labyrinth_length)]; //⫮ 祩, 騥 ᬮ७ ᥤ 祩
	int count=0; // ᨢ cells_for_review[]
	int progress=0; // 誠 ண (  ?)
	int all_viewed=0; //ਧ  ᬮ७ 祥 ᨢ
	while (!all_viewed)
	{
		//। ⢠ ᬮ७ ᥤ 祥
		int neighbor_for_review=0;
		if (x-2 >= 0 && labyrinth[(x-2)*size_labyrinth_length+y] == DUMMY)
		{
			neighbor_for_review++;
		}
		if (y-2 >= 0 && labyrinth[(x*size_labyrinth_length)+(y-2)] == DUMMY)
		{
			neighbor_for_review++;
		}
		//if (x+2 < size_labyrinth_width && x+1 < size_labyrinth_width && labyrinth[(x+2)*size_labyrinth_length+y] == 2)
		if (x+2 < size_labyrinth_width && labyrinth[(x+2)*size_labyrinth_length+y] == DUMMY)
		{
			neighbor_for_review++;
		}
		//if (y+2 < size_labyrinth_length && y+1 < size_labyrinth_length && labyrinth[(x*size_labyrinth_length)+(y+2)] == 2)
		if (y+2 < size_labyrinth_length && labyrinth[(x*size_labyrinth_length)+(y+2)] == DUMMY)
		{
			neighbor_for_review++;
		}
		//᫨  ᬮ७ ᥤ 祩 - 砩 ࠧ ।塞,   ࠢ, ᫨ ,
		//(0 - , 1 - ࠢ, 2 - , 3 - )
		//塞 ﭨ  祩  祩    ⥪饩  ﭨ " ⪠"
		// ⠭  न  ⢥ ⥪
		if (neighbor_for_review > 0)
		{
			//᫨ ⢮ ᬮ७ ᥤ 祥   -   ⥪饩 祩, ᫨    ᠭ
			if (neighbor_for_review > 1)
			{
				int repeat=0;
				for (int i = 0; i < count; i=i+2)
				{
					if (cells_for_review[i] == x && cells_for_review[i+1] == y)
					{
						repeat++;
					}
				}
				if (!repeat)
				{
					cells_for_review[count]=x;
					cells_for_review[count+1]=y;
					count=count+2;
				}
			}
			int vector=0;
			while (vector != 4 )
			{
				vector=rand()%4;
				if (vector == UP && (x-2) >= 0 && labyrinth[(x-2)*size_labyrinth_length+y] == DUMMY)
				{
					x=x-2;
					labyrinth[(x+1)*size_labyrinth_length+y]=CELL;
					vector=4;
				}
				if (vector == RIGHT && (y-2) >= 0 && labyrinth[(x*size_labyrinth_length)+(y-2)] == DUMMY)
				{
					y=y-2;
					labyrinth[(x*size_labyrinth_length)+(y+1)]=CELL;
					vector=4;
				}
				if (vector == DOWN && (x+2) < size_labyrinth_width && labyrinth[(x+2)*size_labyrinth_length+y] == DUMMY)
				{
					x=x+2;
					labyrinth[(x-1)*size_labyrinth_length+y]=CELL;
					vector=4;
				}
				if (vector == LEFT && (y+2) < size_labyrinth_length && labyrinth[(x*size_labyrinth_length)+(y+2)] == DUMMY)
				{
					y=y+2;
					labyrinth[(x*size_labyrinth_length)+(y-1)]=CELL;
					vector=4;
				}
			}
			labyrinth[(x*size_labyrinth_length)+y]=CELL;
		}
		//᫨  ᥤ 祩 ᬮ७ - 塞 ﭨ ⥪饩 祩  " ⪠"
		else
		{
			labyrinth[(x*size_labyrinth_length)+y]=CELL;
			//᫨  ᬮ७ 祩 (ᨢ cells_for_review  ) - ᬠਢ   ᫥饬 室 横
			if (count)
			{
				x=cells_for_review[count-2];
				y=cells_for_review[count-1];
				count=count-2;
			}
			// - ⠥,   祩 ᬮ७ (ਭ ᣥ஢), ⠭ ᮮ⢥騩 ਧ 
			else
			{
				all_viewed=1;
			}
		}
		progress++;
	//}
	
	
		//뢮 ⫠  筮 १ - ᪥ ਭ (᫨  ⪫祭 १ ࠬ)
		//double progress_print=progress/(size_labyrinth_width*size_labyrinth_length/2)*100;
		// 誠 ண (  ?)
		if (visual || result)
		{
			if (!visual && !all_viewed)
				continue;
			show_labyrinth_in_progress(x, y, "neighbor_for_review=", neighbor_for_review, count, progress, size_labyrinth_length, size_labyrinth_width, labyrinth);
		}
	}
	
	//ࠥ 砩 ⥭ (᫨  ⪫祭 १ ࠬ)
	//᫨  ਭ      - ॡ㥬 ⢮ ⥭ 㤥   㦭 ⢮ 
	if (!no_walls_removing || holes)
	{
		int walls=0;
		int holes_count=0;
		if (!no_walls_removing)
		{
			//⢮ ⥭,  㭨⮦ - 1/10  ࠧ ਭ
			walls=size_labyrinth_width*size_labyrinth_length/10;
		}
		else
		{
			//᫨  ॡ 㭨⮦ ⥭ -  塞 㦭 ⢮  
			walls=holes;
		}
		if (holes)
			holes_count=holes; //稪  
		for (int i = 0; i < walls; i++)
		{
			int x_wall, y_wall;
			int is_wall=0;
			while (!is_wall)
			{
				x_wall=rand()%size_labyrinth_width;
				y_wall=rand()%size_labyrinth_length;
				//᫨ न 㪠뢠  ࠩ ⥭ - 室  ᫥饩 樨 横
				if (!x_wall || !y_wall || x_wall == size_labyrinth_width-1 || y_wall == size_labyrinth_length-1)
					continue;
				if (labyrinth[(x_wall*size_labyrinth_length)+y_wall] == WALL)
				{
					//᫨ 冷      ⪠ (室), , ⥭  
					//( ⨢ 砥    㯭 ,  ,  쭥襩 樨,
					//  ⭨/ᮡ)
					if (x_wall)
					{
						if (!labyrinth[(x_wall-1)*size_labyrinth_length+y_wall])
						{
							if (holes_count)
							{
								labyrinth[(x_wall*size_labyrinth_length)+y_wall]=HOLE;
								//न  뢠  ᨢ    न
								holes_array[i]=(x_wall*size_labyrinth_length+y_wall);
								is_wall=1;
								holes_count--;
								break;
							}
							labyrinth[(x_wall*size_labyrinth_length)+y_wall]=CELL;
							is_wall=1;
							break;
						}
					}
					if (y_wall)
					{
						if (!labyrinth[x_wall*size_labyrinth_length+(y_wall-1)])
						{
							if (holes_count)
							{
								labyrinth[(x_wall*size_labyrinth_length)+y_wall]=HOLE;
								//न  뢠  ᨢ    न
								holes_array[i]=(x_wall*size_labyrinth_length+y_wall);
								is_wall=1;
								holes_count--;
								break;
							}
							labyrinth[(x_wall*size_labyrinth_length)+y_wall]=CELL;
							is_wall=1;
							break;
						}
					}
					if (x_wall < size_labyrinth_width-1)
					{
						if (!labyrinth[(x_wall+1)*size_labyrinth_length+y_wall])
						{
							if (holes_count)
							{
								labyrinth[(x_wall*size_labyrinth_length)+y_wall]=HOLE;
								//न  뢠  ᨢ    न
								holes_array[i]=(x_wall*size_labyrinth_length+y_wall);
								is_wall=1;
								holes_count--;
								break;
							}
							labyrinth[(x_wall*size_labyrinth_length)+y_wall]=CELL;
							is_wall=1;
							break;
						}
					}
					if (y_wall < size_labyrinth_length-1)
					{
						if (!labyrinth[x_wall*size_labyrinth_length+(y_wall+1)])
						{
							if (holes_count)
							{
								labyrinth[(x_wall*size_labyrinth_length)+y_wall]=HOLE;
								//न  뢠  ᨢ    न
								holes_array[i]=(x_wall*size_labyrinth_length+y_wall);
								is_wall=1;
								holes_count--;
								break;
							}
							labyrinth[(x_wall*size_labyrinth_length)+y_wall]=CELL;
							is_wall=1;
							break;
						}
					}
					//labyrinth[(x_wall*size_labyrinth_length)+y_wall]=0;
					//is_wall=1;
				}
			}
			
			//뢮 ⫠  筮 १ - ᪥ ਭ (᫨  ⪫祭 १ ࠬ)
			//double progress_print=progress/(size_labyrinth_width*size_labyrinth_length/2)*100;
			// 誠 ண (  ?)
			if (visual)
			{
				show_labyrinth_in_progress(x_wall, y_wall, "walls=", walls, i+1, progress, size_labyrinth_length, size_labyrinth_width, labyrinth);
			}
		}
	}
	time_t end_generation=time(NULL); //६ 砭 樨 ।⢥ ਭ
	//printf("६   ᪥: %.2f ᥪ.\n", difftime(end_generation, start_generation));
	// MinGW
	double time_diff=end_generation-start_global_generation;
	printf("६   ᪥: %.2f ᥪ.\n", time_diff);
	// न ᮯ୨ ( ப)  室  ਭ
	//⪨  祭묨 न⠬     室    ࠩ ⥭ ਭ
	//( ਭ,  믠  ࠩ ⥭)
	time_t start_generation=time(NULL); //६ 砫 樨 ⭨
	short int *rivals_coordinates=(short int*)calloc(rivals*2+2, sizeof( short int )); //६ ᨢ न ⭨  室  ਭ
	if (rivals_coordinates == NULL)
		return 1;
	for (int i=0; i < rivals+1; i++) // न ⭨  室
	{
		time_t start_rival_generation=time(NULL); //६ 砫 樨 न । ⭨
		int wall, near_edge, distance;
		do
		{
			wall=0, near_edge=0, distance=1;
			x=rand()%(size_labyrinth_width-2)+1;
			y=rand()%(size_labyrinth_length-2)+1;
			if (labyrinth[x*size_labyrinth_length+y] != CELL)
				wall=1;
			if (x == 1 || x == size_labyrinth_width-2 || y == 1 || y == size_labyrinth_length-2)
				near_edge=1;
			//FIXME:  , ⪨  祭묨 न⠬  
			//   ஬ ﭨ  㣨 ᮯ୨   ᮡ⨩
			//(ਬ, ,  ,  祭  襩 ஭ ਭ,
			// , 祬  ஭ ਭ,   ஡  ⠬  㫠)
			if (!wall && near_edge)
			{
				//int max_distance, part_1, part_2, part_3;
				int max_distance;
				//~ max_distance=(size_labyrinth_length/2)+(size_labyrinth_width/2);
				if (size_labyrinth_length > size_labyrinth_width)
					//max_distance=size_labyrinth_length/2-2;
					max_distance=(size_labyrinth_length-2)/2;
				else
					//max_distance=size_labyrinth_width/2-2;
					max_distance=(size_labyrinth_width-2)/2;
				distance=check_in_neighbor_cells_border(x, y, max_distance, size_labyrinth_length, size_labyrinth_width, labyrinth, i);
			}
			//᫨ 諮  5 ᥪ. (?) - -   ⠪, 稪 for 뢠  砫 横,
			//६ ᨢ , ᭮ ᨢ ⠭  砫쭮 ﭨ
			//if (difftime(time(NULL), start_rival_generation) > 5)
			// MinGW
			if ((time(NULL)-start_rival_generation) > 5)
			{
				printf("%i: Resetted\n", i+1);
				for (int reset_count = 0; reset_count < rivals*2+2; reset_count=reset_count+2)
				{
					if (labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]] == RIVAL)
						labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]]=CELL;
				}
				memset(rivals_coordinates, 0, sizeof(*rivals_coordinates)*(rivals*2+2));
				i=-1;
				break;
			}
		} while (wall || !near_edge || !distance);
		//࠭ न  ᭮   ६ ᨢ (᫨  뫮 )
		if (i >= 0)
		{
			rivals_coordinates[i+i]=x; //0->0 1->2 2->4 3->6
			rivals_coordinates[i+i+1]=y; //0->1 1->3 2->5 3->7
			labyrinth[(x*size_labyrinth_length)+y]=RIVAL;
		}
		printf("%iF: %i %i\n", i+1, x, y);
		//᫨ 諮  20 ᥪ. (?)   砫 樨 ⭨ (  饩?) -
		//-   ⠪, ଠ쭠  ,
		//⠭ 祭  㬮砭 ( 㣫 ਭ)
		//室  ਭ ⠢ ।   ⥭  砩 浪;
		//᫨ ਭ   ਭ ࠧ -      ⥭, ⠪  砩 浪
		//FIXME: ⥪ ॠ  ࠡ⠥, ᫨ ⭨  4-
		//if (difftime(time(NULL), start_generation) > 20)
		// MinGW
		if ((time(NULL)-start_generation) > 20)
		{
			printf("%i: Breaked\n", i+1);
			//᫨  뫮  - ६ ᨢ , ᭮ ᨢ ⠭  砫쭮 ﭨ
			if (i >= 0)
			{
				for (int reset_count = 0; reset_count < rivals*2+2; reset_count=reset_count+2)
				{
					//if (labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]] != CELL || labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]] != WALL)
					if (labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]] == RIVAL)
					{
						labyrinth[rivals_coordinates[reset_count]*size_labyrinth_length+rivals_coordinates[reset_count+1]]=CELL;
					}
				}
				memset(rivals_coordinates, 0, sizeof(*rivals_coordinates)*(rivals*2+2));
			}
			//~ if (labyrinth[0])
			//~ {
				//~ if (!labyrinth[1])
					//~ labyrinth[1]=3;
				//~ else if (!labyrinth[size_labyrinth_length])
					//~ labyrinth[size_labyrinth_length]=3;
				//~ else if (!labyrinth[size_labyrinth_length+1])
					//~ labyrinth[size_labyrinth_length+1]=3;
				//~ else
					//~ printf("⭨ %i  ᯮ :-(\n", i/2+1);
			rivals_coordinates[0]=1;
			rivals_coordinates[1]=1;
			rivals_coordinates[2]=1;
			rivals_coordinates[3]=size_labyrinth_length-2;
			rivals_coordinates[4]=size_labyrinth_width-2;
			rivals_coordinates[5]=1;
			rivals_coordinates[6]=size_labyrinth_width-2;
			rivals_coordinates[7]=size_labyrinth_length-2;
			int wall_with_exit=0;
			if (size_labyrinth_length-size_labyrinth_width > 0)
			{
				do
				{
					wall_with_exit=rand()%3; // 0  2 - UP/DOWN
				} while (wall_with_exit%2);
			}
			else if (size_labyrinth_length-size_labyrinth_width < 0)
			{
				do
				{
					wall_with_exit=rand()%3+1; // 1  3 - RIGHT/LEFT
				} while (!(wall_with_exit%2));
			}
			else
				wall_with_exit=rand()%4;
			printf("wall_with_exit:%i\n", wall_with_exit);
			switch (wall_with_exit)
			{
				case UP:
					rivals_coordinates[8]=1;
					if (size_labyrinth_length%2)
					{
						rivals_coordinates[9]=(size_labyrinth_length-2)/2+1; // 樨  ⪠  
					}
					else
						rivals_coordinates[9]=(size_labyrinth_length-2)/2;
					break;
				case RIGHT:
					if (size_labyrinth_width%2)
					{
						rivals_coordinates[8]=(size_labyrinth_width-2)/2+1; // 樨  ⪠  
					}
					else
						rivals_coordinates[8]=(size_labyrinth_width-2)/2;
					rivals_coordinates[9]=size_labyrinth_length-2;
					break;
				case DOWN:
					rivals_coordinates[8]=size_labyrinth_width-2;
					if (size_labyrinth_length%2)
					{
						rivals_coordinates[9]=(size_labyrinth_length-2)/2+1; // 樨  ⪠  
					}
					else
						rivals_coordinates[9]=(size_labyrinth_length-2)/2;
					break;
				case LEFT:
					if (size_labyrinth_width%2)
					{
						rivals_coordinates[8]=(size_labyrinth_width-2)/2+1; // 樨  ⪠  
					}
					else
						rivals_coordinates[8]=(size_labyrinth_width-2)/2;
					rivals_coordinates[9]=1;
					break;
			}
			//FIXME:  ࠡ⠥, ᫨ ⭨  4-
			//~ ᫨ ⭨  4- - ﭥ न ⮬᪨ (ਬ୮ ।  ।騬 ⭨)
			//~ for (int rival_count=4; rival_count < rivals; rival_count++)
			//~ {
				//~ rivals_coordinates[rival_count*2]=rivals_coordinates[rival_count*2+1]
			for (int break_count=0; break_count < rivals*2+2; break_count=break_count+2)
			{
				//᫨  ⠭ न ⭨ ।⢥  㣫
				//(⪠ ) - ⠪  ந室
				//, ஢  ⠭  ᥤ ⪨ (+/-x, +/-y, +/-x+/-y)
				if (!labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+rivals_coordinates[break_count+1]])
				{
					labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+rivals_coordinates[break_count+1]]=RIVAL;
					continue;
				}
				int sign_x, sign_y;
				if (rivals_coordinates[break_count] == 1)
					sign_x=1;
				else
					sign_x=-1;
				if (rivals_coordinates[break_count+1] == 1)
					sign_y=1;
				else
					sign_y=-1;
				if (!labyrinth[(rivals_coordinates[break_count]+sign_x*1)*size_labyrinth_length+rivals_coordinates[break_count+1]])
				{
					rivals_coordinates[break_count]=rivals_coordinates[break_count]+sign_x*1;
					labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+rivals_coordinates[break_count+1]]=RIVAL;
				}
				else if (!labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+(rivals_coordinates[break_count+1]+sign_y*1)])
				{
					rivals_coordinates[break_count+1]=rivals_coordinates[break_count+1]+sign_y*1;
					labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+rivals_coordinates[break_count+1]]=RIVAL;
				}
				else if (!labyrinth[(rivals_coordinates[break_count]+sign_x*1)*size_labyrinth_length+(rivals_coordinates[break_count+1]+sign_y*1)])
				{
					rivals_coordinates[break_count]=rivals_coordinates[break_count]+sign_x*1;
					rivals_coordinates[break_count+1]=rivals_coordinates[break_count+1]+sign_y*1;
					labyrinth[rivals_coordinates[break_count]*size_labyrinth_length+rivals_coordinates[break_count+1]]=RIVAL;
				}
				else
					printf("⭨ %i  ᯮ :-(\n", break_count/2+1);
			}
			break;
		}
	}
	//।   ᮯ୨  ࠢ ப ( 砩 浪)
	//  ⨯  न ᮯ୨,  ⠪ ⠫   ᨢ 
	int player_number=rand()%rivals;
	//int player_number=0; //   ᭮ -  ࠢ ᮯ୨ ᯮ  ਭ  砩 浪
	//( ⠭  㬮砭 ப ᥣ 㤥    ⮬   - 頥 砩 ࠯। ஫)
	// ᫥饩 筮 ᬥ   ᨢ (  न⠬  ᬥ ⨯   )
	for (int i = 0; i < rivals; i++)
	{
		count=0;
		player[i].x=rivals_coordinates[i+i];
		player[i].y=rivals_coordinates[i+i+1];
		player[i].previous_cell_state=0;
		player[i].has_treasure=0;
		player[i].has_fake_treasure=0;
		player[i].has_weapon=0;
		player[i].is_wounded=0;
		player[i].in_hole=0;
		player[i].in_trap=0;
		player[i].trap_start=0;
		player[i].step_start=0;
		if (player_number == i)
		{
			player[i].type=1;
			//७ᥭ , ᫥  न⠬  player[0]
			//labyrinth[(rivals_coordinates[i+i]*size_labyrinth_length+rivals_coordinates[i+i+1])]=PLAYER;
		}
		else
			player[i].type=0;
		//।,   ஭ ᬮ ⭨ (0 - , 1 - ࠢ, 2 - , 3 - )
		//᫨ ⭨ 室  㣫 -    ࠢ 롨ࠥ 砩
		//뢠 ⠪  ᤢ   न  祭  㬮砭  ॢ襭  ६  
		if ((((rivals_coordinates[i+i] == 1) || (rivals_coordinates[i+i] == size_labyrinth_width-2)) && ((rivals_coordinates[i+i+1] == 1) || (rivals_coordinates[i+i+1] == size_labyrinth_length-2))) \
		|| (((rivals_coordinates[i+i] == 2) || (rivals_coordinates[i+i] == size_labyrinth_width-3)) && ((rivals_coordinates[i+i+1] == 2) || (rivals_coordinates[i+i+1] == size_labyrinth_length-3))))
		{
			count=rand()%2;
		}
		if (rivals_coordinates[i+i] == 1 || rivals_coordinates[i+i] == 2)
		{
			if (!count)
			{
				player[i].direction=DOWN;
				count=count+2;
			}
			count--;
		}
		if (rivals_coordinates[i+i] == size_labyrinth_width-2 || rivals_coordinates[i+i] == size_labyrinth_width-3)
		{
			if (!count)
			{
				player[i].direction=UP;
				count=count+2;
			}
			count--;
		}
		if (rivals_coordinates[i+i+1] == 1 || rivals_coordinates[i+i+1] == 2)
		{
			if (!count)
			{
				player[i].direction=RIGHT;
				count=count+2;
			}
			count--;
		}
		if (rivals_coordinates[i+i+1] == size_labyrinth_length-2 || rivals_coordinates[i+i+1] == size_labyrinth_length-3)
		{
			if (!count)
			{
				player[i].direction=LEFT;
				count=count+2;
			}
			count--;
		}
	}
	//童  ப  ᨢ  ⭨
	// ᢠ     ᨢ ६ No
	if (!player[0].type) //᫨ ப 㦥     ᨢ -  ய᪠
	{
		int No=0;
		for (int i = 0; i < rivals; i++)
		{
			if (player[i].type)
			{
				No = i;
				break;
			}
		}
		int temp_x;
		int temp_y;
		int temp_direction;
		temp_x=player[0].x;
		temp_y=player[0].y;
		temp_direction=player[0].direction;
		player[0].type=1;
		player[0].x=player[No].x;
		player[0].y=player[No].y;
		player[0].direction=player[No].direction;
		player[No].type=0;
		player[No].x=temp_x;
		player[No].y=temp_y;
		player[No].direction=temp_direction;
	}
	labyrinth[player[0].x*size_labyrinth_length+player[0].y]=PLAYER;
	//⠭ 祭 ᫥ 樨  ᮡ⨥ "室"
	//( ⮬  ᤢ  砥  न  祭  㬮砭  ॢ襭  ६  )
	//᫨ 窠 室 室  㣫 -   ࠢ 롨ࠥ 砩
	count=0;
	if ((((rivals_coordinates[rivals*2] == 1) || (rivals_coordinates[rivals*2] == size_labyrinth_width-2)) \
	&& ((rivals_coordinates[rivals*2+1] == 1) || (rivals_coordinates[rivals*2+1] == size_labyrinth_length-2))) \
	\
	|| (((rivals_coordinates[rivals*2] == 2) || (rivals_coordinates[rivals*2] == size_labyrinth_width-3)) \
	&& ((rivals_coordinates[rivals*2+1] == 2) || (rivals_coordinates[rivals*2+1] == size_labyrinth_length-3))))
	{
		count=rand()%2;
	}
	if (rivals_coordinates[rivals*2] == 1 || rivals_coordinates[rivals*2] == 2)
	{
		//   㦥 ᤢ
		if (labyrinth[(rivals_coordinates[rivals*2]-1)*size_labyrinth_length+rivals_coordinates[rivals*2+1]] == CELL)
			count++;
		if (!count)
		{
			for (int i = 0; i < rivals_coordinates[rivals*2]; )
			{
				labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=CELL;
				rivals_coordinates[rivals*2]--;
			}
			labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=EXIT;
			count=count+2;
		}
		count--;
	}
	if (rivals_coordinates[rivals*2] == size_labyrinth_width-2 || rivals_coordinates[rivals*2] == size_labyrinth_width-3)
	{
		//   㦥 ᤢ
		if (labyrinth[(rivals_coordinates[rivals*2]+1)*size_labyrinth_length+rivals_coordinates[rivals*2+1]] == CELL)
			count++;
		if (!count)
		{
			for (int i = 0; i < (size_labyrinth_width-1)-rivals_coordinates[rivals*2]; )
			{
				labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=CELL;
				rivals_coordinates[rivals*2]++;
			}
			labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=EXIT;
			count=count+2;
		}
		count--;
	}
	if (rivals_coordinates[rivals*2+1] == 1 || rivals_coordinates[rivals*2+1] == 3)
	{
		//   㦥 ᤢ
		if (labyrinth[(rivals_coordinates[rivals*2])*size_labyrinth_length+(rivals_coordinates[rivals*2+1]-1)] == CELL)
			count++;
		if (!count)
		{
			for (int i = 0; i < rivals_coordinates[rivals*2+1]; )
			{
				labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=CELL;
				rivals_coordinates[rivals*2+1]--;
			}
			labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=EXIT;
			count=count+2;
		}
		count--;
	}
	if (rivals_coordinates[rivals*2+1] == size_labyrinth_length-2 || rivals_coordinates[rivals*2+1] == size_labyrinth_length-3)
	{
		//   㦥 ᤢ
		if (labyrinth[(rivals_coordinates[rivals*2])*size_labyrinth_length+(rivals_coordinates[rivals*2+1]+1)] == CELL)
			count++;
		if (!count)
		{
			for (int i = 0; i < (size_labyrinth_length-1)-rivals_coordinates[rivals*2+1]; )
			{
				labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=CELL;
				rivals_coordinates[rivals*2+1]++;
			}
			labyrinth[rivals_coordinates[rivals*2]*size_labyrinth_length+rivals_coordinates[rivals*2+1]]=EXIT;
			count=count+2;
		}
		count--;
	}
	//~ int player=rand()%rivals;
	//~ count=0;
	//~ for (int i=0; i < size_labyrinth_length*size_labyrinth_width; i++)
	//~ {
		//~ if (labyrinth[i] == 3)
		//~ {
			//~ if (count == player)
			//~ {
				//~ labyrinth[i]=4;
				//~ break;
			//~ }
			//~ count++;
		//~ }
	//~ }
	memset(rivals_coordinates, 0, sizeof(*rivals_coordinates)*(rivals*2+2));
	free(rivals_coordinates);
	rivals_coordinates=NULL;
	end_generation=time(NULL); //६ 砭 樨
	//printf("६  : %.2f ᥪ.\n", difftime(end_generation, start_generation));
	// MinGW
	time_diff=end_generation-start_generation;
	printf("६   ⭨: %.2f ᥪ.\n", time_diff);
	char *dir[]={"", "ࠢ", "", ""};
	for (int i=0; i < rivals; i++)
	{
		printf("Player %i: type=%i, x=%i, y=%i, direction=%s\n", i, player[i].type, player[i].x, player[i].y, dir[player[i].direction]);
	}
	puts("");
	// ⠫ ᮡ⨩ ਭ
	// 㬮砭 ᮡ ᯮ  ⤠    ⪨  ⠫ ᮡ⨩  ⭨,
	//஬ ᮡ  (TREASURE), ஥ ᯮ  ⤠    ⮪  ᥣ ⠫쭮,
	// ⮬  ᫥ ( ,   ᫥  ࢮ ᫥ ᮡ EXIT)
	//᫨ ࠧ ਭ  - ஭   ࠢ 10 ⪠ (  譨 ⥭) -  ࠢ 㬥  
	// ਭ⮢ ࠧ஬  100x100 ࠢ ᯮ, ᮮ⢥⢥, 㢥稢  
	//(2 ⪨    ᮡ⨩  3 -  ᮡ )
	
	//६ ᨢ न ᮡ⨩ ਭ (x, y, 室 祭 祩  砩, ᫨ ந  樨)
	short int *events_coordinates=(short int*)calloc((END_OF_CT_ENUM-EXIT-1)*3, sizeof( short int ));
	if (events_coordinates == NULL)
		return 1;
	int empty_cell;
	int distance=1;
	for (int i = END_OF_CT_ENUM-EXIT-2; i >= 0; i--)
	{
		if (i+EXIT+1 == HOLE)
			continue; //FIXME: ᪠ 㣮 ᯮᮡ ᪫  (  ࠭,  㭨⮦ ⥭)
		printf("⨥ %i\n", i+EXIT+1);
		start_generation=time(NULL);
		do
		{
			empty_cell=1;
			//TREASURE     饬, ⠪   樠 ६ 㡨 ஢ન
			// ஢ઠ  ࠧ ਭ   ४樨 ந  横,   ᭠㦨
			int depth=1;
			if (size_labyrinth_length-2 <= 10 || size_labyrinth_width-2 <= 10)
				depth=0;
			if (size_labyrinth_length-2 > 100 || size_labyrinth_width-2 > 100)
				depth=2;
			//if (!i) // ᫮,  TREASURE  ࠧ  EXIT
			if (i == TREASURE-EXIT-1)
				depth++;
			x=rand()%(size_labyrinth_width-2)+1;
			y=rand()%(size_labyrinth_length-2)+1;
			printf("x=%i y=%i\n", x, y);
			if (labyrinth[x*size_labyrinth_length+y] != CELL && labyrinth[x*size_labyrinth_length+y] != WALL)
				empty_cell=0;
			if (empty_cell)
			{
				// ஢ન ᪫  祩  ⥭
				cell_types[CELL]=1;
				cell_types[WALL]=1;
				distance=check_in_neighbor_cells_around(x, y, 255, depth, cell_types, size_labyrinth_length, size_labyrinth_width, labyrinth);
			}
			// 砥, ᫨  㤠  ࠧ㬭 ६ ᣥ஢ ᮡ⨥ (10 ᥪ.   砥) -
			//ந , ᭮ ᨢ 頥  室 ﭨ
			//,  ⠭, ।    ࢮ न ("x") 祭, ⫨筮  "0",
			//ண      祣, ஬ ࠩ ⥭  室
			if (time(NULL)-start_generation > 10)
			{
				printf("⨥ %i  ⠭ (x=%i y=%i)\n", i+EXIT+1, x, y);
				puts("⪠  ⮩ ⠭");
				system("sleep 1");
				for (int break_count = 0; break_count < (END_OF_CT_ENUM-EXIT-1)*3; break_count=break_count+3)
				{
					if (events_coordinates[break_count] > 0)
					{
						labyrinth[events_coordinates[break_count]*size_labyrinth_length+events_coordinates[break_count+1]]=events_coordinates[break_count+2];
					}
				}
				memset(events_coordinates, 0, sizeof(*events_coordinates)*((END_OF_CT_ENUM-EXIT-1)*3));
				i=-1;
				break;
			}
		} while (!empty_cell || !distance);
		if (i >= 0)
		{
			events_coordinates[i*3]=x;   									//0->0 1->3 2->6 3->9  4->12 5->15
			events_coordinates[i*3+1]=y; 									//0->1 1->4 2->7 3->10 4->13 5->16
			events_coordinates[i*3+2]=labyrinth[x*size_labyrinth_length+y]; //0->2 1->5 2->8 3->11 4->14 5->17
			labyrinth[x*size_labyrinth_length+y]=i+EXIT+1;
		}
	}
	//᫨ ᨢ  न⠬ ᮡ⨩  -  , ᮡ  ᯮ  ।।񭭮 浪
	//  䠪஬ 砩
	if (!events_coordinates[0])
	{
		//TREASURE
		if (size_labyrinth_width%2)
		{
			events_coordinates[0]=(size_labyrinth_width-2)/2+1;
		}
		else
			events_coordinates[0]=(size_labyrinth_width-2)/2;
		if (size_labyrinth_length%2)
		{
			events_coordinates[1]=(size_labyrinth_length-2)/2+1;
		}
		else
			events_coordinates[1]=(size_labyrinth_length-2)/2;
		events_coordinates[2]=TREASURE;
		//।,   ஭ 㤥 ந 쭥 ⠭
		//( ᮢ ५: 0 - , 1 - ࠢ, 2 - , 3 - )
		int event_gen_way=rand()%4;
		printf("ࠢ 樨: %i\n", event_gen_way);
		switch (event_gen_way)
		{
			case UP:
				//FAKE_TREASURE
				events_coordinates[3]=events_coordinates[0]/2;
				events_coordinates[4]=events_coordinates[1];
				//  ࠭,  ⠯ 㭨⮦ ⥭
				//⠢  ४⭮  न
				//HOLE
				//TODO: ᨢ 
				events_coordinates[6]=events_coordinates[3]+1;
				events_coordinates[7]=events_coordinates[4]/2;
				//TRAP
				//TODO: ᪮쪮 襪,  ᨬ  ࠧ ਭ
				events_coordinates[9]=(size_labyrinth_width-1)-events_coordinates[6];
				events_coordinates[10]=events_coordinates[7]+1;
				//HOSPITAL
				events_coordinates[12]=events_coordinates[9]+1;
				events_coordinates[13]=(size_labyrinth_length-1)-events_coordinates[10];
				//ARSENAL
				events_coordinates[15]=events_coordinates[12]/2;
				if (events_coordinates[15]+1 != events_coordinates[0])
					events_coordinates[15]++;
				events_coordinates[16]=events_coordinates[13];
				break;
			case RIGHT:
				//FAKE_TREASURE
				events_coordinates[3]=events_coordinates[0];
				events_coordinates[4]=(size_labyrinth_length-1)-events_coordinates[1]/2;
				//  ࠭,  ⠯ 㭨⮦ ⥭
				//⠢  ४⭮  न
				//HOLE
				//TODO: ᨢ 
				events_coordinates[6]=events_coordinates[3]/2;
				events_coordinates[7]=events_coordinates[4]-1;
				//TRAP
				//TODO: ᪮쪮 襪,  ᨬ  ࠧ ਭ
				events_coordinates[9]=events_coordinates[6]+1;
				events_coordinates[10]=events_coordinates[7]/2;
				//HOSPITAL
				events_coordinates[12]=(size_labyrinth_width-1)-events_coordinates[9];
				events_coordinates[13]=events_coordinates[10]-1;
				//ARSENAL
				events_coordinates[15]=events_coordinates[12];
				events_coordinates[16]=(size_labyrinth_length-1)-events_coordinates[13];
				if (events_coordinates[16]-1 != events_coordinates[1])
					events_coordinates[16]--;
				break;
			case DOWN:
				//FAKE_TREASURE
				events_coordinates[3]=(size_labyrinth_width-1)-events_coordinates[0]/2;
				events_coordinates[4]=events_coordinates[1];
				//  ࠭,  ⠯ 㭨⮦ ⥭
				//⠢  ४⭮  न
				//HOLE
				//TODO: ᨢ 
				events_coordinates[6]=events_coordinates[3]-1;
				events_coordinates[7]=(size_labyrinth_length-1)-events_coordinates[4]/2;
				//TRAP
				//TODO: ᪮쪮 襪,  ᨬ  ࠧ ਭ
				events_coordinates[9]=events_coordinates[6]/2;
				events_coordinates[10]=events_coordinates[7]-1;
				//HOSPITAL
				events_coordinates[12]=events_coordinates[9]-1;
				events_coordinates[13]=events_coordinates[10]/2;
				//ARSENAL
				events_coordinates[15]=(size_labyrinth_width-1)-events_coordinates[12];
				if (events_coordinates[15]-1 != events_coordinates[0])
					events_coordinates[15]--;
				events_coordinates[16]=events_coordinates[13];
				break;
			case LEFT:
				//FAKE_TREASURE
				events_coordinates[3]=events_coordinates[0];
				events_coordinates[4]=events_coordinates[1]/2;
				//  ࠭,  ⠯ 㭨⮦ ⥭
				//⠢  ४⭮  न
				//HOLE
				//TODO: ᨢ 
				events_coordinates[6]=(size_labyrinth_width-1)-events_coordinates[3]/2;
				events_coordinates[7]=events_coordinates[4]+1;
				//TRAP
				//TODO: ᪮쪮 襪,  ᨬ  ࠧ ਭ
				events_coordinates[9]=events_coordinates[6]-1;
				events_coordinates[10]=(size_labyrinth_length-1)-events_coordinates[7];
				//HOSPITAL
				events_coordinates[12]=events_coordinates[9]/2;
				events_coordinates[13]=events_coordinates[10]+1;
				//ARSENAL
				events_coordinates[15]=events_coordinates[12];
				events_coordinates[16]=events_coordinates[13]/2;
				if (events_coordinates[16]+1 != events_coordinates[1])
					events_coordinates[16]++;
				break;
		}
		events_coordinates[5]=FAKE_TREASURE;
		//  ࠭,  ⠯ 㭨⮦ ⥭
		//⠢  ४⭮  न
		events_coordinates[8]=HOLE;
		events_coordinates[11]=TRAP;
		events_coordinates[14]=HOSPITAL;
		events_coordinates[17]=ARSENAL;
		//᫨  ⠭ ᮡ⨥ ।⢥  ᫥  - ⠪  ந室;
		//, ஢  ⠭  ᥤ ⪨ (+/-x, +/-y -  砩 浪)
		for (int i = 0; i < (END_OF_CT_ENUM-EXIT-1)*3; i=i+3)
		{
			if (events_coordinates[i+2] == HOLE)
				continue; //FIXME: ᪠ 㣮 ᯮᮡ ᪫  (  ࠭,  㭨⮦ ⥭)
			printf("⨥ %i  ⠭: x=%i y=%i\n", events_coordinates[i+2], events_coordinates[i], events_coordinates[i+1]);
			if (labyrinth[(events_coordinates[i]*size_labyrinth_length)+events_coordinates[i+1]] == WALL || labyrinth[(events_coordinates[i]*size_labyrinth_length)+events_coordinates[i+1]] == CELL)
			{
				labyrinth[(events_coordinates[i]*size_labyrinth_length)+events_coordinates[i+1]]=events_coordinates[i+2];
				printf("⨥ %i ᫥ ⠭: x=%i y=%i\n", events_coordinates[i+2], events_coordinates[i], events_coordinates[i+1]);
				continue;
			}
			int sign=rand()%2;
			if (!sign)
				sign=-1;
			if (events_coordinates[i] == 1 || events_coordinates[i] == size_labyrinth_width-2)
			{
				if (labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]+sign*1)] == WALL || labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]+sign*1)] == CELL)
				{
					labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]+sign*1)]=events_coordinates[i+2];
				}
				else if (labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]-sign*1)] == WALL || labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]-sign*1)] == CELL)
				{
					labyrinth[(events_coordinates[i]*size_labyrinth_length)+(events_coordinates[i+1]-sign*1)]=events_coordinates[i+2];
				}
				else
					printf("⨥ %i  ⠭ (x=%i y=%i)\n", events_coordinates[i+2], events_coordinates[i], events_coordinates[i+1]);
			}
			if (events_coordinates[i+1] == 1 || events_coordinates[i+1] == size_labyrinth_length-2)
			{
				if (labyrinth[(events_coordinates[i]+sign*1)*size_labyrinth_length+events_coordinates[i+1]] == WALL || labyrinth[(events_coordinates[i]+sign*1)*size_labyrinth_length+events_coordinates[i+1]] == CELL)
				{
					labyrinth[(events_coordinates[i]+sign*1)*size_labyrinth_length+events_coordinates[i+1]]=events_coordinates[i+2];
				}
				else if (labyrinth[(events_coordinates[i]-sign*1)*size_labyrinth_length+events_coordinates[i+1]] == WALL || labyrinth[(events_coordinates[i]-sign*1)*size_labyrinth_length+events_coordinates[i+1]] == CELL)
				{
					labyrinth[(events_coordinates[i]-sign*1)*size_labyrinth_length+events_coordinates[i+1]]=events_coordinates[i+2];
				}
				else
					printf("⨥ %i  ⠭ (x=%i y=%i)\n", events_coordinates[i+2], events_coordinates[i], events_coordinates[i+1]);
			}
			printf("⨥ %i ᫥ ⠭: x=%i y=%i\n", events_coordinates[i+2], events_coordinates[i], events_coordinates[i+1]);
		}
	}
	
	time_diff=(time(NULL)-start_generation);
	printf("६   ᮡ⨩: %.2f ᥪ.\n", time_diff);
	//TODO: 뭥  ⤥ 㭪,  ࠡ⪨ ⭮ 襭 ࠡ ( return 1)
	memset(cell_types, 0, sizeof((*cell_types)*END_OF_CT_ENUM));
	memset(events_coordinates, 0, sizeof(*events_coordinates)*((END_OF_CT_ENUM-EXIT-1)*3));
	free(cell_types);
	free(events_coordinates);
	cell_types=NULL;
	events_coordinates=NULL;
	
	//printf("६  : %.2f ᥪ.\n", end_generation-start_generation);
	//뢮 ⫠  筮 १ - ᪥ ਭ (᫨  ⪫祭 १ ࠬ)
	if (result)
		show_labyrinth_in_progress(0, 0, "Finish!", 0, 0, 100, size_labyrinth_length, size_labyrinth_width, labyrinth);
	time_diff=time(NULL)-start_global_generation;
	printf("饥 ६ 樨: %.2f ᥪ.\n", time_diff);
	return 0;
}

void show_labyrinth_in_progress(int x, int y, char *info_string, int info, int count, int progress, short int length, short int width, const int *labyrinth_temp)
{
	double progress_print=width*length/2;
	progress_print=progress/progress_print;
	progress_print=progress_print*100;
	for (int j = 0; j < width; j++)
	//for (int j = -1; j <= width; j++)
	{
		//~ if (j == -1 || j == (width))
		//~ {
			//~ for (int j_walls = 0; j_walls < (length+2); j_walls++)
			//~ {
				//~ printf("%s", " X");
			//~ }
			//~ puts("");
			//~ continue;
		//~ }
		for (int k = 0; k < length; k++)
		{
			//~ if (k == 0)
				//~ printf("%s", " X");
			//0 -  ⪠, 1 - ⥭, 2 -   ⪠, 3 -   ᮯ୨, 4 - ப, 5 - 室
			//6 - , 7 -  , 8 - , 9 - 誠, 10 - ᯨ⠫, 11 - ᥭ
			if (!labyrinth_temp[(j*length)+k])
				printf("%s", "  ");
			if (labyrinth_temp[(j*length)+k] == WALL)
				printf("%s", " X");
			if (labyrinth_temp[(j*length)+k] == DUMMY)
				printf("%s", " .");
			if (labyrinth_temp[(j*length)+k] == RIVAL)
				printf("%s", " p");
			if (labyrinth_temp[(j*length)+k] == PLAYER)
				printf("%s", " g");
			if (labyrinth_temp[(j*length)+k] == EXIT)
				printf("%s", " e");
			if (labyrinth_temp[(j*length)+k] == TREASURE)
				printf("%s", " T");
			if (labyrinth_temp[(j*length)+k] == FAKE_TREASURE)
				printf("%s", " F");
			if (labyrinth_temp[(j*length)+k] == HOLE)
				printf("%s", " O");
			if (labyrinth_temp[(j*length)+k] == TRAP)
				printf("%s", " #");
			if (labyrinth_temp[(j*length)+k] == HOSPITAL)
				printf("%s", " H");
			if (labyrinth_temp[(j*length)+k] == ARSENAL)
				printf("%s", " A");
			//~ if (k == (length-1))
				//~ printf("%s", " X");
		}
		if (j == 0)
			printf("  %s%i %s%i", "x=", x, "y=", y);
		if (j == 1)
			printf("  %s%i", info_string, info);
		if (j == 2)
			printf("  %s%i %s%.2f%%", "count=", count, "progress=", progress_print);
		printf("%s", "\n");
	}
	printf("%s", "\n");
	system("sleep 1");
	return;
}
