/*  labyrinth_main.c

  ਭ
  Version 0.3.1

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "includes_macros.h"

void help(char *program_title, int help_size);
int change_settings_file(struct options_array *options_arrayPtr, FILE *settings, char *settings_filename);

int set_options(FILE *settings, char *settings_filename, short int *window_height, short int *window_width, short int *fullscreen, short int *refresh_rate, short int *fps, short int *hw_accel, short int *vsync, short int *sdl_12, short int *size_labyrinth_length, short int *size_labyrinth_width, short int *no_walls_removing, short int *rivals, short int *holes, short int *trap_time, short int *hole_time, short int *speed, short int *turn_speed, short int *debug, short int *visual, short int *result);

int parameters(char *args[], int count, short int *window_height, short int *window_width, short int *fullscreen, short int *refresh_rate, short int *fps, short int *hw_accel, short int *vsync, short int *sdl_12, short int *size_labyrinth_length, short int *size_labyrinth_width, short int *no_walls_removing, short int *rivals, short int *holes, short int *trap_time, short int *hole_time, short int *speed, short int *turn_speed, short int *debug, short int *visual, short int *result);

int labyrinth_generation(int *labyrinth, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const visual, short int const no_walls_removing, short int const result, short int const rivals, short int const holes, short int *holes_array, struct players player[]);

void clean_up(int *labyrinth, short int const size_labyrinth_width, short int const size_labyrinth_length, short int *holes_array, short int const holes, char *settings_filename);

int sdl_main(int *labyrinth, struct players player[], short int const rivals, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, short int window_height, short int window_width, short int fullscreen, short int refresh_rate, short int fps, short int trap_time, short int hole_time, short int speed, short int turn_speed, short int const debug, FILE *settings, char const *settings_filename);
//~ int sdl_main(int *labyrinth, struct players player[], short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array);

int sdl_main_hwsw(int *labyrinth, struct players player[], short int const rivals, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, short int window_height, short int window_width, short int fullscreen, short int refresh_rate, short int fps, short int hw_accel, short int vsync, short int trap_time, short int hole_time, short int speed, short int turn_speed, short int const debug, FILE *settings, char const *settings_filename);
//~ int sdl_main_hwsw(int *labyrinth, struct players player[], short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, int requested_mode);

int main(int argc, char *argv[])
{
	//஢ઠ   맮 ࠢ, ᫨ 襭 - 맮 ࠢ筮 ଠ樨  室  ணࠬ
	if (argc > 1)
	{
		for (int i = 1; i < argc; i++)
		{
			if (!strcmp("-h", argv[i]) || !strcmp("--help", argv[i]))
			{
				char *program_title=argv[0];
				help(program_title, strlen(argv[i]));
				return 0;
			}
		}
	}
	
	//樠 ᭮ ६
	//祭  㬮砭 -  䠩 includes_macros.h
	//祭   १ ࠬ ᪠  䠩 ஥ ( 㬮砭 "settings.ini"  ⠫  ணࠬ)
	//VIDEO
	// ࠬ (ᮡ refresh_rate) ᪮॥ ᥣ,  १ᠭ
	//᫥ 㧪 䠩 ஥ / 樠樨 SDL
	short int window_height=DEFAULT_RES_Y; //, ⮨   int    ࠧ襭
	short int window_width=DEFAULT_RES_X; //, ⮨   int    ࠧ襭
	short int fullscreen=0;
	short int refresh_rate=0;
	short int fps=FPS; //࣠祭  ⢮ ࠡ뢠 SDL ஢  ᥪ㭤
	short int hw_accel=1; //⮫쪮  SDL2
	short int vsync=1; //⮫쪮  SDL2
	short int sdl_12=0; //⮫쪮  SDL1.2
	//GAME
	short int size_labyrinth_length=DEFAULT_LENGTH+2; // -   ன+ 祩  ࠩ ⥭
	//~ if (size_labyrinth_length%2 == 0)
	//~ {
		//~ size_labyrinth_length=size_labyrinth_length-1; //᫨  ⭮ ᫮ - 㡨ࠥ 㡫 ஭ (⥭)
	//~ }
	short int size_labyrinth_width=DEFAULT_WIDTH+2; //ਭ -   ன+ 祩  ࠩ ⥭
	//~ if (size_labyrinth_width%2 == 0)
	//~ {
		//~ size_labyrinth_width=size_labyrinth_width-1; //᫨  ⭮ ᫮ - 㡨ࠥ 㡫 ஭ (⥭)
	//~ }
	short int no_walls_removing=0; // 㡨 砩 ⥭  ਭ ( 㬮砭 -  (㡨))
	short int rivals=RIVALS; //⢮ ᮯ୨  ਭ ( ப!)
	short int holes=HOLES; //⢮   ਭ
	short int trap_time=TIME_IN_TRAP; //६, ஢񭭮  誥 ( ᥪ㭤)
	short int hole_time=TIME_BETWEEN_HOLES; //६, ॡ㥬  ६饭  ࠬ ( ᥪ㭤)
	short int speed=SPEED_MOVE; //६  ᥪ㭤, ॡ㥬  ᮢ襭  蠣 (த  1 祩)
	short int turn_speed=SPEED_TURN; //६  ᥪ㭤, ॡ㥬  
	//DEBUG
	short int debug=0; //⮡ࠦ ਭ  ᮫/ନ  ६ 
	short int visual=0; // ⫠ - 뢮 ᪥ ਭ ( 㬮砭 - )  
	short int result=0; //⮡ࠦ ⥫ १   ( 㬮砭 - )
	
	//뢠 ࠬ஢  䠩 ஥
	//砫 ந ஢ઠ  ⢨ । ࠬ஢ ᪠
	//  ᮧ/ᯮ짮 㣮 䠩  ன
	// १ 饣 祭ﬨ  㬮砭
	FILE *settings=NULL;
	char *settings_filename=NULL;
	if (argc > 1)
	{
		for (int i = 1; i < argc; i++)
		{
			if (!strcmp("--conf", argv[i]) || !strcmp("-c", argv[i]))
			{
				if ((i+1) < argc)
				{
					if (!(settings = fopen(argv[i+1], "r")))
					{
						perror("   䠩 ஥,  짮⥫");
						printf("㤥 ᯮ짮 䠩  㬮砭 (\"%s\")\n", DEFAULT_SETTINGS_FILE);
					}
					else
					{
						int filename_length=strlen(argv[i+1]);
						settings_filename=calloc(filename_length+1, 1);
						snprintf(settings_filename, filename_length+1, "%s", argv[i+1]);
					}
				}
				else
				{
					puts(" 㪠 䠩 ஥!");
					printf("㤥 ᯮ짮 䠩  㬮砭 (\"%s\")\n", DEFAULT_SETTINGS_FILE);
				}
			}
			//᫨ ॡ ᮧ  䠩 ஥ -  ᯮ짮   , 㪠 짮⥫
			//᫨  ᨬ  / 㤥 "-" -  㤥    ࠬ஢ ᪠  ந஢
			//(㤥 ᯮ짮 䠩  㬮砭)
			if (!strcmp("--new-conf", argv[i]) || !strcmp("-N", argv[i]))
			{
				if (((i+1) < argc) && strncmp("-", argv[i+1], 1))
				{
					int filename_length=strlen(argv[i+1]);
					settings_filename=calloc(filename_length+1, 1);
					snprintf(settings_filename, filename_length+1, "%s", argv[i+1]);
					printf("  䠩 ஥ \"%s\"...\n", settings_filename);
					if (change_settings_file(NULL, settings, settings_filename))
					{
						printf("㤥 ᯮ짮 䠩  㬮砭 (\"%s\")\n", DEFAULT_SETTINGS_FILE);
						free(settings_filename);
						settings_filename=NULL;
					}
				}
				//᫨  㪠  䠩  ᮧ ஥ - 㤥 १ᠭ 騩 䠩
				//TODO: ᯥ १ࢭ ஢  ⠪ 砥
				else
				{
					settings_filename=calloc(strlen(DEFAULT_SETTINGS_FILE)+1, 1);
					snprintf(settings_filename, strlen(DEFAULT_SETTINGS_FILE)+1, "%s", DEFAULT_SETTINGS_FILE);
					puts(" 㪠 䠩 ஥!");
					printf("㤥 १ᠭ 䠩  㬮砭 (\"%s\")\n", settings_filename);
					if (change_settings_file(NULL, settings, settings_filename))
						return 1;
				}
			}
		}
	}
	if (!settings_filename)
	{
		settings_filename=calloc(strlen(DEFAULT_SETTINGS_FILE)+1, 1);
		snprintf(settings_filename, strlen(DEFAULT_SETTINGS_FILE)+1, "%s", DEFAULT_SETTINGS_FILE);
	}
	//᫥ ந 뢠 䠩 ஥ ("settings.ini"   १ ࠬ ᪠)
	short int success;
	success=set_options(settings, settings_filename, &window_height, &window_width, &fullscreen, &refresh_rate, &fps, &hw_accel, &vsync, &sdl_12, &size_labyrinth_length, &size_labyrinth_width, &no_walls_removing, &rivals, &holes, &trap_time, &hole_time, &speed, &turn_speed, &debug, &visual, &result);
	//ࠡ⪠ 訡 ⥭ 䠫 ஥ 訡 
	if (success == 1 || success == 2)
		return success;
	//ᬮ ࠬ஢ ᪠, ᫨  
	// 砥  ᪫ ࠬ஢   㡫஢
	//㤥  ᫥ 㪠 ࠬ/᫥ 祭
	if (argc > 1)
	{
		if (parameters(argv, argc, &window_height, &window_width, &fullscreen, &refresh_rate, &fps, &hw_accel, &vsync, &sdl_12, &size_labyrinth_length, &size_labyrinth_width, &no_walls_removing, &rivals, &holes, &trap_time, &hole_time, &speed, &turn_speed, &debug, &visual, &result))
			return 0;
	}
	//樠 ᨢ ਭ
	//FIXME: , ७  labyrinth_generation?
	int *labyrinth=(int*)calloc((size_labyrinth_width*size_labyrinth_length), sizeof( int ));
	if (labyrinth == NULL)
	{
		puts("筮 ᢮   樠樨 ਭ");
		return 1;
	}
	struct players player[rivals]; //ᨢ   ⨯, न⠬  . . ᮯ୨ ( ப)
	//樠 ᨢ  (᫨ ॡ)
	//if (holes)
	//{
		short int *holes_array=(short int*)calloc(holes, sizeof( short int ));
		if (holes_array == NULL)
		{
			holes=0;
			puts("筮 ᢮   樠樨 ᨢ ");
		}
	//}
	if (labyrinth_generation(labyrinth, size_labyrinth_length, size_labyrinth_width, visual, no_walls_removing, result, rivals, holes, holes_array, player))
	{
		puts("筮 ᢮   樨 ਭ");
		return 1;
	}
	
	// ⫠ ⭮ ᪮७
	//TODO:   ࠬ ᪠
	//   १ 䠩 ஥
	//~ int mode=0;
	//~ if (argc > 1)
	//~ {
		//~ if ((argv[1]) && (!strcmp("-sw", argv[1])))
		//~ {
			//~ mode=1;
		//~ }
		//~ if ((argv[1]) && (!strcmp("-swvs", argv[1])))
		//~ {
			//~ mode=2;
		//~ }
		//~ if ((argv[1]) && (!strcmp("-hw", argv[1])))
		//~ {
			//~ mode=3;	
		//~ }
		//~ if ((argv[1]) && (!strcmp("-hwvs", argv[1])))
		//~ {
			//~ mode=4;
		//~ }
	//~ }
	//~ if (mode)
	if (!sdl_12)
	{
		if (sdl_main_hwsw(labyrinth, player, rivals, size_labyrinth_length, size_labyrinth_width, holes, holes_array, window_height, window_width, fullscreen, refresh_rate, fps, hw_accel, vsync, trap_time, hole_time, speed, turn_speed, debug, settings, settings_filename))
		//~ if (sdl_main_hwsw(labyrinth, player, size_labyrinth_length, size_labyrinth_width, holes, holes_array, mode))
		{
			clean_up(labyrinth, size_labyrinth_width, size_labyrinth_length, holes_array, holes, settings_filename);
			return 1;
		}
		else
		{
			clean_up(labyrinth, size_labyrinth_width, size_labyrinth_length, holes_array, holes, settings_filename);
			return 0;
		}
	}
	//FIXME:   㭪樨!
	if (sdl_main(labyrinth, player, rivals, size_labyrinth_length, size_labyrinth_width, holes, holes_array, window_height, window_width, fullscreen, refresh_rate, fps, trap_time, hole_time, speed, turn_speed, debug, settings, settings_filename))
	//~ if (sdl_main(labyrinth, player, size_labyrinth_length, size_labyrinth_width, holes, holes_array))
	{
		clean_up(labyrinth, size_labyrinth_width, size_labyrinth_length, holes_array, holes, settings_filename);
		return 1;
	}
	//labyrinth={0};
	/*memset(labyrinth, 0, sizeof(*labyrinth)*size_labyrinth_width*size_labyrinth_length);
	free(labyrinth);
	labyrinth=NULL;*/
	clean_up(labyrinth, size_labyrinth_width, size_labyrinth_length, holes_array, holes, settings_filename);
	return 0;
}

//⪠ ४⭮ ᢮ ᮢ
void clean_up(int *labyrinth, short int const size_labyrinth_width, short int const size_labyrinth_length, short int *holes_array, short int const holes, char *settings_filename)
{
	memset(labyrinth, 0, sizeof(*labyrinth)*size_labyrinth_width*size_labyrinth_length);
	memset(holes_array, 0, sizeof(*holes_array)*holes);
	//FIXME: ७  atexit()
	free(labyrinth);
	free(holes_array);
	free(settings_filename);
	labyrinth=NULL;
	holes_array=NULL;
	settings_filename=NULL;
	return;
}
