/*  parameters.c

  ਭ
  Version 0.3.1

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "includes_macros.h"

short int parameters_check(const char *parameter_name, const char *parameter_value, const short int default_value, const short int *parameter);

//~ int parameters(char *args[], int count, short int *length, short int *width, short int *visual, short int *no_walls_removing, short int *show_result, short int *num_holes)
int parameters(char *args[], int count, short int *window_height, short int *window_width, short int *fullscreen, short int *refresh_rate, short int *fps, short int *hw_accel, short int *vsync, short int *sdl_12, short int *length, short int *width, short int *no_walls_removing, short int *rivals, short int *num_holes, short int *trap_time, short int *hole_time, short int *speed, short int *turn_speed, short int *debug, short int *visual, short int *show_result)
{
	// 砥  ᪫ ࠬ஢   㡫஢
	//㤥  ᫥ 㪠 ࠬ/᫥ 祭
	int parameter_count=1;
	while (parameter_count < count)
	{
		int result=0;
		//VIDEO
		//   ஢७   室   樠樨 SDL
		if (!strcmp("-H", args[parameter_count]) || !strcmp("--screen-height", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭  , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*window_height == DEFAULT_RES_Y)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_RES_Y);
				else
					printf("祭   (%hi).\n", *window_height);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], DEFAULT_RES_Y, window_height);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭  .");
				parameter_count++;
				continue;
			}
			// ஭     ⥫쭮  㫥 稭
			if (result < 1)
			{
				printf("祭 '%s' ࠬ '%s'    . ", args[parameter_count+1], args[parameter_count]);
				if (*window_height == DEFAULT_RES_Y)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_RES_Y);
				else
					printf("祭   (%hi).\n", *window_height);
				parameter_count++;
				continue;
			}
			*window_height=result;
			parameter_count++;
		}
		//   ஢७   室   樠樨 SDL
		else if (!strcmp("-W", args[parameter_count]) || !strcmp("--screen-width", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭  , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*window_width == DEFAULT_RES_X)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_RES_X);
				else
					printf("祭   (%hi).\n", *window_width);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], DEFAULT_RES_X, window_width);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭  .");
				parameter_count++;
				continue;
			}
			// ஭     ⥫쭮  㫥 稭
			if (result < 1)
			{
				printf("祭 '%s' ࠬ '%s'    . ", args[parameter_count+1], args[parameter_count]);
				if (*window_width == DEFAULT_RES_X)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_RES_X);
				else
					printf("祭   (%hi).\n", *window_width);
				parameter_count++;
				continue;
			}
			*window_width=result;
			parameter_count++;
		}
		//᫨ 㪠 ࠬ ࠭ ० - 㤥 ந ⪠ ᮧ 
		// ࠭ ०   ࠧ襭,  室 ࠬ   ᫥ 樠樨 SDL
		else if (!strcmp("-F", args[parameter_count]) || !strcmp("--fullscreen", args[parameter_count]))
		{
			*fullscreen=1;
			parameter_count++;
		}
		//   祭 FPS  ⮫쪮   ᪮७/  (७ ⮢)
		//祭 "-1" 砥 ன  ࠬ    ࠭ (refresh rate)
		else if (!strcmp("-f", args[parameter_count]) || !strcmp("--fps", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭  , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*fps == FPS)
					printf("⠭ 祭  㬮砭: %i.\n", FPS);
				else
					printf("祭   (%hi).\n", *fps);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], FPS, fps);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭   ( -1  ன 祭    ࠭).");
				parameter_count++;
				continue;
			}
			//祭 FPS     "1"
			//(஬ 祭 "-1", ஥ 뢠 室  ன    ࠭ (refresh rate)
			if (!result || result < -1)
			{
				printf("祭 '%s' ࠬ '%s'      ࠢ \'-1\'. ", args[parameter_count+1], args[parameter_count]);
				if (*fps == FPS)
					printf("⠭ 祭  㬮砭: %i.\n", FPS);
				else
					printf("祭   (%hi).\n", *fps);
				parameter_count++;
				continue;
			}
			*fps=result;
			parameter_count++;
		}
		//祭 "Hardware_Acceleration" 㪠뢠  室
		//樠樨 SDL  ⢮ ⭮ ᪮७
		else if (!strcmp("-a", args[parameter_count]) || !strcmp("--hw-accel", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭  , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . 祭   (%hi).\n", args[parameter_count], *hw_accel);
				parameter_count++;
				continue;
			}
			//᫮ 祭  ᥣ 㤮 -  짮⥫ 
			//ᯮ짮 祫⠥ 祭 ࠬ
			if (!strncmp("y", args[parameter_count+1], 1) || !strncmp("Y", args[parameter_count+1], 1) || !strncmp("on", args[parameter_count+1], 2) || !strncmp("ON", args[parameter_count+1], 2) ||!strncmp("On", args[parameter_count+1], 2))
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], "1", -2, hw_accel);
			}
			else if (!strncmp("n", args[parameter_count+1], 1) || !strncmp("N", args[parameter_count+1], 1) || !strncmp("off", args[parameter_count+1], 3) || !strncmp("OFF", args[parameter_count+1], 3) ||!strncmp("Off", args[parameter_count+1], 3))
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], "0", -2, hw_accel);
			}
			else
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], args[parameter_count+1], -2, hw_accel);
			}
			if (result == -2)
			{
				puts("⨬ ⮫쪮 祭 '1'  '0' ( 祪).");
				parameter_count++;
				continue;
			}
			if (result != 0 && result != 1)
			{
				printf("祭 ࠬ '%s'   ࠢ \"0\"  \"1\". 祭   (%hi).\n", args[parameter_count], *hw_accel);
				parameter_count++;
				continue;
			}
			// ࠬ ᮢ⨬  ࠬ஬ "sdl12",  ᯮ  API SDL 1.2
			//᫨ 祭 ᫥ 㤥 ࠢ "1",
			// 祭 ࠬ "hw_accel" ⠪ 㤥 ⠭  "1" -
			//᫥  ਮ, 祭 ᮢ⨬ ࠬ 㤥 襭  ﭨ "0"
			if (*sdl_12)
			{
				printf("ࠬ '%s' ᮢ⨬  ࠬ஬ 'sdl12'  ன 'SDL_12_style'. 祭 ࠬ 'sdl12'  (0)\n", args[parameter_count]);
				*sdl_12=0;
			}
			*hw_accel=result;
			parameter_count++;
		}
		//祭 "VSync" 㪠뢠  室 樠樨 SDL
		// ⢮ ० ᨭ஭樨 ⨪쭮  ࠭
		else if (!strcmp("-v", args[parameter_count]) || !strcmp("--vsync", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭  , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . 祭   (%hi).\n", args[parameter_count], *vsync);
				parameter_count++;
				continue;
			}
			//᫮ 祭  ᥣ 㤮 -  짮⥫ 
			//ᯮ짮 祫⠥ 祭 ࠬ
			if (!strncmp("y", args[parameter_count+1], 1) || !strncmp("Y", args[parameter_count+1], 1) || !strncmp("on", args[parameter_count+1], 2) || !strncmp("ON", args[parameter_count+1], 2) ||!strncmp("On", args[parameter_count+1], 2))
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], "1", -2, vsync);
			}
			else if (!strncmp("n", args[parameter_count+1], 1) || !strncmp("N", args[parameter_count+1], 1) || !strncmp("off", args[parameter_count+1], 3) || !strncmp("OFF", args[parameter_count+1], 3) ||!strncmp("Off", args[parameter_count+1], 3))
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], "0", -2, vsync);
			}
			else
			{
				//祭 "-2" 砥,   ࠬ  祭  㬮砭
				result=parameters_check(args[parameter_count], args[parameter_count+1], -2, vsync);
			}
			if (result == -2)
			{
				puts("⨬ ⮫쪮 祭 '1'  '0' ( 祪).");
				parameter_count++;
				continue;
			}
			if (result != 0 && result != 1)
			{
				printf("祭 ࠬ '%s'   ࠢ \"0\"  \"1\". 祭   (%hi).\n", args[parameter_count], *vsync);
				parameter_count++;
				continue;
			}
			// ࠬ ᮢ⨬  ࠬ஬ "sdl12",  ᯮ  API SDL 1.2
			//᫨ 祭 ᫥ 㤥 ࠢ "1",
			// 祭 ࠬ "vsync" ⠪ 㤥 ⠭  "1" -
			//᫥  ਮ, 祭 ᮢ⨬ ࠬ 㤥 襭  ﭨ "0"
			if (*sdl_12)
			{
				printf("ࠬ '%s' ᮢ⨬  ࠬ஬ 'sdl12'  ன 'SDL_12_style'. 祭 ࠬ 'sdl12'  (0)\n", args[parameter_count]);
				*sdl_12=0;
			}
			*vsync=result;
			parameter_count++;
		}
		//ࠬ "sdl12" 㪠뢠  室 ᯮ짮 ணࠬ ᪮७   API SDL 1.2
		// ࠬ ᮢ⨬  ࠬࠬ "hw_accel"  "vsync",
		// ᯮ  API SDL 2.x
		//᫨ 祭      㤥 ࠢ "1",
		// 祭 ࠬ "sdl12" ⠪ 㤥 ⠭  "1" -
		//᫥  ਮ, 祭 ᮢ⨬ ࠬ஢  襭  ﭨ "0"
		else if (!strcmp("--sdl12", args[parameter_count]))
		{
			if (*hw_accel)
			{
				printf("ࠬ '%s' ᮢ⨬  ࠬ஬ 'hw_accel'  ன 'Hardware_Acceleration'. 祭 ࠬ 'hw_accel'  (0)\n", args[parameter_count]);
				*hw_accel=0;
			}
			if (*vsync)
			{
				printf("ࠬ '%s' ᮢ⨬  ࠬ஬ 'vsync'  ன 'VSync'. 祭 ࠬ 'vsync'  (0)\n", args[parameter_count]);
				*vsync=0;
			}
			*sdl_12=1;
			parameter_count++;
		}
		//GAME
		//஢ઠ,   짮⥫ ⠭ ᢮  ਭ
		else if (!strcmp("-l", args[parameter_count]) || !strcmp("--length", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*length == DEFAULT_LENGTH)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_LENGTH);
				else
					printf("祭   (%hi).\n", *length);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], DEFAULT_LENGTH, length);
			if (result == -2)
			{
				printf("⨬ ⥫ 楫᫥ 祭    %i  %i ⥫쭮.\n", DEFAULT_MIN_LENGTH, DEFAULT_MAX_LENGTH);
				parameter_count++;
				continue;
			}
			//᫨ 祭  ।񭭮 ᨬ쭮  - ᢠ ᨬ쭮  祭
			//᫨ 祭  ।񭭮 쭮  - ᢠ 쭮  祭
			if (result < DEFAULT_MIN_LENGTH)
			{
				printf("祭 '%s' ࠬ '%s'     쭮 祭 (%i). ", args[parameter_count+1], args[parameter_count], DEFAULT_MIN_LENGTH);
				if (*length == DEFAULT_MIN_LENGTH+2)
					printf("祭   (%hi).\n", *length-2);
				else
					printf("⠭ 쭮 祭  㬮砭: %i.\n", DEFAULT_MIN_LENGTH);
				result=DEFAULT_MIN_LENGTH;
			}
			if (result > DEFAULT_MAX_LENGTH)
			{
				printf("祭 '%s' ࠬ '%s'     ᨬ쭮 祭 (%i). ", args[parameter_count+1], args[parameter_count], DEFAULT_MAX_LENGTH);
				if (*length == DEFAULT_MAX_LENGTH+2)
					printf("祭   (%hi).\n", *length-2);
				else
					printf("⠭ ᨬ쭮 祭  㬮砭: %i.\n", DEFAULT_MAX_LENGTH);
				result=DEFAULT_MAX_LENGTH;
			}
			*length=result+2;
			parameter_count++;
		}
		//஢ઠ,   짮⥫ ⠭ ᢮ ਭ ਭ
		else if (!strcmp("-w", args[parameter_count]) || !strcmp("--width", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ਭ, ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*width == DEFAULT_WIDTH)
					printf("⠭ 祭  㬮砭: %i.\n", DEFAULT_WIDTH);
				else
					printf("祭   (%hi).\n", *width);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], DEFAULT_WIDTH, width);
			if (result == -2)
			{
				printf("⨬ ⥫ 楫᫥ 祭    %i  %i ⥫쭮.\n", DEFAULT_MIN_WIDTH, DEFAULT_MAX_WIDTH);
				parameter_count++;
				continue;
			}
			//᫨ 祭  ।񭭮 ᨬ쭮  - ᢠ ᨬ쭮  祭
			//᫨ 祭  ।񭭮 쭮  - ᢠ 쭮  祭
			if (result < DEFAULT_MIN_WIDTH)
			{
				printf("祭 '%s' ࠬ '%s'     쭮 祭 (%i). ", args[parameter_count+1], args[parameter_count], DEFAULT_MIN_WIDTH);
				if (*width == DEFAULT_MIN_WIDTH+2)
					printf("祭   (%hi).\n", *width-2);
				else
					printf("⠭ 쭮 祭  㬮砭: %i.\n", DEFAULT_MIN_WIDTH);
				result=DEFAULT_MIN_WIDTH;
			}
			if (result > DEFAULT_MAX_WIDTH)
			{
				printf("祭 '%s' ࠬ '%s'     ᨬ쭮 祭 (%i). ", args[parameter_count+1], args[parameter_count], DEFAULT_MAX_WIDTH);
				if (*width == DEFAULT_MAX_WIDTH+2)
					printf("祭   (%hi).\n", *width-2);
				else
					printf("⠭ ᨬ쭮 祭  㬮砭: %i.\n", DEFAULT_MAX_WIDTH);
				result=DEFAULT_MAX_WIDTH;
			}
			*width=result+2;
			parameter_count++;
		}
		//஢ઠ,   짮⥫ ⠢ 㤠 ⥭  ਭ  ᮧ 横筮 ਭ
		//( 㬮砭 - ),   ( ।  ࠬ)
		// 室  ᫥饬 ࠬ (᫨ )
		else if (!strcmp("-n", args[parameter_count]) || !strcmp("--no-wall-removing", args[parameter_count]))
		{
			*no_walls_removing=1;
			parameter_count++;
		}
		//ࠬ "Rivals" 㪠뢠 饥  ⢮ ᮯ୨,    ( ப)
		//FIXME: ᨬ쭮 ⢮ ⭨   ࠭祭
		else if (!strcmp("-r", args[parameter_count]) || !strcmp("--rivals", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ⢠ ⭨, ᫨    - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*rivals == RIVALS)
					printf("⠭ 祭  㬮砭: %i.\n", RIVALS);
				else
					printf("祭   (%hi).\n", *rivals);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], RIVALS, rivals);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭  .");
				parameter_count++;
				continue;
			}
			//⢮ ᮯ୨    ⥫쭮  㫥 稭
			//(   ⭨ (ப) 㤥 ⢮)
			if (result < 1)
			{
				printf("祭 '%s' ࠬ '%s'    . ", args[parameter_count+1], args[parameter_count]);
				if (*rivals == RIVALS)
					printf("⠭ 祭  㬮砭: %i.\n", RIVALS);
				else
					printf("祭   (%hi).\n", *rivals);
				parameter_count++;
				continue;
			}
			*rivals=result;
			parameter_count++;
		}
		//ࠬ "Holes" ("pits") 㪠뢠  ⢮   
		//TODO:    横᪨ 易  ᮡ
		//(஢ઠ  ⭮ ⢮   ॡ,      0,   2)
		//FIXME: ᨬ쭮 ⢮   ࠭祭!
		//TODO:    ᯮᮡ  ᮡ  室 ६ ⭨
		// 砩  ਭ - ⢮      1,  ࠢ 0
		else if (!strcmp("-p", args[parameter_count]) || !strcmp("--pits", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ⢠ , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*num_holes == HOLES)
					printf("⠭ 祭  㬮砭: %i.\n", HOLES);
				else
					printf("祭   (%hi).\n", *num_holes);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], HOLES, num_holes);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭 ஬ '1'.");
				parameter_count++;
				continue;
			}
			//⢮     ⥫쭮 稭
			if (result < 0)
			{
				printf("祭 '%s' ࠬ '%s'    '1'  ࠢ . ", args[parameter_count+1], args[parameter_count]);
				if (*num_holes == HOLES)
					printf("⠭ 祭  㬮砭: %i.\n", HOLES);
				else
					printf("祭   (%hi).\n", *num_holes);
				parameter_count++;
				continue;
			}
			*num_holes=result;
			parameter_count++;
		}
		//६, ஢񭭮  誥, 㪠뢠  ᥪ㭤
		else if (!strcmp("-t", args[parameter_count]) || !strcmp("--trap-time", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ६, ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*trap_time == TIME_IN_TRAP)
					printf("⠭ 祭  㬮砭: %i.\n", TIME_IN_TRAP);
				else
					printf("祭   (%hi).\n", *trap_time);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], TIME_IN_TRAP, trap_time);
			if (result == -2)
			{
				//࠭祭  30 ᥪ㭤 易  ᨬ쭮  祭 ६ ⨯ short int - 32767
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭    0  30 ⥫쭮.");
				parameter_count++;
				continue;
			}
			//६    ⥫쭮 稭
			if (result < 0 || result > 30)
			{
				printf("祭 '%s' ࠬ '%s'      0  30 ⥫쭮. ", args[parameter_count+1], args[parameter_count]);
				if (*trap_time == TIME_IN_TRAP)
					printf("⠭ 祭  㬮砭: %i.\n", TIME_IN_TRAP);
				else
					printf("祭   (%hi).\n", *trap_time);
				parameter_count++;
				continue;
			}
			//᪮ SDL API ਭ ᥪ㭤 - ந 㬭  1000
			*trap_time=result*1000;
			parameter_count++;
		}
		//६, 祭  ६饭  ࠬ, 㪠뢠  ᥪ㭤
		else if (!strcmp("-T", args[parameter_count]) || !strcmp("--pit-time", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ६, ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*hole_time == TIME_BETWEEN_HOLES)
					printf("⠭ 祭  㬮砭: %i.\n", TIME_BETWEEN_HOLES);
				else
					printf("祭   (%hi).\n", *hole_time);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], TIME_BETWEEN_HOLES, hole_time);
			if (result == -2)
			{
				//࠭祭  30 ᥪ㭤 易  ᨬ쭮  祭 ६ ⨯ short int - 32767
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭    0  30 ⥫쭮.");
				parameter_count++;
				continue;
			}
			//६    ⥫쭮 稭
			if (result < 0 || result > 30)
			{
				printf("祭 '%s' ࠬ '%s'      0  30 ⥫쭮. ", args[parameter_count+1], args[parameter_count]);
				if (*hole_time == TIME_BETWEEN_HOLES)
					printf("⠭ 祭  㬮砭: %i.\n", TIME_BETWEEN_HOLES);
				else
					printf("祭   (%hi).\n", *hole_time);
				parameter_count++;
				continue;
			}
			//᪮ SDL API ਭ ᥪ㭤 - ந 㬭  1000
			*hole_time=result*1000;
			parameter_count++;
		}
		//ࠬ ᪮   প  (稢)
		// ப   (६饭  ⪠  )
		//TODO: ࠭祭  ᨬ쭮 祭  
		else if (!strcmp("-s", args[parameter_count]) || !strcmp("--speed", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ᪮ , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*speed == SPEED_MOVE)
					printf("⠭ 祭  㬮砭: %i.\n", SPEED_MOVE);
				else
					printf("祭   (%hi).\n", *speed);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], SPEED_MOVE, speed);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭.");
				parameter_count++;
				continue;
			}
			//砫쭠 ᪮    ⥫쭮 稭
			if (result < 0)
			{
				printf("祭 '%s' ࠬ '%s'      ࠢ . ", args[parameter_count+1], args[parameter_count]);
				if (*speed == SPEED_MOVE)
					printf("⠭ 祭  㬮砭: %i.\n", SPEED_MOVE);
				else
					printf("祭   (%hi).\n", *speed);
				parameter_count++;
				continue;
			}
			*speed=result;
			parameter_count++;
		}
		//ࠬ ᪮   প  (稢)
		// ப   (६饭  ⪠  )
		//TODO: ࠭祭  ᨬ쭮 祭  
		else if (!strcmp("-S", args[parameter_count]) || !strcmp("--speed-turn", args[parameter_count]))
		{
			//஢ઠ  ।⢥ 祭 ᪮ , ᫨   - 室  ᫥饬 ࠬ
			if ((parameter_count+1) >= count)
			{
				printf("ࠬ '%s' . ", args[parameter_count]);
				if (*turn_speed == SPEED_TURN)
					printf("⠭ 祭  㬮砭: %i.\n", SPEED_TURN);
				else
					printf("祭   (%hi).\n", *turn_speed);
				parameter_count++;
				continue;
			}
			result=parameters_check(args[parameter_count], args[parameter_count+1], SPEED_TURN, turn_speed);
			if (result == -2)
			{
				puts("⨬ ⮫쪮 ⥫ 楫᫥ 祭.");
				parameter_count++;
				continue;
			}
			//砫쭠 ᪮    ⥫쭮 稭
			if (result < 0)
			{
				printf("祭 '%s' ࠬ '%s'      ࠢ . ", args[parameter_count+1], args[parameter_count]);
				if (*turn_speed == SPEED_TURN)
					printf("⠭ 祭  㬮砭: %i.\n", SPEED_TURN);
				else
					printf("祭   (%hi).\n", *turn_speed);
				parameter_count++;
				continue;
			}
			*turn_speed=result;
			parameter_count++;
		}
		//DEBUG
		//஢ઠ,   짮⥫  楫 ⫠
		// 奬筮 ࠦ ਭ (ᮢ뢠  横 -  ४  ࠧ஢  20*20)
		// ﭨ  ६
		else if (!strcmp("-d", args[parameter_count]) || !strcmp("--debug", args[parameter_count]))
		{
			*debug=1;
			parameter_count++;
		}
		//஢ઠ,   짮⥫  楫 ⫠
		//  ᮧ ᪥ ਭ ( 㬮砭 -),   ( ।  ࠬ)
		// 室  ᫥饬 ࠬ (᫨ )
		else if (!strcmp("-b", args[parameter_count]) || !strcmp("--show-building", args[parameter_count]))
		{
			*visual=1;
			parameter_count++;
		}
		//஢ઠ,   짮⥫  ⥫ १ ࠡ ணࠬ
		//(   - 뢮 ᪥ ਭ),  ।  ࠬ,   ( 㬮砭)
		// 室  ᫥饬 ࠬ (᫨ )
		else if (!strcmp("-R", args[parameter_count]) || !strcmp("--result", args[parameter_count]))
		{
			*show_result=1;
			parameter_count++;
		}
		
		//OTHER
		
		//᫨  ⢥ ࠬ । -  (ਬ, 祭  ।饣 ࠬ) - 室  ᫥饬 ࠬ (᫨  )
		else
		{
			parameter_count++;
		}
	}
	return 0;
}

//஢ઠ ࠬ஢,  짮⥫
//㭪 頥  񭭮 짮⥫ 祭,  "-2"  ⢥ 訡
//ࠡ⪠ ४⭮ ।⢥ ᠬ 祭 ந  ஢ ࠡ⪨ ࠬ஢
short int parameters_check(const char *parameter_name, const char *parameter_value, const short int default_value, const short int *parameter)
{
	//  祭, ॢ ࠧ short int,  ⠪  ᫮ ᨬ
	long int temp_int;
	char *tile_string[100]={""};
	temp_int=strtol(parameter_value, tile_string, 10);
	if ((!temp_int) && (parameter_value == *tile_string))
	{
		printf("祭 '%s' ࠬ '%s' ⭮. ", parameter_value, parameter_name);
		if (*parameter == default_value)
			printf("⠭ 祭  㬮砭: %i.\n", default_value);
		else
			printf("祭   (%hi).\n", *parameter);
		return -2;
	}
	short int value=temp_int;
	//᫨  ࠬ । ஡ ᫮/ -
	//⠪ 祭  祭  楫 ᥫ/ࠢ  㫨  祭  㬮砭
	char value_string[10]; // 10 c  㬥 筮 讥 ᫮
	snprintf(value_string, 10, "%hi", value);
	if (strcmp(value_string, parameter_value))
	{
		printf("祭 '%s' ࠬ '%s' ⭮. ", parameter_value, parameter_name);
		if (*parameter == default_value)
			printf("⠭ 祭  㬮砭: %i.\n", default_value);
		else
			printf("祭   (%hi).\n", *parameter);
		return -2;
	}
	return value;
}
