/*  sdl_main.c

  ਭ
  Version 0.3.1

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "SDL2\SDL.h"
#include "SDL2\SDL_image.h"
#include "includes_macros.h"

void show_labyrinth_in_cmd(int const player_coordinate, const struct players player[], short int const length, short int const width, int const *labyrinth_temp); // ⫠  ஫ १ ᮫

void checking_for_events(SDL_Window *main_window, SDL_Surface *screen, int const coordinate, struct players player[], int *labyrinth, short int const size_labyrinth_length, short int const holes, short int const *holes_array);

int request_for_exit(SDL_Window *main_window, const struct players player[]);

void clean_up_sdl(SDL_Window *main_window);

int sdl_main(int *labyrinth, struct players player[], short int const rivals, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, short int window_height, short int window_width, short int fullscreen, short int refresh_rate, short int fps, short int trap_time, short int hole_time, short int speed, short int turn_speed, short int const debug, FILE *settings, char const *settings_filename)
//~ int sdl_main(int *labyrinth, struct players player[], short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array)
{
	//  樠 প   㤨
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0)
	{
		SDL_Log("Unable to initialize SDL: %s", SDL_GetError());
		return 1;
	}
	// ᭮ 
	SDL_Window *main_window=NULL;
	//祭 祭 ⥪饣 ० ࠭ (ᯫ) 0
	SDL_DisplayMode desktop_display0_mode;
	SDL_GetDesktopDisplayMode(0, &desktop_display0_mode);
	//᫨ ਫ  ᪠  ࠭ ० - ந ஢ઠ
	// 㯭 ৥襭 ࠭, 室饣   祭   ਭ 
	if (fullscreen)
	{
		SDL_DisplayMode other_display_mode;
		int modes_number=SDL_GetNumDisplayModes(0);
		unsigned char *suited_dm=(unsigned char*)calloc(modes_number+1, sizeof( unsigned char ));
		if (suited_dm)
		{
			//᫥ ⢠ 㯭 ०   ࠧ襭
			for (int i = 0; i < modes_number; i++)
			{
				SDL_GetDisplayMode(0, i, &other_display_mode);
				if (other_display_mode.h == window_height && other_display_mode.w == window_width)
				{
					suited_dm[0]++;
					suited_dm[(int)suited_dm[0]]=i;
				}
			}
			//᫨  祭  ᮮ⢥    㯭 ० -
			//ந ⪠ ᪠   室饣 ०
			if (!(int)suited_dm[0])
			{
				puts(" ࠧ襭  ন ᯮ㥬 ஬.");
				SDL_DisplayMode whished_display_mode;
				whished_display_mode.h=window_height;
				whished_display_mode.w=window_width;
				if (SDL_GetClosestDisplayMode(0, &whished_display_mode, &other_display_mode))
				{
					whished_display_mode.h=other_display_mode.h;
					whished_display_mode.w=other_display_mode.w;
					for (int i = 0; i < modes_number; i++)
					{
						SDL_GetDisplayMode(0, i, &other_display_mode);
						if (other_display_mode.h == whished_display_mode.h && other_display_mode.w == whished_display_mode.w)
						{
							suited_dm[0]++;
							suited_dm[(int)suited_dm[0]]=i;
						}
					}
					if ((int)suited_dm[0] == 1)
						printf("㤥 ᯮ짮   室饥 ࠧ襭: %ix%i.\n", whished_display_mode.w, whished_display_mode.h);
				}
				//᫨ ⮬᪨   室饣 ०  㤠 -
				//㤥 ந ⡮  㯭
				//砫 ந ஢ઠ  ࠧ 
				//(     ,  뫨   ᪥),
				//⥬ -  㡨 梥⮯।  祭   ࠭
				//(㤥 ࠭ ०,  ண     ࠧ )
				else
				{
					short int current_refresh_rate=0;
					short int current_bpp=0;
					for (int i = 0; i < modes_number; i++)
					{
						SDL_GetDisplayMode(0, i, &other_display_mode);
						if (other_display_mode.h <= window_height && other_display_mode.w <= window_width)
						{
							if ((SDL_BITSPERPIXEL(other_display_mode.format) >= current_bpp) \
							&& (other_display_mode.refresh_rate >= current_refresh_rate))
							{
								current_refresh_rate=other_display_mode.refresh_rate;
								current_bpp=SDL_BITSPERPIXEL(other_display_mode.format);
								suited_dm[0]++;
								suited_dm[(int)suited_dm[0]]=i;
							}
						}
					}
				}
			}
			//᫨  ᪮쪮 室 ० -
			//㤥 ࠭ ⠪,  ண  㡨 梥⮯।,   ࠭  ࠧ襭 (ࠧ )
			//(᫨  ⠪ ᮢ - 㤥 ࠭  㯭 ०)
			if ((int)suited_dm[0] > 1)
			{
				char check=1;
				short int max_num=0;
				short int max_num_2=0;
				//ᠭ   ᫥ 㯭 ०
				struct suited_modes{
					unsigned char number; // ०, 뤠 SDL
					short int height; // 
					short int width; //ਭ 
					short int bpp; //㡨 梥⮯।
					short int refresh_rate; //  ࠭
					struct suited_modes *next_mode; //㪠⥫  ᫥㨩  ()
				};
				struct suited_modes *video_modesPtr=NULL;
				struct suited_modes *video_modes_lastPtr=NULL;
				struct suited_modes *video_modes_previousPtr=NULL;
				video_modesPtr=calloc(1, sizeof(struct suited_modes));
				video_modes_lastPtr=video_modesPtr;
				video_modes_previousPtr=video_modesPtr;
				if (!video_modesPtr)
					check=0;
				if (check)
				{
					//  祭ﬨ ⮡࠭ ०
					for (int i = 0; i < (int)suited_dm[0]; i++)
					{
						SDL_GetDisplayMode(0, (int)suited_dm[i+1], &other_display_mode);
						video_modes_previousPtr->number=suited_dm[i+1];
						video_modes_previousPtr->height=other_display_mode.h;
						video_modes_previousPtr->width=other_display_mode.w;
						video_modes_previousPtr->bpp=SDL_BITSPERPIXEL(other_display_mode.format);
						video_modes_previousPtr->refresh_rate=other_display_mode.refresh_rate;
						video_modes_lastPtr=calloc(1, sizeof(struct suited_modes));
						if (!video_modes_lastPtr)
						{
							check=0;
							break;
						}
						video_modes_previousPtr->next_mode=video_modes_lastPtr;
						video_modes_previousPtr=video_modes_lastPtr;
					}
				}
				if (check)
				{
					//⡮ ०  襩 㡨 梥⮯।
					//⠫ ०  襭   쭥 ⡮ ⢮  
					max_num=video_modesPtr->bpp;
					video_modes_lastPtr=video_modesPtr;
					//~ for (int i = 0; i < (int)suited_dm[0]; i++)
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->bpp > max_num)
							max_num=video_modes_lastPtr->bpp;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					//~ for (int i = 0; i < (int)suited_dm[0]; i++)
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->bpp != max_num)
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					//⡮ ०  襩 ⮩  ࠭
					//⠫ ०  襭   쭥 ⡮ ⢮  
					max_num=video_modesPtr->refresh_rate;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->refresh_rate > max_num)
							max_num=video_modes_lastPtr->refresh_rate;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->refresh_rate != max_num)
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					//⡮ ०   ࠧ襭 (ࠧ஬ )
					//⠫ ०  襭
					max_num=video_modesPtr->height;
					max_num_2=video_modesPtr->width;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if ((video_modes_lastPtr->height >= max_num) && (video_modes_lastPtr->width >= max_num_2))
						{
							max_num=video_modes_lastPtr->height;
							max_num_2=video_modes_lastPtr->width;
						}
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if ((video_modes_lastPtr->height != max_num) && (video_modes_lastPtr->width != max_num_2))
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
				}
				//᫨ ।騥 ⡮ 諨 ᯥ譮
				//(    易 ᯨ᪮  뫠 ᯥ譮 뤥),
				// ந   ⠢襣 ०
				//( ࢮ  ⠢ -       ࠪ᪨ 묨)
				// 㪠뢠,  室騩 ०   
				if (!check)
					suited_dm[0]=0;
				else
				{
					suited_dm[0]=1;
					suited_dm[1]=video_modesPtr->number;
				}
				SDL_GetDisplayMode(0, (int)suited_dm[1], &other_display_mode);
				puts(" ᪮쪮 室 ०.");
				printf("㤥 ᯮ짮   室饥 ࠧ襭: %ix%i\n", other_display_mode.w, other_display_mode.h);
			}
			//᫨ 室騩 ० ⠪     - 㤥 ᯮ짮
			//⥪饥 ࠧ襭 樮 ⥬ (ࠧ襭 ࠡ祣 ⮫)
			if (!(int)suited_dm[0])
			{
				printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
				window_height=desktop_display0_mode.h;
				window_width=desktop_display0_mode.w;
				refresh_rate=desktop_display0_mode.refresh_rate;
				main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN_DESKTOP);
			}
			//᫨ 室騩 ०  - 㤥 ᯮ짮  
			SDL_GetDisplayMode(0, (int)suited_dm[1], &other_display_mode);
			window_height=other_display_mode.h;
			window_width=other_display_mode.w;
			refresh_rate=other_display_mode.refresh_rate;
			main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN);
			free(suited_dm);
			suited_dm=NULL;
		}
		//᫨  㤠 뤥   ᪠ ন ० -
		//㤥 ᯮ짮 ⥪饥 ࠧ襭 樮 ⥬ (ࠧ襭 ࠡ祣 ⮫)
		else
		{
			puts("訡   ⠭ ࠧ襭 ࠭.");
			printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
			window_height=desktop_display0_mode.h;
			window_width=desktop_display0_mode.w;
			refresh_rate=desktop_display0_mode.refresh_rate;
			main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN_DESKTOP);
		}
	}
	else
	{
		//  ० 㤥 ந ஢ઠ  ४⭮ 祭 ⭮⥫쭮 ࠧ஢ ࠭
		if (window_height > desktop_display0_mode.h || window_width > desktop_display0_mode.w)
		{
			puts(" ࠧ襭  ࠧ ࠭");
			printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
			window_height=desktop_display0_mode.h;
			window_width=desktop_display0_mode.w;
		}
	    main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, 0);
	}
    if (main_window == NULL)
    {
		SDL_Log("Could not create window: %s\n", SDL_GetError());
		clean_up_sdl(NULL);
		return 1;
	}
	/*SDL_Renderer *renderer = NULL;
	SDL_Texture *bitmapTex = NULL;
	renderer = SDL_CreateRenderer(main_window, -1, SDL_RENDERER_ACCELERATED);*/
	//樠 孮 
	SDL_Surface *screen=NULL;
	screen=SDL_GetWindowSurface(main_window);
	//㧪 ᪨ ᮢ
	if (IMG_Init(IMG_INIT_PNG) != IMG_INIT_PNG)
	{
		printf("IMG_Init: Failed to init required png support!\n");
		printf("IMG_Init: %s\n", IMG_GetError());
		clean_up_sdl(main_window);
		return 1;
	}
	SDL_Surface *background_=NULL;
	SDL_Surface *wall_=NULL;
	SDL_Surface *wall_side_left_=NULL;
	SDL_Surface *wall_side_right_=NULL;
	SDL_Surface *wall_far_=NULL;
	SDL_Surface *wall_side_far_left_=NULL;
	SDL_Surface *wall_side_far_right_=NULL;
	SDL_Surface *line_=NULL;
	SDL_Surface *empty_background_=NULL;
	SDL_Surface *empty_far_background_=NULL;
	SDL_Surface *arsenal_=NULL;
	SDL_Surface *hole_=NULL;
	SDL_Surface *hole_ceiling_=NULL;
	SDL_Surface *chest_=NULL;
	SDL_Surface *grate_=NULL;
	SDL_Surface *hospital_=NULL;
	SDL_Surface *hospital_near_=NULL;
	SDL_Surface *exit_morning_=NULL;
	SDL_Surface *exit_day_=NULL;
	SDL_Surface *exit_evening_=NULL;
	SDL_Surface *exit_night_=NULL;
	
	SDL_Surface *black_rect=NULL; // 䥪  堭 ࠭
	
	background_=IMG_Load("gfx/background.png");
	wall_=IMG_Load("gfx/wall.png");
	wall_side_left_=IMG_Load("gfx/wall_side_left.png");
	wall_side_right_=IMG_Load("gfx/wall_side_right.png");
	wall_far_=IMG_Load("gfx/wall_far.png");
	wall_side_far_left_=IMG_Load("gfx/wall_side_far_left.png");
	wall_side_far_right_=IMG_Load("gfx/wall_side_far_right.png");
	line_=IMG_Load("gfx/line.png");
	empty_background_=IMG_Load("gfx/empty_background.png");
	empty_far_background_=IMG_Load("gfx/empty_far_background.png");
	arsenal_=IMG_Load("gfx/arsenal_boxes.png");
	hole_=IMG_Load("gfx/big_hole_in_floor.png");
	hole_ceiling_=IMG_Load("gfx/big_holes_in_ceiling.png");
	chest_=IMG_Load("gfx/chest.png");
	grate_=IMG_Load("gfx/grate.png");
	hospital_=IMG_Load("gfx/hospital_far.png");
	hospital_near_=IMG_Load("gfx/hospital_near.png");
	exit_morning_=IMG_Load("gfx/exit_morning.png");
	exit_day_=IMG_Load("gfx/exit_day.png");
	exit_evening_=IMG_Load("gfx/exit_evening.png");
	exit_night_=IMG_Load("gfx/exit_night.png");
	//᫨  㤠 㧨 - 䠩 - 뢥 ᮮ饭  訡  㪠 ᫥  㦥 䠩
	if (!background_ || !wall_ || !wall_side_left_ || !wall_side_right_ || !wall_far_ || !wall_side_far_left_ || !wall_side_far_right_ || !line_ || !empty_background_ || !empty_far_background_ || !arsenal_ || !hole_ || !hole_ceiling_ || !chest_ || !grate_ || !hospital_ || !hospital_near_ || !exit_morning_ || !exit_day_ || !exit_evening_ || !exit_night_)
	{
		printf("IMG_Load: %s\n", IMG_GetError());
		clean_up_sdl(main_window);
		return 1;
	}
	//  ன ० ᬥ訢 孮 ୮  ( 䥪  堭 ࠭)
	if ( (black_rect=SDL_CreateRGBSurface(0, window_width, window_height, 32, 0, 0, 0, 0)) == NULL)
	{
		SDL_Log("SDL_CreateRGBSurface(black_rect) failed: %s", SDL_GetError());
	}
	else
		SDL_SetSurfaceBlendMode(black_rect, SDL_BLENDMODE_BLEND);
	
	//⨬ 㦥 ࠦ
	SDL_Surface *background=NULL;
	SDL_Surface *wall=NULL;
	SDL_Surface *wall_side_left=NULL;
	SDL_Surface *wall_side_right=NULL;
	SDL_Surface *wall_far=NULL;
	SDL_Surface *wall_side_far_left=NULL;
	SDL_Surface *wall_side_far_right=NULL;
	SDL_Surface *line=NULL;
	SDL_Surface *empty_background=NULL;
	SDL_Surface *empty_far_background=NULL;
	SDL_Surface *arsenal=NULL;
	SDL_Surface *hole=NULL;
	SDL_Surface *hole_ceiling=NULL;
	SDL_Surface *chest=NULL;
	SDL_Surface *grate=NULL;
	SDL_Surface *hospital=NULL;
	SDL_Surface *hospital_near=NULL;
	SDL_Surface *exit_morning=NULL;
	SDL_Surface *exit_day=NULL;
	SDL_Surface *exit_evening=NULL;
	SDL_Surface *exit_night=NULL;

	//background=SDL_ConvertSurface(background_, screen->format, 0);
	background=SDL_ConvertSurface(background_, (*screen).format, 0);
	wall=SDL_ConvertSurface(wall_, (*screen).format, 0);
	wall_side_left=SDL_ConvertSurface(wall_side_left_, (*screen).format, 0);
	wall_side_right=SDL_ConvertSurface(wall_side_right_, (*screen).format, 0);
	wall_far=SDL_ConvertSurface(wall_far_, (*screen).format, 0);
	wall_side_far_left=SDL_ConvertSurface(wall_side_far_left_, (*screen).format, 0);
	wall_side_far_right=SDL_ConvertSurface(wall_side_far_right_, (*screen).format, 0);
	line=SDL_ConvertSurface(line_, (*screen).format, 0);
	empty_background=SDL_ConvertSurface(empty_background_, (*screen).format, 0);
	empty_far_background=SDL_ConvertSurface(empty_far_background_, (*screen).format, 0);
	arsenal=SDL_ConvertSurface(arsenal_, (*screen).format, 0);
	hole=SDL_ConvertSurface(hole_, (*screen).format, 0);
	hole_ceiling=SDL_ConvertSurface(hole_ceiling_, (*screen).format, 0);
	chest=SDL_ConvertSurface(chest_, (*screen).format, 0);
	grate=SDL_ConvertSurface(grate_, (*screen).format, 0);
	hospital=SDL_ConvertSurface(hospital_, (*screen).format, 0);
	hospital_near=SDL_ConvertSurface(hospital_near_, (*screen).format, 0);
	exit_morning=SDL_ConvertSurface(exit_morning_, (*screen).format, 0);
	exit_day=SDL_ConvertSurface(exit_day_, (*screen).format, 0);
	exit_evening=SDL_ConvertSurface(exit_evening_, (*screen).format, 0);
	exit_night=SDL_ConvertSurface(exit_night_, (*screen).format, 0);
	//᫨  㤠 ⨬஢ - ࠦ - 뢥 ᮮ饭  訡  㪠 ᫥ 㤠襣 ८ࠧ
	if (!background || !wall || !wall_side_left || !wall_side_right || !wall_far || !wall_side_far_left || !wall_side_far_right || !line || !empty_background || !empty_far_background || !arsenal || !hole || !hole_ceiling || !chest || !grate || !hospital || !hospital_near || !exit_morning || !exit_day || !exit_evening || !exit_night)
	{
		printf("IMG_Load: %s\n", IMG_GetError());
		clean_up_sdl(main_window);
		return 1;
	}
	//㧪 ⨬஢ ࠦ
	SDL_FreeSurface(background_);
	SDL_FreeSurface(wall_);
	SDL_FreeSurface(wall_side_left_);
	SDL_FreeSurface(wall_side_right_);
	SDL_FreeSurface(wall_far_);
	SDL_FreeSurface(wall_side_far_left_);
	SDL_FreeSurface(wall_side_far_right_);
	SDL_FreeSurface(line_);
	SDL_FreeSurface(empty_background_);
	SDL_FreeSurface(empty_far_background_);
	SDL_FreeSurface(arsenal_);
	SDL_FreeSurface(hole_);
	SDL_FreeSurface(hole_ceiling_);
	SDL_FreeSurface(chest_);
	SDL_FreeSurface(grate_);
	SDL_FreeSurface(hospital_);
	SDL_FreeSurface(hospital_near_);
	SDL_FreeSurface(exit_morning_);
	SDL_FreeSurface(exit_day_);
	SDL_FreeSurface(exit_evening_);
	SDL_FreeSurface(exit_night_);
	
	//祭 祭 ⥪饣 쭮 ६  ⮡ࠦ ᮮ⢥饣 ਠ ࠦ 室  ਭ
	//(, ⮨ ७  ᭮ 横  ঠ 㠫 ,
	//  ᮬ ⭮⥫쭮 ந⥫쭮  室   )
	time_t local_rawtime=time(NULL);
	struct tm *time_of_day;
	time_of_day=localtime(&local_rawtime);
	//᫨ -  祭 ६   ⠪ - ⠭ 祭  㬮砭 ()
	if (time_of_day->tm_hour < 0 || time_of_day->tm_hour > 23)
		time_of_day->tm_hour=12;
	SDL_Event event;
	if (fps == -1)
		fps=refresh_rate;
	int request_for_quit=0;
	int count=0;
	
	//砫 ᭮ 横 -   ந 맮  ணࠬ
	while (!request_for_quit)
	{
		Uint32 ticks_begin=SDL_GetTicks(); //६ 砫 । 
		//᫥ न ப
		int player_coordinate=player[0].x*size_labyrinth_length+player[0].y;
		//᫨ ப    ( 孮 ୮  ४⭮ 樠஢) -
		//ந室 堭 ࠭  ६, ࠢ  ६,
		//ॡ㥬  ६饭  ᥤ (易묨) ࠬ (TIME_BETWEEN_HOLES)
		//  ப   ६  ᮢ뢠
		if (player[0].in_hole && (ticks_begin-player[0].trap_start < TIME_BETWEEN_HOLES/2) && black_rect)
		{
			SDL_SetSurfaceAlphaMod(black_rect, (SDL_GetTicks()-player[0].trap_start)*255/(TIME_BETWEEN_HOLES/2));
			printf("%i\n", (int)(SDL_GetTicks()-player[0].trap_start)*255/(TIME_BETWEEN_HOLES/2));
			SDL_BlitSurface(black_rect, NULL, screen, NULL);
			SDL_UpdateWindowSurface(main_window);
		}
		//᫨ ப   ,  諮   ६,
		//ॡ㥬  ६饭  ᥤ (易묨) ࠬ (TIME_BETWEEN_HOLES) -
		//ᮢ  ࠡ⪠ ᮡ⨩  ப த  筮 ०
		else
		{
			//⮢  (ᯮ ࠦ  㦭 浪  ᮮ⢥騬 न⠬)
			/*bitmapTex = SDL_CreateTextureFromSurface(renderer, wall);
			SDL_RenderClear(renderer);
			SDL_RenderCopy(renderer, bitmapTex, NULL, NULL);
			SDL_RenderPresent(renderer);*/
			SDL_Rect srcrect_wall, dstrect_wall;
			//ᮢ 䮭
			SDL_BlitSurface(background, NULL, screen, NULL);
			//᫨ ப ࠢ      ਭ
			if (player[0].direction == UP || player[0].direction == DOWN)
			{
				int sign; //  ࠢ ஭  - ⭮⥫쭮 ப
				//᫨ ப ࠢ    ਭ
				if (player[0].direction == UP)
					sign=1;
				//᫨ ப ࠢ    ਭ
				else
					sign=-1;
				//᫨ । ⥭ ( ⮬ ᫥ ࠩ) - ᮢ ⮣ 䮭  ⥭,  - ᮢ 쭥 
				if ((player[0].x-sign*1) <= 0 || (player_coordinate-sign*size_labyrinth_length) >= size_labyrinth_width*size_labyrinth_length || labyrinth[player_coordinate-sign*size_labyrinth_length] == WALL)
				{
					//SDL_BlitSurface(empty_far_background, NULL, screen, NULL);
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391 empty_background height=391
					SDL_BlitSurface(empty_background, NULL, screen, &dstrect_wall);
					dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
					SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
				}
				else
				{
					//ᮢ    䮭
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-209)/2; //empty_far_background.png height=209
					SDL_BlitSurface(empty_far_background, NULL, screen, &dstrect_wall);
					//ᮢ 쭥 ⥭
					if (labyrinth[player_coordinate-sign*size_labyrinth_length*2] == WALL)
					{
						dstrect_wall.x=(window_width-324)/2; //wall_far width=324
						dstrect_wall.y=(window_height-211)/2; //wall_far height=211
						SDL_BlitSurface(wall_far, NULL, screen, &dstrect_wall);
					}
					//᫨     ⥭ - ᮢ ,  - ᮢ 쭥  ⥭ ( )
					// ᮡ⨩, ᫨ ⠪  (஬ ᮡ⨩    ) 
					if (labyrinth[player_coordinate-sign*size_labyrinth_length-1*sign] == WALL)
					{
						dstrect_wall.x=(window_width-324)/2-109; //wall_far width=324 wall_side_far_left width=109
						dstrect_wall.y=(window_height-391)/2; //wall_side_far_left height=391
						SDL_BlitSurface(wall_side_far_left, NULL, screen, &dstrect_wall);
					}
					else if (labyrinth[player_coordinate-sign*size_labyrinth_length*2-1*sign] == WALL)
					{
						srcrect_wall.x=324-(window_width-324)/2;
						srcrect_wall.y=0;
						srcrect_wall.h=211;
						srcrect_wall.w=(window_width-324)/2;
						dstrect_wall.x=0;
						dstrect_wall.y=(window_height-211)/2;
						SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
						if (labyrinth[player_coordinate-sign*size_labyrinth_length*2-1*sign] != CELL)
						{
							switch (labyrinth[player_coordinate-sign*size_labyrinth_length*2-1*sign])
							{
								case ARSENAL:
									SDL_BlitSurface(arsenal, &srcrect_wall, screen, &dstrect_wall);
									break;
								case HOLE:
									SDL_BlitSurface(hole, &srcrect_wall, screen, &dstrect_wall);
									break;
								case HOSPITAL:
									SDL_BlitSurface(hospital, &srcrect_wall, screen, &dstrect_wall);
									break;
								default:
									break;
							}
						}
					}
					//᫨    ࠢ ⥭ - ᮢ ,  - ᮢ 쭥 ࠢ ⥭ ( )
					if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
					{
						//(window_width-324)/2+324=(window_width-324)/2+648/2=(window_width-324+648)/2=(window_width+324)/2
						dstrect_wall.x=(window_width+324)/2; //wall_far width=324
						dstrect_wall.y=(window_height-393)/2; //wall_side_far_left height=393
						SDL_BlitSurface(wall_side_far_right, NULL, screen, &dstrect_wall);
					}
					else if (labyrinth[player_coordinate-sign*size_labyrinth_length*2+1*sign] == WALL)
					{
						srcrect_wall.x=0;
						srcrect_wall.y=0;
						srcrect_wall.h=211;
						srcrect_wall.w=(window_width-324)/2;
						dstrect_wall.x=window_width-(window_width-324)/2;
						dstrect_wall.y=(window_height-211)/2;
						SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
					}
					//ᮢ 쭨 -ࠧ⥫   ࠢ
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=211; //line.png height=391 wall_far.png height=211
					srcrect_wall.w=1; //line.png width-2
					dstrect_wall.x=(window_width-324)/2; //wall_far.png width=324
					dstrect_wall.y=(window_height-211)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
					dstrect_wall.x=window_width-(window_width-324)/2; //wall_far.png width=324
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨    ⥭ () - ᮢ ,  ந ஢ઠ
				// ⢨ 쭥   ⥭ //FIXME: ୮!
				// ᮢ  । 
				//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
				if (labyrinth[player_coordinate-1*sign] == WALL)
				{
					SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length-1*sign] == WALL)
				{
					srcrect_wall.x=538-(window_width-538)/2;
					srcrect_wall.y=0;
					srcrect_wall.h=391;
					srcrect_wall.w=(window_width-538)/2;
					dstrect_wall.x=0; //wall.png widht=538
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391
					SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨   ࠢ ⥭ () - ᮢ ,  ந ஢ઠ
				// ⢨ 쭥  ࠢ ⥭ //FIXME: ୮!
				// ᮢ  । 
				//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
				if (labyrinth[player_coordinate+1*sign] == WALL)
				{
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
					dstrect_wall.y=0;
					SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
				{
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391;
					srcrect_wall.w=(window_width-538)/2;
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391
					SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨ । 室 - ᮢ ,  ᮮ⢥⢨  ⥪騬  ६
				//(筮 । ६ ⮪ 室  includes_headers;  㤥 ७  䠩 䨣樨/ன)
				//FIXME: ।  浪 ᮢ!
				if (labyrinth[player_coordinate-sign*size_labyrinth_length] == EXIT)
				{
					if (time_of_day->tm_hour >= EVENING && time_of_day->tm_hour < NIGHT)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_evening, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= NIGHT || time_of_day->tm_hour < MORNING)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_night, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= MORNING && time_of_day->tm_hour < DAY)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_morning, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= DAY && time_of_day->tm_hour < EVENING)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_day, NULL, screen, &dstrect_wall);
					}
				}
				if ((labyrinth[player_coordinate-sign*size_labyrinth_length] == TREASURE) || (labyrinth[player_coordinate-sign*size_labyrinth_length] == FAKE_TREASURE))
				{
					dstrect_wall.x=(window_width-302)/2; //big_hole_in_floor.png width=302
					dstrect_wall.y=(window_height+211)/2; //wall.png height=391 wall_far.png height=211
					SDL_BlitSurface(chest, NULL, screen, &dstrect_wall);
				}
				if (labyrinth[player_coordinate-sign*size_labyrinth_length] == HOLE)
				{
					dstrect_wall.x=(window_width-302)/2; //big_hole_in_floor.png width=302
					dstrect_wall.y=(window_height+211)/2; //wall.png height=391 wall_far.png height=211
					//dstrect_wall.h=391;
					//dstrect_wall.w=640;
					SDL_BlitSurface(hole, NULL, screen, &dstrect_wall);
				}
				if (labyrinth[player_coordinate-sign*size_labyrinth_length] == HOSPITAL)
				{
					dstrect_wall.x=(window_width-489)/2; //hospital_far.png width=302
					dstrect_wall.y=window_height/2; //६ 襭
					SDL_BlitSurface(hospital, NULL, screen, &dstrect_wall);
				}
				if (labyrinth[player_coordinate-sign*size_labyrinth_length] == ARSENAL)
				{
					dstrect_wall.x=(window_width-478)/2; //arsenal_boxes.png width=302
					dstrect_wall.y=(window_height-(window_height-391)); //६ 襭; wall.png height=391
					SDL_BlitSurface(arsenal, NULL, screen, &dstrect_wall);
				}
			}
			//᫨ ப ࠢ ࠢ     ਭ
			if (player[0].direction == RIGHT || player[0].direction == LEFT)
			{
				int sign; //  ࠢ ஭  - ⭮⥫쭮 ப
				//᫨ ப ࠢ ࠢ   ਭ
				if (player[0].direction == RIGHT)
					sign=1;
				//᫨ ப ࠢ    ਭ
				else
					sign=-1;
				//᫨ । ⥭  ( ⮬ ᫥ ࠩ) - ᮢ ⮣ 䮭  ⥭,  - ᮢ 쭥 
				if ((player[0].y+1*sign) <= 0 || (player[0].y+1*sign) >= size_labyrinth_length || labyrinth[player_coordinate+1*sign] == WALL)
				{
					//SDL_BlitSurface(empty_far_background, NULL, screen, NULL);
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391 empty_background height=391
					SDL_BlitSurface(empty_background, NULL, screen, &dstrect_wall);
					dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
					SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
				}
				else
				{
					//ᮢ    䮭
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-209)/2; //empty_far_background.png height=209
					SDL_BlitSurface(empty_far_background, NULL, screen, &dstrect_wall);
					//ᮢ 쭥 ⥭
					if (labyrinth[player_coordinate+2*sign] == WALL)
					{
						dstrect_wall.x=(window_width-324)/2; //wall_far width=324
						dstrect_wall.y=(window_height-211)/2; //wall_far height=211
						SDL_BlitSurface(wall_far, NULL, screen, &dstrect_wall);
					}
					//᫨     ⥭ - ᮢ ,  - ᮢ 쭥  ⥭ ( )
					if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
					{
						dstrect_wall.x=(window_width-324)/2-109; //wall_far width=324 wall_side_far_left width=109
						dstrect_wall.y=(window_height-391)/2; //wall_side_far_left height=391
						SDL_BlitSurface(wall_side_far_left, NULL, screen, &dstrect_wall);
					}
					else if (labyrinth[player_coordinate-sign*size_labyrinth_length+2*sign] == WALL)
					{
						srcrect_wall.x=324-(window_width-324)/2;
						srcrect_wall.y=0;
						srcrect_wall.h=211;
						srcrect_wall.w=(window_width-324)/2;
						dstrect_wall.x=0;
						dstrect_wall.y=(window_height-211)/2;
						SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
					}
					//᫨    ࠢ ⥭ - ᮢ ,  - ᮢ 쭥 ࠢ ⥭ ( )
					if (labyrinth[player_coordinate+sign*size_labyrinth_length+1*sign] == WALL)
					{
						//(window_width-324)/2+324=(window_width-324)/2+648/2=(window_width-324+648)/2=(window_width+324)/2
						dstrect_wall.x=(window_width+324)/2; //wall_far width=324
						dstrect_wall.y=(window_height-393)/2; //wall_side_far_left height=393
						SDL_BlitSurface(wall_side_far_right, NULL, screen, &dstrect_wall);
					}
					else if (labyrinth[player_coordinate+sign*size_labyrinth_length+2*sign] == WALL)
					{
						srcrect_wall.x=0;
						srcrect_wall.y=0;
						srcrect_wall.h=211;
						srcrect_wall.w=(window_width-324)/2;
						dstrect_wall.x=window_width-(window_width-324)/2;
						dstrect_wall.y=(window_height-211)/2;
						SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
					}
					//ᮢ 쭨 -ࠧ⥫   ࠢ
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=211; //line.png height=391 wall_far.png height=211
					srcrect_wall.w=1; //line.png width-2
					dstrect_wall.x=(window_width-324)/2; //wall_far.png width=324
					dstrect_wall.y=(window_height-211)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
					dstrect_wall.x=window_width-(window_width-324)/2; //wall_far.png width=324
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨    ⥭ () - ᮢ ,  ந ஢ઠ
				// ⢨ 쭥   ⥭ //FIXME: ୮!
				// ᮢ  । 
				//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
				if (labyrinth[player_coordinate-size_labyrinth_length*sign] == WALL)
				{
					SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
				{
					srcrect_wall.x=538-(window_width-538)/2;
					srcrect_wall.y=0;
					srcrect_wall.h=391;
					srcrect_wall.w=(window_width-538)/2;
					dstrect_wall.x=0; //wall.png widht=538
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391
					SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨   ࠢ ⥭ () - ᮢ ,  ந ஢ઠ
				// ⢨ 쭥  ࠢ ⥭ //FIXME: ୮!
				// ᮢ  । 
				//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
				if (labyrinth[player_coordinate+size_labyrinth_length*sign] == WALL)
				{
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
					dstrect_wall.y=0;
					SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate+sign*size_labyrinth_length+1*sign] == WALL)
				{
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391;
					srcrect_wall.w=(window_width-538)/2;
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
					dstrect_wall.y=(window_height-391)/2; //wall.png height=391
					SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=391; //line.png height=391 wall.png height=391
					srcrect_wall.w=3; //line.png width=3
					dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
					dstrect_wall.y=(window_height-391)/2;
					SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨ । 室 - ᮢ ,  ᮮ⢥⢨  ⥪騬  ६
				//(筮 । ६ ⮪ 室  includes_headers;  㤥 ७  䠩 䨣樨/ன)
				//FIXME: ।  浪 ᮢ!
				if (labyrinth[player_coordinate+1*sign] == EXIT)
				{
					if (time_of_day->tm_hour >= EVENING && time_of_day->tm_hour < NIGHT)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_evening, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= NIGHT || time_of_day->tm_hour < MORNING) //ᯮ짮 , ᪮ NIGHT > MORNING
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_night, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= MORNING && time_of_day->tm_hour < DAY)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_morning, NULL, screen, &dstrect_wall);
					}
					if (time_of_day->tm_hour >= DAY && time_of_day->tm_hour < EVENING)
					{
						dstrect_wall.x=(window_width-538)/2; //exit_*.png widht=538
						dstrect_wall.y=(window_height-394)/2; //exit_*.png height=394
						SDL_BlitSurface(exit_day, NULL, screen, &dstrect_wall);
					}
				}
			}
			//᫨ ப    ( 孮 ୮  ४⭮ 樠஢) -
			//ந室 ⥯  ࠭  ६, ࠢ  ६,
			//ॡ㥬  ६饭  ᥤ (易묨) ࠬ (TIME_BETWEEN_HOLES)
			//  ⮯ ப
			if (player[0].in_hole && (ticks_begin-player[0].trap_start > TIME_BETWEEN_HOLES/2) && (ticks_begin-player[0].trap_start < TIME_BETWEEN_HOLES) && black_rect)
			{
				SDL_SetSurfaceAlphaMod(black_rect, ((SDL_GetTicks()-player[0].trap_start)*255/(TIME_BETWEEN_HOLES/2)*(-1)+255));
				printf("%i\n", (int)((SDL_GetTicks()-player[0].trap_start)*255/(TIME_BETWEEN_HOLES/2)*(-1)+255));
				SDL_BlitSurface(black_rect, NULL, screen, NULL);
			}
			if (player[0].in_trap && (ticks_begin-player[0].trap_start < TIME_IN_TRAP))
			{
				dstrect_wall.x=0; //big_holes_in_ceiling.png width=640
				dstrect_wall.y=(window_height-391)/2-12; //big_holes_in_ceiling.png height=12 wall.png height=391
				SDL_BlitSurface(hole_ceiling, NULL, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.h=400;
				srcrect_wall.w=640;
				if (ticks_begin-player[0].trap_start < 1000) //1 ᥪ㭤  ᪠/ ⪨
				{
					srcrect_wall.y=400-((SDL_GetTicks()-player[0].trap_start)*400/1000); //grate.png height=400
				}
				else if (ticks_begin-player[0].trap_start > TIME_IN_TRAP-1000) //1 ᥪ㭤  ᪠/ ⪨
				{
					srcrect_wall.y=((SDL_GetTicks()-player[0].trap_start)*400/1000)-400*2;
				}
				else
					srcrect_wall.y=0;
				SDL_BlitSurface(grate, &srcrect_wall, screen, &dstrect_wall);
				//SDL_UpdateWindowSurface(main_window);
			}
			//~ SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
			//~ dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
			//~ dstrect_wall.y=0;
			//~ SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
			//~ dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
			//~ dstrect_wall.y=(window_height-391)/2; //wall.png height=391
			//SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
			//뢮   ࠭
			SDL_UpdateWindowSurface(main_window);
			//SDL_Delay(3000);
			// ⢨ ப
			while (SDL_PollEvent(&event))
			{
				//᫨ ந 맮  ணࠬ  稭   ணࠬ -
				//ந 襭 ࠡ ணࠬ
				if (event.type == SDL_QUIT)
					request_for_quit=1;
				//᫨ ப  ESC - ந 襭 ࠡ ணࠬ
				if (event.type == SDL_KEYDOWN)
				{
					switch (event.key.keysym.sym)
					{
						case SDLK_ESCAPE:
							request_for_quit=1;
							break;
						// 㧠    "p" (.)
						case SDLK_p:
							do
							{
								SDL_WaitEvent(&event);
								//㧠    室  ਫ
								//(    "ESC", ⠪     ਫ
								if (event.type == SDL_QUIT || event.key.keysym.sym == SDLK_ESCAPE)
								{
									request_for_quit=1;
									break;
								}
							}
							while (event.type != SDL_KEYDOWN || event.key.keysym.sym != SDLK_p);
					}
				}
				//TODO:  饥 -  
				/*if (player[0].in_trap)
				{
					if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
						break;
					else
						player[0].in_trap=0;
				}
				if (player[0].in_hole)
				{
					if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
						break;
					else
						player[0].in_hole=0;
				}
				if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
					break;*/
				if (event.type == SDL_KEYDOWN && !request_for_quit)
				{
					//⠭ 祭 祩  ﭨ   㤠 ⭨
					labyrinth[player_coordinate]=player[0].previous_cell_state;
					/*switch (event.key.keysym.scancode)
					{
						case SDL_SCANCODE_ESCAPE:
							request_for_quit=1;
							break;
					}*/
					switch (event.key.keysym.sym)
					{
						//室   ESC ७ 
						/*case SDLK_ESCAPE:
							request_for_quit=1;
							break;*/
						//᫨ ப   ५ ""  "",  WS - 
						//ந ஢ઠ,  ⠥  ப ன  室  ਭ - 
						// ⮬ 砥   㤥 襭 ⢥ত  室
						// ⨢ 砥, ந  न ப   ஭
						//(᫨ ப  ⠥ ன ᪢ ⥭,  ⮬ ᫥ ࠩ)
						//᫥ ⮣ ந ஢ઠ  ⢨ ᮡ  祩,    ப
						//( ᮮ⢥騬 ⢨ﬨ - ᠭ  㭪樨 checking_for_events)
						//᫨ ப   ""  "ࠢ",  AD - 
						//ந  ࠢ,  ஬ ᬮ ப
						//(0 - , 1 - ࠢ, 2 - , 3 - )
						//   Shift  "", "ࠢ", A  D  ᬥ  ᮮ⢥ ஭
						//( )
						// ।   ப ஫ ⠩஬
						//१ SDL_GetTicks()  ன SPEED_MOVE  SPEED_TURN
						case SDLK_UP:
						case SDLK_w:
							if (player[0].in_trap)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
									break;
								else
									player[0].in_trap=0;
							}
							if (player[0].in_hole)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
									break;
								else
									player[0].in_hole=0;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
								break;
							switch (player[0].direction)
							{
								case UP:
									if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x-1;
										player[0].step_start=SDL_GetTicks();
										//஢ઠ  ᮡ  祩,    ⭨
										checking_for_events(main_window, screen, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										/*switch (labyrinth[player_coordinate-size_labyrinth_length])
										{
											case TREASURE:
												player[0].has_treasure=1;
												labyrinth[player_coordinate-size_labyrinth_length]=CELL;
												break;
											case FAKE_TREASURE:
												player[0].has_fake_treasure=1;
												labyrinth[player_coordinate-size_labyrinth_length]=CELL;
												break;
											case HOLE:
												player[0].in_hole=1;
												break;
											case TRAP:
												player[0].in_trap=1;
												break;
											case HOSPITAL:
												if (player[0].is_wounded)
													player[0].is_wounded=0;
												break;
											case ARSENAL:
												player[0].has_weapon=1;
												break;
											default:
												break;
										}*/
										break;
									}
									break;
								case RIGHT:
									if (labyrinth[player_coordinate+1] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
									{
										player[0].y=player[0].y+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case DOWN:
									if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case LEFT:
									if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
									{
										player[0].y=player[0].y-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
							}
							break;
						case SDLK_DOWN:
						case SDLK_s:
							if (player[0].in_trap)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
									break;
								else
									player[0].in_trap=0;
							}
							if (player[0].in_hole)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
									break;
								else
									player[0].in_hole=0;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
								break;
							switch (player[0].direction)
							{
								case UP:
									if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case RIGHT:
									if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
									{
										player[0].y=player[0].y-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case DOWN:
									if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case LEFT:
									if (labyrinth[player_coordinate+1] == EXIT && request_for_exit(main_window, player) )
									{
										request_for_quit=1;
										break;
									}
									if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
									{
										player[0].y=player[0].y+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, screen, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
							}
							break;
						case SDLK_LEFT:
						case SDLK_a:
							//~ if (player[0].direction == 0)
								//~ player[0].direction=3;
							//~ break;
							//~ player[0].direction=player[0].direction-1;
							//~ break;
							//  Shift ந ᤢ  ( )
							if (SDL_GetModState() && KMOD_SHIFT)
							{
								if (player[0].in_trap)
								{
									if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
										break;
									else
										player[0].in_trap=0;
								}
								if (player[0].in_hole)
								{
									if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
										break;
									else
										player[0].in_hole=0;
								}
								if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
									break;
								switch (player[0].direction)
								{
									case UP:
										//if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
										if (labyrinth[player_coordinate-1] == EXIT)
										{
											//뭥ᥭ  ⤥쭮 ᫮, ᫥ ண  㫥  mod  SDL_Keysym
											// ⨢ 砥,  室   ᫮,  믮 
											//( ⪠ ப   ), ﭨ  Shift ࠭﫮  "",
											// ᨬ   ⢨⥫쭮 ﭨ
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
										{
											player[0].y=player[0].y-1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case RIGHT:
										if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
										{
											player[0].x=player[0].x-1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case DOWN:
										if (labyrinth[player_coordinate+1] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
										{
											player[0].y=player[0].y+1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case LEFT:
										if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
										{
											player[0].x=player[0].x+1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
								}
								break;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_TURN)
								break;
							if (player[0].direction == UP)
								player[0].direction=LEFT;
							else
								player[0].direction=player[0].direction-1;
							player[0].step_start=SDL_GetTicks();
							break;
						case SDLK_RIGHT:
						case SDLK_d:
							//  Shift ந ᤢ ࠢ ( )
							if (SDL_GetModState() && KMOD_SHIFT)
							{
								if (player[0].in_trap)
								{
									if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
										break;
									else
										player[0].in_trap=0;
								}
								if (player[0].in_hole)
								{
									if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
										break;
									else
										player[0].in_hole=0;
								}
								if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
									break;
								switch (player[0].direction)
								{
									case UP:
										if (labyrinth[player_coordinate+1] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
										{
											player[0].y=player[0].y+1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case RIGHT:
										if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
										{
											player[0].x=player[0].x+1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case DOWN:
										if (labyrinth[player_coordinate-1] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
										{
											player[0].y=player[0].y-1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
									case LEFT:
										if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT)
										{
											if (request_for_exit(main_window, player) )
											{
												request_for_quit=1;
												break;
											}
											SDL_SetModState(KMOD_NONE);
										}
										if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
										{
											player[0].x=player[0].x-1;
											player[0].step_start=SDL_GetTicks();
											checking_for_events(main_window, screen, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
											break;
										}
										break;
								}
								break;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_TURN)
								break;
							if (player[0].direction == LEFT)
								player[0].direction=UP;
							else
								player[0].direction=player[0].direction+1;
							player[0].step_start=SDL_GetTicks();
							break;
					}
				}
			}
			//।饥 ﭨ ⪨ ࠭  ᫥饣 ⠭
			if (labyrinth[player[0].x*size_labyrinth_length+player[0].y] != PLAYER)
			{
				player[0].previous_cell_state=labyrinth[player[0].x*size_labyrinth_length+player[0].y];
				labyrinth[player[0].x*size_labyrinth_length+player[0].y]=PLAYER;
			}
		}
		// ⫠  ஫ १ ᮫
		if (debug)
			show_labyrinth_in_cmd(player_coordinate, player, size_labyrinth_length, size_labyrinth_width, labyrinth);
		//᫨   砫 ࠡ⪨  諮  ६,
		//祬 ॡ   祭 FPS - ࠡ⪠ ਮ⠭  ⮪ ॡ㥬 ६
		if ((SDL_GetTicks()-ticks_begin) < (1000/FPS))
			SDL_Delay((1000/FPS)-(SDL_GetTicks()-ticks_begin));
		count++;
		//char *dir[]={"", "ࠢ", "", ""};
		//printf("\rcell: %i  x: %i  y: %i  dir: %s  ", player_coordinate, player[0].x, player[0].y, dir[player[0].direction]);
	}
	printf("\n஢: %i ᥪ㭤: %i FPS: %.2f\n", count, SDL_GetTicks(), (float)count/SDL_GetTicks()*1000);

	//TODO: ७  clean_up_sdl()
	SDL_FreeSurface(background);
	SDL_FreeSurface(wall);
	SDL_FreeSurface(wall_side_left);
	SDL_FreeSurface(wall_side_right);
	SDL_FreeSurface(wall_far);
	SDL_FreeSurface(wall_side_far_left);
	SDL_FreeSurface(wall_side_far_right);
	SDL_FreeSurface(line);
	SDL_FreeSurface(empty_background);
	SDL_FreeSurface(empty_far_background);
	SDL_FreeSurface(exit_morning);
	SDL_FreeSurface(exit_day);
	SDL_FreeSurface(exit_evening);
	SDL_FreeSurface(exit_night);
	SDL_FreeSurface(black_rect);
/*	IMG_Quit();
	//SDL_DestroyTexture(bitmapTex);
    //SDL_DestroyRenderer(renderer);
	SDL_DestroyWindow(main_window);
	SDL_Quit();*/
	clean_up_sdl(main_window);
	return 0;
}

int request_for_exit(SDL_Window *main_window, const struct players player[])
{
	//TODO:  ᮡ⢥ ॠ  뢮 ਫ
    SDL_MessageBoxButtonData buttons_exit[] = { { 0, 0, "Yes" }, { SDL_MESSAGEBOX_BUTTON_ESCAPEKEY_DEFAULT, 1, "No" }, };
	SDL_MessageBoxData message_box_exit={SDL_MESSAGEBOX_WARNING , main_window, "", "Quit labyrinth? It will end game.", 2, buttons_exit, NULL};
	SDL_MessageBoxData message_box_treasure={SDL_MESSAGEBOX_WARNING , main_window, "", "You have not found treasure. Quit anyway?", 2, buttons_exit, NULL};
	SDL_MessageBoxButtonData buttons_fake_treasure[] = { { SDL_MESSAGEBOX_BUTTON_ESCAPEKEY_DEFAULT, 0, "Yes" }, { 0, 1, "No" }, };
	SDL_MessageBoxData message_box_fake_treasure={SDL_MESSAGEBOX_WARNING , main_window, "", "You have found fake treasure. Want to return?", 2, buttons_fake_treasure, NULL};
	int button_id;
	if (SDL_ShowMessageBox(&message_box_exit, &button_id) < 0)
	{
        SDL_Log("Error displaying message box");
        return 1;
    }
	if (button_id == -1)
	{
        SDL_Log("no selection");
    }
    else
    {
        if (!button_id)
		{
			if (!player[0].has_treasure && !player[0].has_fake_treasure)
			{
				SDL_ShowMessageBox(&message_box_treasure, &button_id);
				if (!button_id)
					return 1;
			}
			if (player[0].has_fake_treasure)
			{
				SDL_ShowMessageBox(&message_box_fake_treasure, &button_id);
				if (button_id)
					return 1;
			}
			if (player[0].has_treasure)
			{
				SDL_ShowSimpleMessageBox(SDL_MESSAGEBOX_INFORMATION, "Victory", "Congratulations! You have found treasure!", main_window);
				return 1;
			}
		}
    }
	return 0;
}

//४⭮ 襭 ࠡ SDL
void clean_up_sdl(SDL_Window *main_window)
{
	//~ SDL_FreeSurface(background);
	//~ SDL_FreeSurface(wall);
	//~ SDL_FreeSurface(wall_side_left);
	//~ SDL_FreeSurface(wall_side_right);
	//~ SDL_FreeSurface(wall_far);
	//~ SDL_FreeSurface(wall_side_far_left);
	//~ SDL_FreeSurface(wall_side_far_right);
	//~ SDL_FreeSurface(line);
	//~ SDL_FreeSurface(empty_background);
	//~ SDL_FreeSurface(empty_far_background);	
	IMG_Quit();
	if (main_window != NULL)
		SDL_DestroyWindow(main_window);
	//Uint32 SDL_WasInit(Uint32 flags)
	SDL_Quit();
	return;
}

void show_labyrinth_in_cmd(int const player_coordinate, const struct players player[], short int const length, short int const width, int const *labyrinth_temp)
{
	for (int j = 0; j < width; j++)
	{
		for (int k = 0; k < length; k++)
		{
			//0 -  ⪠, 1 - ⥭, 2 -   ⪠, 3 -   ᮯ୨, 4 - ப, 5 - 室
			//6 - , 7 -  , 8 - , 9 - 誠, 10 - ᯨ⠫, 11 - ᥭ
			if (!labyrinth_temp[(j*length)+k])
				printf("%s", "  ");
			if (labyrinth_temp[(j*length)+k] == WALL)
				printf("%s", " X");
			if (labyrinth_temp[(j*length)+k] == DUMMY)
				printf("%s", " .");
			if (labyrinth_temp[(j*length)+k] == RIVAL)
				printf("%s", " p");
			if (labyrinth_temp[(j*length)+k] == PLAYER)
			{
				//0 - , 1 - ࠢ, 2 - , 3 - 
				if (!player[0].direction)
					printf("%s", " ^");
				if (player[0].direction == RIGHT)
					printf("%s", " >");
				if (player[0].direction == DOWN)
					printf("%s", " v");
				if (player[0].direction == LEFT)
					printf("%s", " <");
			}
			if (labyrinth_temp[(j*length)+k] == EXIT)
				printf("%s", " e");
			if (labyrinth_temp[(j*length)+k] == TREASURE)
				printf("%s", " T");
			if (labyrinth_temp[(j*length)+k] == FAKE_TREASURE)
				printf("%s", " F");
			if (labyrinth_temp[(j*length)+k] == HOLE)
				printf("%s", " O");
			if (labyrinth_temp[(j*length)+k] == TRAP)
				printf("%s", " #");
			if (labyrinth_temp[(j*length)+k] == HOSPITAL)
				printf("%s", " H");
			if (labyrinth_temp[(j*length)+k] == ARSENAL)
				printf("%s", " A");
		}
		if (j == 0)
			printf("  %s%i", "cell:", player_coordinate);
		if (j == 1)
			printf("  %s%i %s%i", "x=", player[0].x, "y=", player[0].y);
		if (j == 2)
		{
			char *dir[]={"", "ࠢ", "", ""};
			printf("  %s%s", "dir:", dir[player[0].direction]);
		}
		if (j == 3)
			printf("  %s", "T F W @ H # (h) (t)");
		if (j == 4)
			printf("  %i %i %i %i %i %i %li %i", player[0].has_treasure, player[0].has_fake_treasure, player[0].has_weapon, player[0].is_wounded, player[0].in_hole, player[0].in_trap, TIME_IN_TRAP-(SDL_GetTicks()-player[0].trap_start), (int)player[0].trap_start);
		printf("%s", "\n");
	}
	printf("%s", "\n");
	return;
}
