/*  sdl_main_hwsw.c

  ਭ
  Version 0.3.1

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "SDL2\SDL.h"
#include "SDL2\SDL_image.h"
#include "includes_macros.h"

void show_labyrinth_in_cmd_hw(int const player_coordinate, const struct players player[], short int const length, short int const width, int const *labyrinth_temp); // ⫠  ஫ १ ᮫

void checking_for_events(SDL_Window *main_window, SDL_Surface *screen, int const coordinate, struct players player[], int *labyrinth, short int const size_labyrinth_length, short int const holes, short int const *holes_array);

int request_for_exit(SDL_Window *main_window, const struct players player[]);

void clean_up_sdl_hw(SDL_Window *main_window, SDL_Renderer *renderer);

int sdl_main_hwsw(int *labyrinth, struct players player[], short int const rivals, short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, short int window_height, short int window_width, short int fullscreen, short int refresh_rate, short int fps, short int hw_accel, short int vsync, short int trap_time, short int hole_time, short int speed, short int turn_speed, short int const debug, FILE *settings, char const *settings_filename)
//~ int sdl_main_hwsw(int *labyrinth, struct players player[], short int const size_labyrinth_length, short int const size_labyrinth_width, short int const holes, short int const *holes_array, int requested_mode)
{
	//  樠 প   㤨
    if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) < 0)
    {
		SDL_Log("Unable to initialize SDL: %s", SDL_GetError());
		return 1;
    }
    // ᭮ 
    SDL_Window *main_window=NULL;
    //祭 祭 ⥪饣 ० ࠭ (ᯫ) 0
    SDL_DisplayMode desktop_display0_mode;
    SDL_GetDesktopDisplayMode(0, &desktop_display0_mode);
    //᫨ ਫ  ᪠  ࠭ ० - ந ஢ઠ
    // 㯭 ৥襭 ࠭, 室饣   祭   ਭ 
    if (fullscreen)
    {
		SDL_DisplayMode other_display_mode;
		int modes_number=SDL_GetNumDisplayModes(0);
		unsigned char *suited_dm=(unsigned char*)calloc(modes_number+1, sizeof( unsigned char ));
		if (suited_dm)
		{
			//᫥ ⢠ 㯭 ०   ࠧ襭
			for (int i = 0; i < modes_number; i++)
			{
				SDL_GetDisplayMode(0, i, &other_display_mode);
				if (other_display_mode.h == window_height && other_display_mode.w == window_width)
				{
					suited_dm[0]++;
					suited_dm[(int)suited_dm[0]]=i;
				}
			}
			//᫨  祭  ᮮ⢥    㯭 ० -
			//ந ⪠ ᪠   室饣 ०
			if (!(int)suited_dm[0])
			{
				puts(" ࠧ襭  ন ᯮ㥬 ஬.");
				SDL_DisplayMode whished_display_mode;
				whished_display_mode.h=window_height;
				whished_display_mode.w=window_width;
				if (SDL_GetClosestDisplayMode(0, &whished_display_mode, &other_display_mode))
				{
					whished_display_mode.h=other_display_mode.h;
					whished_display_mode.w=other_display_mode.w;
					for (int i = 0; i < modes_number; i++)
					{
						SDL_GetDisplayMode(0, i, &other_display_mode);
						if (other_display_mode.h == whished_display_mode.h && other_display_mode.w == whished_display_mode.w)
						{
							suited_dm[0]++;
							suited_dm[(int)suited_dm[0]]=i;
						}
					}
					if ((int)suited_dm[0] == 1)
						printf("㤥 ᯮ짮   室饥 ࠧ襭: %ix%i.\n", whished_display_mode.w, whished_display_mode.h);
				}
				//᫨ ⮬᪨   室饣 ०  㤠 -
				//㤥 ந ⡮  㯭
				//砫 ந ஢ઠ  ࠧ 
				//(     ,  뫨   ᪥),
				//⥬ -  㡨 梥⮯।  祭   ࠭
				//(㤥 ࠭ ०,  ண     ࠧ )
				else
				{
					short int current_refresh_rate=0;
					short int current_bpp=0;
					for (int i = 0; i < modes_number; i++)
					{
						SDL_GetDisplayMode(0, i, &other_display_mode);
						if (other_display_mode.h <= window_height && other_display_mode.w <= window_width)
						{
							if ((SDL_BITSPERPIXEL(other_display_mode.format) >= current_bpp) \
							&& (other_display_mode.refresh_rate >= current_refresh_rate))
							{
								current_refresh_rate=other_display_mode.refresh_rate;
								current_bpp=SDL_BITSPERPIXEL(other_display_mode.format);
								suited_dm[0]++;
								suited_dm[(int)suited_dm[0]]=i;
							}
						}
					}
				}
			}
			//᫨  ᪮쪮 室 ० -
			//㤥 ࠭ ⠪,  ண  㡨 梥⮯।,   ࠭  ࠧ襭 (ࠧ )
			//(᫨  ⠪ ᮢ - 㤥 ࠭  㯭 ०)
			if ((int)suited_dm[0] > 1)
			{
				char check=1;
				short int max_num=0;
				short int max_num_2=0;
				//ᠭ   ᫥ 㯭 ०
				struct suited_modes{
					unsigned char number; // ०, 뤠 SDL
					short int height; // 
					short int width; //ਭ 
					short int bpp; //㡨 梥⮯।
					short int refresh_rate; //  ࠭
					struct suited_modes *next_mode; //㪠⥫  ᫥㨩  ()
				};
				struct suited_modes *video_modesPtr=NULL;
				struct suited_modes *video_modes_lastPtr=NULL;
				struct suited_modes *video_modes_previousPtr=NULL;
				video_modesPtr=calloc(1, sizeof(struct suited_modes));
				video_modes_lastPtr=video_modesPtr;
				video_modes_previousPtr=video_modesPtr;
				if (!video_modesPtr)
					check=0;
				if (check)
				{
					//  祭ﬨ ⮡࠭ ०
					for (int i = 0; i < (int)suited_dm[0]; i++)
					{
						SDL_GetDisplayMode(0, (int)suited_dm[i+1], &other_display_mode);
						video_modes_previousPtr->number=suited_dm[i+1];
						video_modes_previousPtr->height=other_display_mode.h;
						video_modes_previousPtr->width=other_display_mode.w;
						video_modes_previousPtr->bpp=SDL_BITSPERPIXEL(other_display_mode.format);
						video_modes_previousPtr->refresh_rate=other_display_mode.refresh_rate;
						video_modes_lastPtr=calloc(1, sizeof(struct suited_modes));
						if (!video_modes_lastPtr)
						{
							check=0;
							break;
						}
						video_modes_previousPtr->next_mode=video_modes_lastPtr;
						video_modes_previousPtr=video_modes_lastPtr;
					}
				}
				if (check)
				{
					//⡮ ०  襩 㡨 梥⮯।
					//⠫ ०  襭   쭥 ⡮ ⢮  
					max_num=video_modesPtr->bpp;
					video_modes_lastPtr=video_modesPtr;
					//~ for (int i = 0; i < (int)suited_dm[0]; i++)
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->bpp > max_num)
							max_num=video_modes_lastPtr->bpp;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					//~ for (int i = 0; i < (int)suited_dm[0]; i++)
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->bpp != max_num)
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					//⡮ ०  襩 ⮩  ࠭
					//⠫ ०  襭   쭥 ⡮ ⢮  
					max_num=video_modesPtr->refresh_rate;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->refresh_rate > max_num)
							max_num=video_modes_lastPtr->refresh_rate;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if (video_modes_lastPtr->refresh_rate != max_num)
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					//⡮ ०   ࠧ襭 (ࠧ஬ )
					//⠫ ०  襭
					max_num=video_modesPtr->height;
					max_num_2=video_modesPtr->width;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if ((video_modes_lastPtr->height >= max_num) && (video_modes_lastPtr->width >= max_num_2))
						{
							max_num=video_modes_lastPtr->height;
							max_num_2=video_modes_lastPtr->width;
						}
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
					video_modes_previousPtr=video_modesPtr;
					video_modes_lastPtr=video_modesPtr;
					while (video_modes_lastPtr)
					{
						if ((video_modes_lastPtr->height != max_num) && (video_modes_lastPtr->width != max_num_2))
						{
							if (video_modes_lastPtr == video_modesPtr)
								video_modesPtr=video_modesPtr->next_mode;
							video_modes_previousPtr->next_mode=video_modes_lastPtr->next_mode;
						}
						if (video_modes_previousPtr != video_modes_lastPtr)
							video_modes_previousPtr=video_modes_lastPtr;
						video_modes_lastPtr=video_modes_lastPtr->next_mode;
					}
				}
				//᫨ ।騥 ⡮ 諨 ᯥ譮
				//(    易 ᯨ᪮  뫠 ᯥ譮 뤥),
				// ந   ⠢襣 ०
				//( ࢮ  ⠢ -       ࠪ᪨ 묨)
				// 㪠뢠,  室騩 ०   
				if (!check)
					suited_dm[0]=0;
				else
				{
					suited_dm[0]=1;
					suited_dm[1]=video_modesPtr->number;
				}
				SDL_GetDisplayMode(0, (int)suited_dm[1], &other_display_mode);
				puts(" ᪮쪮 室 ०.");
				printf("㤥 ᯮ짮   室饥 ࠧ襭: %ix%i\n", other_display_mode.w, other_display_mode.h);
			}
			//᫨ 室騩 ० ⠪     - 㤥 ᯮ짮
			//⥪饥 ࠧ襭 樮 ⥬ (ࠧ襭 ࠡ祣 ⮫)
			if (!(int)suited_dm[0])
			{
				printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
				window_height=desktop_display0_mode.h;
				window_width=desktop_display0_mode.w;
				refresh_rate=desktop_display0_mode.refresh_rate;
				main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN_DESKTOP);
			}
			//᫨ 室騩 ०  - 㤥 ᯮ짮  
			SDL_GetDisplayMode(0, (int)suited_dm[1], &other_display_mode);
			window_height=other_display_mode.h;
			window_width=other_display_mode.w;
			refresh_rate=other_display_mode.refresh_rate;
			main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN);
			free(suited_dm);
			suited_dm=NULL;
		}
		//᫨  㤠 뤥   ᪠ ন ० -
		//㤥 ᯮ짮 ⥪饥 ࠧ襭 樮 ⥬ (ࠧ襭 ࠡ祣 ⮫)
		else
		{
			puts("訡   ⠭ ࠧ襭 ࠭.");
			printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
			window_height=desktop_display0_mode.h;
			window_width=desktop_display0_mode.w;
			refresh_rate=desktop_display0_mode.refresh_rate;
			main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, SDL_WINDOW_FULLSCREEN_DESKTOP);
		}
	}
	else
	{
		//  ० 㤥 ந ஢ઠ  ४⭮ 祭 ⭮⥫쭮 ࠧ஢ ࠭
		if (window_height > desktop_display0_mode.h || window_width > desktop_display0_mode.w)
		{
			puts(" ࠧ襭  ࠧ ࠭");
			printf("㤥 ᯮ짮 ࠧ襭 ࠭,  樮 ⥬:  %ix%i\n", desktop_display0_mode.w, desktop_display0_mode.h);
			window_height=desktop_display0_mode.h;
			window_width=desktop_display0_mode.w;
		}
	    main_window=SDL_CreateWindow("Labyrinth", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, window_width, window_height, 0);
	}
    if (main_window == NULL)
    {
		SDL_Log("Could not create window: %s\n", SDL_GetError());
		clean_up_sdl_hw(NULL, NULL);
		return 1;
	}
	SDL_Renderer *renderer = NULL;
	//~ if (requested_mode == 1)
	if (!hw_accel && !vsync)
		renderer = SDL_CreateRenderer(main_window, -1, SDL_RENDERER_SOFTWARE);
	//~ else if (requested_mode == 2)
	else if (!hw_accel && vsync)
		renderer = SDL_CreateRenderer(main_window, -1, SDL_RENDERER_SOFTWARE || SDL_RENDERER_PRESENTVSYNC);
	//~ else if (requested_mode == 3)
	else if (hw_accel && !vsync)
		renderer = SDL_CreateRenderer(main_window, -1, SDL_RENDERER_ACCELERATED);
	//~ else if (requested_mode == 4)
	else if (hw_accel && vsync)
		renderer = SDL_CreateRenderer(main_window, -1, SDL_RENDERER_ACCELERATED || SDL_RENDERER_PRESENTVSYNC);
	if (renderer == NULL)
	{
		SDL_Log("Could not create renderer: %s\n", SDL_GetError());
		clean_up_sdl_hw(main_window, NULL);
	}
	SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
	//樠 孮 
	//SDL_Surface *screen=NULL;
	//screen=SDL_GetWindowSurface(main_window);
	//㧪 ᪨ ᮢ
	if (IMG_Init(IMG_INIT_PNG) != IMG_INIT_PNG)
	{
		printf("IMG_Init: Failed to init required png support!\n");
		printf("IMG_Init: %s\n", IMG_GetError());
		clean_up_sdl_hw(main_window, renderer);
		return 1;
	}
	SDL_Surface *background_sf=NULL;
	SDL_Surface *wall_sf=NULL;
	SDL_Surface *wall_side_left_sf=NULL;
	SDL_Surface *wall_side_right_sf=NULL;
	SDL_Surface *wall_far_sf=NULL;
	SDL_Surface *wall_side_far_left_sf=NULL;
	SDL_Surface *wall_side_far_right_sf=NULL;
	SDL_Surface *line_sf=NULL;
	SDL_Surface *empty_background_sf=NULL;
	SDL_Surface *empty_far_background_sf=NULL;
	SDL_Surface *exit_morning_sf=NULL;
	SDL_Surface *exit_day_sf=NULL;
	SDL_Surface *exit_evening_sf=NULL;
	SDL_Surface *exit_night_sf=NULL;
	
	background_sf=IMG_Load("gfx/background.png");
	wall_sf=IMG_Load("gfx/wall.png");
	wall_side_left_sf=IMG_Load("gfx/wall_side_left.png");
	wall_side_right_sf=IMG_Load("gfx/wall_side_right.png");
	wall_far_sf=IMG_Load("gfx/wall_far.png");
	wall_side_far_left_sf=IMG_Load("gfx/wall_side_far_left.png");
	wall_side_far_right_sf=IMG_Load("gfx/wall_side_far_right.png");
	line_sf=IMG_Load("gfx/line.png");
	empty_background_sf=IMG_Load("gfx/empty_background.png");
	empty_far_background_sf=IMG_Load("gfx/empty_far_background.png");
	exit_morning_sf=IMG_Load("gfx/exit_morning.png");
	exit_day_sf=IMG_Load("gfx/exit_day.png");
	exit_evening_sf=IMG_Load("gfx/exit_evening.png");
	exit_night_sf=IMG_Load("gfx/exit_night.png");
	//᫨  㤠 㧨 - 䠩 - 뢥 ᮮ饭  訡  㪠 ᫥  㦥 䠩
	if (!background_sf || !wall_sf || !wall_side_left_sf || !wall_side_right_sf || !wall_far_sf || !wall_side_far_left_sf || !wall_side_far_right_sf || !line_sf || !empty_background_sf || !empty_far_background_sf || !exit_morning_sf || !exit_day_sf || !exit_evening_sf || !exit_night_sf)
	{
		printf("IMG_Load: %s\n", IMG_GetError());
		clean_up_sdl_hw(main_window, renderer);
		return 1;
	}
	SDL_Texture *background=NULL;
	SDL_Texture *wall=NULL;
	SDL_Texture *wall_side_left=NULL;
	SDL_Texture *wall_side_right=NULL;
	SDL_Texture *wall_far=NULL;
	SDL_Texture *wall_side_far_left=NULL;
	SDL_Texture *wall_side_far_right=NULL;
	SDL_Texture *line=NULL;
	SDL_Texture *empty_background=NULL;
	SDL_Texture *empty_far_background=NULL;
	SDL_Texture *exit_morning=NULL;
	SDL_Texture *exit_day=NULL;
	SDL_Texture *exit_evening=NULL;
	SDL_Texture *exit_night=NULL;
	
	background=SDL_CreateTextureFromSurface(renderer, background_sf);
	wall=SDL_CreateTextureFromSurface(renderer, wall_sf);
	wall_side_left=SDL_CreateTextureFromSurface(renderer, wall_side_left_sf);
	wall_side_right=SDL_CreateTextureFromSurface(renderer, wall_side_right_sf);
	wall_far=SDL_CreateTextureFromSurface(renderer, wall_far_sf);
	wall_side_far_left=SDL_CreateTextureFromSurface(renderer, wall_side_far_left_sf);
	wall_side_far_right=SDL_CreateTextureFromSurface(renderer, wall_side_far_right_sf);
	line=SDL_CreateTextureFromSurface(renderer, line_sf);
	empty_background=SDL_CreateTextureFromSurface(renderer, empty_background_sf);
	empty_far_background=SDL_CreateTextureFromSurface(renderer, empty_far_background_sf);
	exit_morning=SDL_CreateTextureFromSurface(renderer, exit_morning_sf);
	exit_day=SDL_CreateTextureFromSurface(renderer, exit_day_sf);
	exit_evening=SDL_CreateTextureFromSurface(renderer, exit_evening_sf);
	exit_night=SDL_CreateTextureFromSurface(renderer, exit_night_sf);
	
	//᫨  㤠 㧨 - ⥪ - 뢥 ᮮ饭  訡
	if (!background || !wall || !wall_side_left || !wall_side_right || !wall_far || !wall_side_far_left || !wall_side_far_right || !line || !empty_background || !empty_far_background || !exit_morning || !exit_day || !exit_evening || !exit_night)
	{
		printf("IMG_Load: %s\n", IMG_GetError());
		SDL_FreeSurface(background_sf);
		SDL_FreeSurface(wall_sf);
		SDL_FreeSurface(wall_side_left_sf);
		SDL_FreeSurface(wall_side_right_sf);
		SDL_FreeSurface(wall_far_sf);
		SDL_FreeSurface(wall_side_far_left_sf);
		SDL_FreeSurface(wall_side_far_right_sf);
		SDL_FreeSurface(line_sf);
		SDL_FreeSurface(empty_background_sf);
		SDL_FreeSurface(empty_far_background_sf);
		SDL_FreeSurface(exit_morning_sf);
		SDL_FreeSurface(exit_day_sf);
		SDL_FreeSurface(exit_evening_sf);
		SDL_FreeSurface(exit_night_sf);
		SDL_DestroyTexture(background);
		SDL_DestroyTexture(wall);
		SDL_DestroyTexture(wall_side_left);
		SDL_DestroyTexture(wall_side_right);
		SDL_DestroyTexture(wall_far);
		SDL_DestroyTexture(wall_side_far_left);
		SDL_DestroyTexture(wall_side_far_right);
		SDL_DestroyTexture(line);
		SDL_DestroyTexture(empty_background);
		SDL_DestroyTexture(empty_far_background);
		SDL_DestroyTexture(exit_morning);
		SDL_DestroyTexture(exit_day);
		SDL_DestroyTexture(exit_evening);
		SDL_DestroyTexture(exit_night);
		clean_up_sdl_hw(main_window, renderer);
		return 1;
	}
	SDL_FreeSurface(background_sf);
	SDL_FreeSurface(wall_sf);
	SDL_FreeSurface(wall_side_left_sf);
	SDL_FreeSurface(wall_side_right_sf);
	SDL_FreeSurface(wall_far_sf);
	SDL_FreeSurface(wall_side_far_left_sf);
	SDL_FreeSurface(wall_side_far_right_sf);
	SDL_FreeSurface(line_sf);
	SDL_FreeSurface(empty_background_sf);
	SDL_FreeSurface(empty_far_background_sf);
	SDL_FreeSurface(exit_morning_sf);
	SDL_FreeSurface(exit_day_sf);
	SDL_FreeSurface(exit_evening_sf);
	SDL_FreeSurface(exit_night_sf);
	
	//祭 祭 ⥪饣 쭮 ६  ⮡ࠦ ᮮ⢥饣 ਠ ࠦ 室  ਭ
	//(, ⮨ ७  ᭮ 横  ঠ 㠫 ,
	//  ᮬ ⭮⥫쭮 ந⥫쭮  室   )
	time_t local_rawtime=time(NULL);
	struct tm *time_of_day;
	time_of_day=localtime(&local_rawtime);
	//᫨ -  祭 ६   ⠪ - ⠭ 祭  㬮砭 ()
	if (time_of_day->tm_hour < 0 || time_of_day->tm_hour > 23)
		time_of_day->tm_hour=12;
	SDL_Event event;
	if (fps == -1)
		fps=refresh_rate;
	int request_for_quit=0;
	int count=0;
	//砫 ᭮ 横 -   ந 맮  ணࠬ
	while (!request_for_quit)
	{
		Uint32 ticks_begin=SDL_GetTicks(); //६ 砫 । 
		//᫥ न ப
		int player_coordinate=player[0].x*size_labyrinth_length+player[0].y;
		//⪠ ࠭ । ᮢ ᫥饣 
		SDL_RenderClear(renderer);
		//⮢  (ᯮ ࠦ  㦭 浪  ᮮ⢥騬 न⠬)
		SDL_Rect srcrect_wall, dstrect_wall;
		//ᮢ 䮭
		SDL_RenderCopy(renderer, background, NULL, NULL);
		//SDL_BlitSurface(background, NULL, screen, NULL);
		//FIXME: ஢ઠ ࠭ ਭ  ᫮! +  ࠩ ⥭
		//᫨ ப ࠢ      ਭ
		if (player[0].direction == UP || player[0].direction == DOWN)
		{
			int sign; //  ࠢ ஭  - ⭮⥫쭮 ப
			//᫨ ப ࠢ    ਭ
			if (player[0].direction == UP)
				sign=1;
			//᫨ ப ࠢ    ਭ
			else
				sign=-1;
			//᫨ । ⥭ ( ⮬ ᫥ ࠩ) - ᮢ ⮣ 䮭  ⥭,  - ᮢ 쭥 
			if ((player[0].x-sign*1) <= 0 || (player_coordinate-sign*size_labyrinth_length) >= size_labyrinth_width*size_labyrinth_length || labyrinth[player_coordinate-sign*size_labyrinth_length] == WALL)
			{
				//SDL_BlitSurface(empty_far_background, NULL, screen, NULL);
				dstrect_wall.x=0;
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391 empty_background height=391
				dstrect_wall.h=391;
				dstrect_wall.w=640;
				SDL_RenderCopy(renderer, empty_background, NULL, &dstrect_wall);
				//SDL_BlitSurface(empty_background, NULL, screen, &dstrect_wall);
				dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
				dstrect_wall.h=391;
				dstrect_wall.w=538;
				SDL_RenderCopy(renderer, wall, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
			}
			else
			{
				//ᮢ    䮭
				dstrect_wall.x=0;
				dstrect_wall.y=(window_height-209)/2; //empty_far_background.png height=209
				dstrect_wall.h=209;
				dstrect_wall.w=640;
				SDL_RenderCopy(renderer, empty_far_background, NULL, &dstrect_wall);
				//SDL_BlitSurface(empty_far_background, NULL, screen, &dstrect_wall);
				//ᮢ 쭥 ⥭
				if (labyrinth[player_coordinate-sign*size_labyrinth_length*2] == WALL)
				{
					dstrect_wall.x=(window_width-324)/2; //wall_far width=324
					dstrect_wall.y=(window_height-211)/2; //wall_far height=211
					dstrect_wall.h=211;
					dstrect_wall.w=324;
					SDL_RenderCopy(renderer, wall_far, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_far, NULL, screen, &dstrect_wall);
				}
				//᫨     ⥭ - ᮢ ,  - ᮢ 쭥  ⥭ ( )
				if (labyrinth[player_coordinate-sign*size_labyrinth_length-1*sign] == WALL)
				{
					dstrect_wall.x=(window_width-324)/2-109; //wall_far width=324 wall_side_far_left width=109
					dstrect_wall.y=(window_height-391)/2; //wall_side_far_left height=391
					dstrect_wall.h=391;
					dstrect_wall.w=109;
					SDL_RenderCopy(renderer, wall_side_far_left, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_side_far_left, NULL, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length*2-1*sign] == WALL)
				{
					srcrect_wall.x=324-(window_width-324)/2;
					srcrect_wall.y=0;
					srcrect_wall.h=211;
					srcrect_wall.w=(window_width-324)/2;
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-211)/2;
					dstrect_wall.h=211;
					dstrect_wall.w=(window_width-324)/2;
					SDL_RenderCopy(renderer, wall_far, &srcrect_wall, &dstrect_wall);
					//SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨    ࠢ ⥭ - ᮢ ,  - ᮢ 쭥 ࠢ ⥭ ( )
				if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
				{
					//(window_width-324)/2+324=(window_width-324)/2+648/2=(window_width-324+648)/2=(window_width+324)/2
					dstrect_wall.x=(window_width+324)/2; //wall_far width=324
					dstrect_wall.y=(window_height-393)/2; //wall_side_far_left height=393
					dstrect_wall.h=393;
					dstrect_wall.w=109;
					SDL_RenderCopy(renderer, wall_side_far_right, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_side_far_right, NULL, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length*2+1*sign] == WALL)
				{
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=211;
					srcrect_wall.w=(window_width-324)/2;
					dstrect_wall.x=window_width-(window_width-324)/2;
					dstrect_wall.y=(window_height-211)/2;
					dstrect_wall.h=211;
					dstrect_wall.w=(window_width-324)/2;
					SDL_RenderCopy(renderer, wall_far, &srcrect_wall, &dstrect_wall);
					//SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
				}
				//ᮢ 쭨 -ࠧ⥫   ࠢ
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=211; //line.png height=391 wall_far.png height=211
				srcrect_wall.w=1; //line.png width-2
				dstrect_wall.x=(window_width-324)/2; //wall_far.png width=324
				dstrect_wall.y=(window_height-211)/2;
				dstrect_wall.h=211;
				dstrect_wall.w=1;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				dstrect_wall.x=window_width-(window_width-324)/2; //wall_far.png width=324
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨    ⥭ () - ᮢ ,  ந ஢ઠ
			// ⢨ 쭥   ⥭ //FIXME: ୮!
			// ᮢ  । 
			//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
			if (labyrinth[player_coordinate-1*sign] == WALL)
			{
				dstrect_wall.x=0;
				dstrect_wall.y=0;
				dstrect_wall.w=53; //wall_side_left width=53
				dstrect_wall.h=480; //wall_side_left height=480
				SDL_RenderCopy(renderer, wall_side_left, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			else if (labyrinth[player_coordinate-sign*size_labyrinth_length-1*sign] == WALL)
			{
				srcrect_wall.x=538-(window_width-538)/2;
				srcrect_wall.y=0;
				srcrect_wall.h=391;
				srcrect_wall.w=(window_width-538)/2;
				dstrect_wall.x=0; //wall.png widht=538
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391
				dstrect_wall.h=391;
				dstrect_wall.w=(window_width-538)/2;
				SDL_RenderCopy(renderer, wall, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨   ࠢ ⥭ () - ᮢ ,  ந ஢ઠ
			// ⢨ 쭥  ࠢ ⥭ //FIXME: ୮!
			// ᮢ  । 
			//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
			if (labyrinth[player_coordinate+1*sign] == WALL)
			{
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
				dstrect_wall.y=0;
				dstrect_wall.w=53; //wall_side_right width=53
				dstrect_wall.h=481; //wall_side_right height=481
				SDL_RenderCopy(renderer, wall_side_right, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			else if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
			{
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391;
				srcrect_wall.w=(window_width-538)/2;
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391
				dstrect_wall.h=391;
				dstrect_wall.w=(window_width-538)/2;
				SDL_RenderCopy(renderer, wall, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨ । 室 - ᮢ ,  ᮮ⢥⢨  ⥪騬  ६
			//(筮 । ६ ⮪ 室  includes_headers;  㤥 ७  䠩 䨣樨/ன)
			//FIXME: ।  浪 ᮢ!
			if (labyrinth[player_coordinate-sign*size_labyrinth_length] == EXIT)
			{
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=394; //exit_*.png height=394
				srcrect_wall.w=538; //exit_*.png widht=538
				dstrect_wall.x=(window_width-538)/2;
				dstrect_wall.y=(window_height-394)/2;
				dstrect_wall.h=394;
				dstrect_wall.w=538;
				if (time_of_day->tm_hour >= EVENING && time_of_day->tm_hour < NIGHT)
				{
					SDL_RenderCopy(renderer, exit_evening, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= NIGHT || time_of_day->tm_hour < MORNING) //ᯮ짮 , ᪮ NIGHT > MORNING
				{
					SDL_RenderCopy(renderer, exit_night, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= MORNING && time_of_day->tm_hour < DAY)
				{
					SDL_RenderCopy(renderer, exit_morning, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= DAY && time_of_day->tm_hour < EVENING)
				{
					SDL_RenderCopy(renderer, exit_day, &srcrect_wall, &dstrect_wall);
				}
			}
		}
		//FIXME: ஢ઠ ࠭ ਭ  ᫮! +  ࠩ ⥭
		//᫨ ப ࠢ ࠢ     ਭ
		if (player[0].direction == RIGHT || player[0].direction == LEFT)
		{
			int sign; //  ࠢ ஭  - ⭮⥫쭮 ப
			//᫨ ப ࠢ ࠢ   ਭ
			if (player[0].direction == RIGHT)
				sign=1;
			//᫨ ப ࠢ    ਭ
			else
				sign=-1;
			//᫨ । ⥭  ( ⮬ ᫥ ࠩ) - ᮢ ⮣ 䮭  ⥭,  - ᮢ 쭥 
			if ((player[0].y+1*sign) < 0 || (player[0].y+1*sign) >= size_labyrinth_length || labyrinth[player_coordinate+1*sign] == WALL)
			{
				//SDL_BlitSurface(empty_far_background, NULL, screen, NULL);
				dstrect_wall.x=0;
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391 empty_background height=391
				dstrect_wall.h=391;
				dstrect_wall.w=640;
				SDL_RenderCopy(renderer, empty_background, NULL, &dstrect_wall);
				//SDL_BlitSurface(empty_background, NULL, screen, &dstrect_wall);
				dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
				dstrect_wall.w=538;
				SDL_RenderCopy(renderer, wall, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
			}
			else
			{
				//ᮢ    䮭
				dstrect_wall.x=0;
				dstrect_wall.y=(window_height-209)/2; //empty_far_background.png height=209
				dstrect_wall.h=209;
				dstrect_wall.w=640;
				SDL_RenderCopy(renderer, empty_far_background, NULL, &dstrect_wall);
				//SDL_BlitSurface(empty_far_background, NULL, screen, &dstrect_wall);
				//ᮢ 쭥 ⥭
				if (labyrinth[player_coordinate+2*sign] == WALL)
				{
					dstrect_wall.x=(window_width-324)/2; //wall_far width=324
					dstrect_wall.y=(window_height-211)/2; //wall_far height=211
					dstrect_wall.h=211;
					dstrect_wall.w=324;
					SDL_RenderCopy(renderer, wall_far, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_far, NULL, screen, &dstrect_wall);
				}
				//᫨     ⥭ - ᮢ ,  - ᮢ 쭥  ⥭ ( )
				if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
				{
					dstrect_wall.x=(window_width-324)/2-109; //wall_far width=324 wall_side_far_left width=109
					dstrect_wall.y=(window_height-391)/2; //wall_side_far_left height=391
					dstrect_wall.h=391;
					dstrect_wall.w=109;
					SDL_RenderCopy(renderer, wall_side_far_left, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_side_far_left, NULL, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate-sign*size_labyrinth_length+2*sign] == WALL)
				{
					srcrect_wall.x=324-(window_width-324)/2;
					srcrect_wall.y=0;
					srcrect_wall.h=211;
					srcrect_wall.w=(window_width-324)/2;
					dstrect_wall.x=0;
					dstrect_wall.y=(window_height-211)/2;
					dstrect_wall.h=211;
					dstrect_wall.w=(window_width-324)/2;
					SDL_RenderCopy(renderer, wall_far, &srcrect_wall, &dstrect_wall);
					//SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
				}
				//᫨    ࠢ ⥭ - ᮢ ,  - ᮢ 쭥 ࠢ ⥭ ( )
				if (labyrinth[player_coordinate+sign*size_labyrinth_length+1*sign] == WALL)
				{
					//(window_width-324)/2+324=(window_width-324)/2+648/2=(window_width-324+648)/2=(window_width+324)/2
					dstrect_wall.x=(window_width+324)/2; //wall_far width=324
					dstrect_wall.y=(window_height-393)/2; //wall_side_far_left height=393
					dstrect_wall.h=393;
					dstrect_wall.w=109;
					SDL_RenderCopy(renderer, wall_side_far_right, NULL, &dstrect_wall);
					//SDL_BlitSurface(wall_side_far_right, NULL, screen, &dstrect_wall);
				}
				else if (labyrinth[player_coordinate+sign*size_labyrinth_length+2*sign] == WALL)
				{
					srcrect_wall.x=0;
					srcrect_wall.y=0;
					srcrect_wall.h=211;
					srcrect_wall.w=(window_width-324)/2;
					dstrect_wall.x=window_width-(window_width-324)/2;
					dstrect_wall.y=(window_height-211)/2;
					dstrect_wall.h=211;
					dstrect_wall.w=(window_width-324)/2;
					SDL_RenderCopy(renderer, wall_far, &srcrect_wall, &dstrect_wall);
					//SDL_BlitSurface(wall_far, &srcrect_wall, screen, &dstrect_wall);
				}
				//ᮢ 쭨 -ࠧ⥫   ࠢ
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=211; //line.png height=391 wall_far.png height=211
				srcrect_wall.w=1; //line.png width-2
				dstrect_wall.x=(window_width-324)/2; //wall_far.png width=324
				dstrect_wall.y=(window_height-211)/2;
				dstrect_wall.h=211;
				dstrect_wall.w=1;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
				dstrect_wall.x=window_width-(window_width-324)/2; //wall_far.png width=324
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨    ⥭ () - ᮢ ,  ந ஢ઠ
			// ⢨ 쭥   ⥭ //FIXME: ୮!
			// ᮢ  । 
			//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
			if (labyrinth[player_coordinate-size_labyrinth_length*sign] == WALL)
			{
				dstrect_wall.x=0;
				dstrect_wall.y=0;
				dstrect_wall.w=53; //wall_side_left.png width=53
				dstrect_wall.h=480; //wall_side_left.png height=480
				SDL_RenderCopy(renderer, wall_side_left, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			else if (labyrinth[player_coordinate-sign*size_labyrinth_length+1*sign] == WALL)
			{
				srcrect_wall.x=538-(window_width-538)/2;
				srcrect_wall.y=0;
				srcrect_wall.h=391;
				srcrect_wall.w=(window_width-538)/2;
				dstrect_wall.x=0; //wall.png widht=538
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391
				dstrect_wall.h=391;
				dstrect_wall.w=(window_width-538)/2;
				SDL_RenderCopy(renderer, wall, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨   ࠢ ⥭ () - ᮢ ,  ந ஢ઠ
			// ⢨ 쭥  ࠢ ⥭ //FIXME: ୮!
			// ᮢ  । 
			//  砥 ⥬ ᮢ뢠 ࠧ⥫쭠 
			if (labyrinth[player_coordinate+size_labyrinth_length*sign] == WALL)
			{
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
				dstrect_wall.y=0;
				dstrect_wall.w=53; //wall_side_right.png width=53
				dstrect_wall.h=481; //wall_side_right.png height=481
				SDL_RenderCopy(renderer, wall_side_right, NULL, &dstrect_wall);
				//SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			else if (labyrinth[player_coordinate+sign*size_labyrinth_length+1*sign] == WALL)
			{
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391;
				srcrect_wall.w=(window_width-538)/2;
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
				dstrect_wall.y=(window_height-391)/2; //wall.png height=391
				dstrect_wall.h=391;
				dstrect_wall.w=(window_width-538)/2;
				SDL_RenderCopy(renderer, wall, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(wall, &srcrect_wall, screen, &dstrect_wall);
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=391; //line.png height=391 wall.png height=391
				srcrect_wall.w=3; //line.png width=3
				dstrect_wall.x=window_width-(window_width-538)/2; //wall.png width=538
				dstrect_wall.y=(window_height-391)/2;
				dstrect_wall.h=391;
				dstrect_wall.w=3;
				SDL_RenderCopy(renderer, line, &srcrect_wall, &dstrect_wall);
				//SDL_BlitSurface(line, &srcrect_wall, screen, &dstrect_wall);
			}
			//᫨ । 室 - ᮢ ,  ᮮ⢥⢨  ⥪騬  ६
			//(筮 । ६ ⮪ 室  includes_headers;  㤥 ७  䠩 䨣樨/ன)
			//FIXME: ।  浪 ᮢ!
			if (labyrinth[player_coordinate+1*sign] == EXIT)
			{
				srcrect_wall.x=0;
				srcrect_wall.y=0;
				srcrect_wall.h=394; //exit_*.png height=394
				srcrect_wall.w=538; //exit_*.png widht=538
				dstrect_wall.x=(window_width-538)/2;
				dstrect_wall.y=(window_height-394)/2;
				dstrect_wall.h=394;
				dstrect_wall.w=538;
				if (time_of_day->tm_hour >= EVENING && time_of_day->tm_hour < NIGHT)
				{
					SDL_RenderCopy(renderer, exit_evening, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= NIGHT || time_of_day->tm_hour < MORNING) //ᯮ짮 , ᪮ NIGHT > MORNING
				{
					SDL_RenderCopy(renderer, exit_night, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= MORNING && time_of_day->tm_hour < DAY)
				{
					SDL_RenderCopy(renderer, exit_morning, &srcrect_wall, &dstrect_wall);
				}
				if (time_of_day->tm_hour >= DAY && time_of_day->tm_hour < EVENING)
				{
					SDL_RenderCopy(renderer, exit_day, &srcrect_wall, &dstrect_wall);
				}
			}
		}
		//~ SDL_BlitSurface(wall_side_left, NULL, screen, NULL);
		//~ dstrect_wall.x=window_width-(window_width-538)/2; //wall.png widht=538
		//~ dstrect_wall.y=0;
		//~ SDL_BlitSurface(wall_side_right, NULL, screen, &dstrect_wall);
		//~ dstrect_wall.x=(window_width-538)/2; //wall.png widht=538
		//~ dstrect_wall.y=(window_height-391)/2; //wall.png height=391
		//SDL_BlitSurface(wall, NULL, screen, &dstrect_wall);
		//뢮   ࠭
		SDL_RenderPresent(renderer);
		//SDL_UpdateWindowSurface(main_window);
		//SDL_Delay(3000);
		
		// ⢨ ப
		while (SDL_PollEvent(&event))
		{
			//᫨ ந 맮  ணࠬ  稭   ணࠬ
			// ப  ESC - 襭 ࠡ ணࠬ
			if (event.type == SDL_QUIT)
				request_for_quit=1;
			if (event.type == SDL_KEYDOWN)
			{
				//⠭ 祭 祩  ﭨ   㤠 ⭨
				labyrinth[player_coordinate]=player[0].previous_cell_state;
				/*switch (event.key.keysym.scancode)
				{
					case SDL_SCANCODE_ESCAPE:
						request_for_quit=1;
						break;
				}*/
				switch (event.key.keysym.sym)
				{
					case SDLK_ESCAPE:
						request_for_quit=1;
						break;
					//᫨ ப   ५ ""  "",  WS - 
					//ந ஢ઠ,  ⠥  ப ன  室  ਭ - 
					// ⮬ 砥   㤥 襭 ⢥ত  室
					// ⨢ 砥, ந  न ப   ஭
					//(᫨ ப  ⠥ ன ᪢ ⥭,  ⮬ ᫥ ࠩ)
					//᫥ ⮣ ந ஢ઠ  ⢨ ᮡ  祩,    ப
					//( ᮮ⢥騬 ⢨ﬨ - ᠭ  㭪樨 checking_for_events)
					//᫨ ப   ""  "ࠢ",  AD - 
					//ந  ࠢ,  ஬ ᬮ ப
					//(0 - , 1 - ࠢ, 2 - , 3 - )
					//   Shift  "", "ࠢ", A  D  ᬥ  ᮮ⢥ ஭
					//( )
					// ।   ப ஫ ⠩஬
					//१ SDL_GetTicks()  ன SPEED_MOVE  SPEED_TURN
					case SDLK_UP:
					case SDLK_w:
						if (player[0].in_trap)
						{
							if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
								break;
							else
								player[0].in_trap=0;
						}
						if (player[0].in_hole)
						{
							if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
								break;
							else
								player[0].in_hole=0;
						}
						if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
							break;
						switch (player[0].direction)
						{
							case UP:
								if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
								{
									player[0].x=player[0].x-1;
									player[0].step_start=SDL_GetTicks();
									//஢ઠ  ᮡ  祩,    ⭨
									checking_for_events(main_window, NULL, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case RIGHT:
								if (labyrinth[player_coordinate+1] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
								{
									player[0].y=player[0].y+1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case DOWN:
								if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
								{
									player[0].x=player[0].x+1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case LEFT:
								if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
								{
									player[0].y=player[0].y-1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
						}
						break;
					case SDLK_DOWN:
					case SDLK_s:
						if (player[0].in_trap)
						{
							if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
								break;
							else
								player[0].in_trap=0;
						}
						if (player[0].in_hole)
						{
							if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
								break;
							else
								player[0].in_hole=0;
						}
						if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
							break;
						switch (player[0].direction)
						{
							case UP:
								if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
								{
									player[0].x=player[0].x+1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case RIGHT:
								if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
								{
									player[0].y=player[0].y-1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case DOWN:
								if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
								{
									player[0].x=player[0].x-1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
							case LEFT:
								if (labyrinth[player_coordinate+1] == EXIT && request_for_exit(main_window, player) )
								{
									request_for_quit=1;
									break;
								}
								if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
								{
									player[0].y=player[0].y+1;
									player[0].step_start=SDL_GetTicks();
									checking_for_events(main_window, NULL, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
									break;
								}
								break;
						}
						break;
					case SDLK_LEFT:
					case SDLK_a:
						//~ if (player[0].direction == 0)
							//~ player[0].direction=3;
						//~ break;
						//~ player[0].direction=player[0].direction-1;
						//~ break;
						//  Shift ந ᤢ  ( )
						if (SDL_GetModState() && KMOD_SHIFT)
						{
							if (player[0].in_trap)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
									break;
								else
									player[0].in_trap=0;
							}
							if (player[0].in_hole)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
									break;
								else
									player[0].in_hole=0;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
								break;
							switch (player[0].direction)
							{
								case UP:
									//if (labyrinth[player_coordinate-1] == EXIT && request_for_exit(main_window, player) )
									if (labyrinth[player_coordinate-1] == EXIT)
									{
										//뭥ᥭ  ⤥쭮 ᫮, ᫥ ண  㫥  mod  SDL_Keysym
										// ⨢ 砥,  室   ᫮,  믮 
										//( ⪠ ப   ), ﭨ  Shift ࠭﫮  "",
										// ᨬ   ⢨⥫쭮 ﭨ
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
									{
										player[0].y=player[0].y-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case RIGHT:
									if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case DOWN:
									if (labyrinth[player_coordinate+1] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
									{
										player[0].y=player[0].y+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case LEFT:
									if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
							}
							break;
						}
						if ( (SDL_GetTicks()-player[0].step_start) < SPEED_TURN)
							break;
						if (player[0].direction == UP)
							player[0].direction=LEFT;
						else
							player[0].direction=player[0].direction-1;
						player[0].step_start=SDL_GetTicks();
						break;
					case SDLK_RIGHT:
					case SDLK_d:
						//  Shift ந ᤢ ࠢ ( )
						if (SDL_GetModState() && KMOD_SHIFT)
						{
							if (player[0].in_trap)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_IN_TRAP)
									break;
								else
									player[0].in_trap=0;
							}
							if (player[0].in_hole)
							{
								if ( (SDL_GetTicks()-player[0].trap_start) < TIME_BETWEEN_HOLES)
									break;
								else
									player[0].in_hole=0;
							}
							if ( (SDL_GetTicks()-player[0].step_start) < SPEED_MOVE)
								break;
							switch (player[0].direction)
							{
								case UP:
									if (labyrinth[player_coordinate+1] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].y < size_labyrinth_length-2) && (labyrinth[player_coordinate+1] != WALL))
									{
										player[0].y=player[0].y+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate+1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case RIGHT:
									if (labyrinth[player_coordinate+size_labyrinth_length] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].x < size_labyrinth_width-2) && (labyrinth[player_coordinate+size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x+1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate+size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case DOWN:
									if (labyrinth[player_coordinate-1] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].y > 1) && (labyrinth[player_coordinate-1] != WALL))
									{
										player[0].y=player[0].y-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate-1, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
								case LEFT:
									if (labyrinth[player_coordinate-size_labyrinth_length] == EXIT)
									{
										if (request_for_exit(main_window, player) )
										{
											request_for_quit=1;
											break;
										}
										SDL_SetModState(KMOD_NONE);
									}
									if ((player[0].x > 1) && (labyrinth[player_coordinate-size_labyrinth_length] != WALL))
									{
										player[0].x=player[0].x-1;
										player[0].step_start=SDL_GetTicks();
										checking_for_events(main_window, NULL, player_coordinate-size_labyrinth_length, player, labyrinth, size_labyrinth_length, holes, holes_array);
										break;
									}
									break;
							}
							break;
						}
						if ( (SDL_GetTicks()-player[0].step_start) < SPEED_TURN)
							break;
						if (player[0].direction == LEFT)
							player[0].direction=UP;
						else
							player[0].direction=player[0].direction+1;
						player[0].step_start=SDL_GetTicks();
						break;
				}
			}
			if (event.type == SDL_KEYDOWN)
			{
				switch (event.key.keysym.sym)
				{
					// 㧠    "p" (.)
					case SDLK_p:
						do
						{
							SDL_WaitEvent(&event);
							//㧠    室  ਫ
							//(    "ESC", ⠪     ਫ
							if (event.type == SDL_QUIT || event.key.keysym.sym == SDLK_ESCAPE)
							{
								request_for_quit=1;
								break;
							}
						}
						while (event.type != SDL_KEYDOWN || event.key.keysym.sym != SDLK_p);
				}
			}
		}
		//।饥 ﭨ ⪨ ࠭  ᫥饣 ⠭
		if (labyrinth[player[0].x*size_labyrinth_length+player[0].y] != PLAYER)
		{
			player[0].previous_cell_state=labyrinth[player[0].x*size_labyrinth_length+player[0].y];
			labyrinth[player[0].x*size_labyrinth_length+player[0].y]=PLAYER;
		}
		// ⫠  ஫ १ ᮫
		if (debug)
			show_labyrinth_in_cmd_hw(player_coordinate, player, size_labyrinth_length, size_labyrinth_width, labyrinth);
		//᫨   砫 ࠡ⪨  諮  ६,
		//祬 ॡ   祭 FPS - ࠡ⪠ ਮ⠭  ⮪ ॡ㥬 ६
		if ((SDL_GetTicks()-ticks_begin) < (1000/FPS))
			SDL_Delay((1000/FPS)-(SDL_GetTicks()-ticks_begin));
		count++;
		//char *dir[]={"", "ࠢ", "", ""};
		//printf("\rcell: %i  x: %i  y: %i  dir: %s  ", player_coordinate, player[0].x, player[0].y, dir[player[0].direction]);
	}
	//~ char *mode[]={"software", "software vsync", "hardware", "hardware vsync"};
	//~ printf("\n஢: %i ᥪ㭤: %i FPS: %.2f mode: %s\n", count, SDL_GetTicks(), (float)count/SDL_GetTicks()*1000, mode[requested_mode-1]);
	printf("\n஢: %i ᥪ㭤: %i FPS: %.2f hardware: %hi vsync: %hi\n", count, SDL_GetTicks(), (float)count/SDL_GetTicks()*1000, hw_accel, vsync);

	//TODO: ७  clean_up_sdl()
	/*SDL_FreeSurface(background);
	SDL_FreeSurface(wall);
	SDL_FreeSurface(wall_side_left);
	SDL_FreeSurface(wall_side_right);
	SDL_FreeSurface(wall_far);
	SDL_FreeSurface(wall_side_far_left);
	SDL_FreeSurface(wall_side_far_right);
	SDL_FreeSurface(line);
	SDL_FreeSurface(empty_background);
	SDL_FreeSurface(empty_far_background);*/
	SDL_DestroyTexture(background);
	SDL_DestroyTexture(wall);
	SDL_DestroyTexture(wall_side_left);
	SDL_DestroyTexture(wall_side_right);
	SDL_DestroyTexture(wall_far);
	SDL_DestroyTexture(wall_side_far_left);
	SDL_DestroyTexture(wall_side_far_right);
	SDL_DestroyTexture(line);
	SDL_DestroyTexture(empty_background);
	SDL_DestroyTexture(empty_far_background);
	SDL_DestroyTexture(exit_morning);
	SDL_DestroyTexture(exit_day);
	SDL_DestroyTexture(exit_evening);
	SDL_DestroyTexture(exit_night);
/*	IMG_Quit();
	//SDL_DestroyTexture(bitmapTex);
    //SDL_DestroyRenderer(renderer);
	SDL_DestroyWindow(main_window);
	SDL_Quit();*/
	clean_up_sdl_hw(main_window, renderer);
	return 0;
}

//४⭮ 襭 ࠡ SDL
void clean_up_sdl_hw(SDL_Window *main_window, SDL_Renderer *renderer)
{
	//~ SDL_FreeSurface(background);
	//~ SDL_FreeSurface(wall);
	//~ SDL_FreeSurface(wall_side_left);
	//~ SDL_FreeSurface(wall_side_right);
	//~ SDL_FreeSurface(wall_far);
	//~ SDL_FreeSurface(wall_side_far_left);
	//~ SDL_FreeSurface(wall_side_far_right);
	//~ SDL_FreeSurface(line);
	//~ SDL_FreeSurface(empty_background);
	//~ SDL_FreeSurface(empty_far_background);	
	IMG_Quit();
	if (renderer != NULL)
		SDL_DestroyRenderer(renderer);
	if (main_window != NULL)
		SDL_DestroyWindow(main_window);
	//Uint32 SDL_WasInit(Uint32 flags)
	SDL_Quit();
	return;
}

void show_labyrinth_in_cmd_hw(int const player_coordinate, const struct players player[], short int const length, short int const width, int const *labyrinth_temp)
{
	for (int j = 0; j < width; j++)
	{
		for (int k = 0; k < length; k++)
		{
			//0 -  ⪠, 1 - ⥭, 2 -   ⪠, 3 -   ᮯ୨, 4 - ப, 5 - 室
			//6 - , 7 -  , 8 - , 9 - 誠, 10 - ᯨ⠫, 11 - ᥭ
			if (!labyrinth_temp[(j*length)+k])
				printf("%s", "  ");
			if (labyrinth_temp[(j*length)+k] == WALL)
				printf("%s", " X");
			if (labyrinth_temp[(j*length)+k] == DUMMY)
				printf("%s", " .");
			if (labyrinth_temp[(j*length)+k] == RIVAL)
				printf("%s", " p");
			if (labyrinth_temp[(j*length)+k] == PLAYER)
			{
				//0 - , 1 - ࠢ, 2 - , 3 - 
				if (!player[0].direction)
					printf("%s", " ^");
				if (player[0].direction == RIGHT)
					printf("%s", " >");
				if (player[0].direction == DOWN)
					printf("%s", " v");
				if (player[0].direction == LEFT)
					printf("%s", " <");
			}
			if (labyrinth_temp[(j*length)+k] == EXIT)
				printf("%s", " e");
			if (labyrinth_temp[(j*length)+k] == TREASURE)
				printf("%s", " T");
			if (labyrinth_temp[(j*length)+k] == FAKE_TREASURE)
				printf("%s", " F");
			if (labyrinth_temp[(j*length)+k] == HOLE)
				printf("%s", " O");
			if (labyrinth_temp[(j*length)+k] == TRAP)
				printf("%s", " #");
			if (labyrinth_temp[(j*length)+k] == HOSPITAL)
				printf("%s", " H");
			if (labyrinth_temp[(j*length)+k] == ARSENAL)
				printf("%s", " A");
		}
		if (j == 0)
			printf("  %s%i", "cell:", player_coordinate);
		if (j == 1)
			printf("  %s%i %s%i", "x=", player[0].x, "y=", player[0].y);
		if (j == 2)
		{
			char *dir[]={"", "ࠢ", "", ""};
			printf("  %s%s", "dir:", dir[player[0].direction]);
		}
		if (j == 3)
			printf("  %s", "T F W @ H # (h)");
		if (j == 4)
			printf("  %i %i %i %i %i %i %li", player[0].has_treasure, player[0].has_fake_treasure, player[0].has_weapon, player[0].is_wounded, player[0].in_hole, player[0].in_trap, TIME_IN_TRAP-(SDL_GetTicks()-player[0].trap_start));
		printf("%s", "\n");
	}
	printf("%s", "\n");
	return;
}
