/*  settings.c

  ਭ
  Version 0.3.1

  Copyright 2017 Konstantin Zyryanov <post.herzog@gmail.com>
  
  This file is part of Labyrinth.
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published by
  the Free Software Foundation; either version 2.1 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
*/

#include "includes_macros.h"

int change_settings_file(struct options_array *options_arrayPtr, FILE *settings, char *settings_filename);
int repair_settings_file(struct options_array *options_arrayPtr, FILE *settings, char *settings_filename);
int next_element(struct options_array **options_arrayPtr, const char *option, const short int value);
int search_in_section(struct options_array *sectionPtr, FILE *settings, FILE *tmp);

int set_options(FILE *settings, char *settings_filename, short int *window_height, short int *window_width, short int *fullscreen, short int *refresh_rate, short int *fps, short int *hw_accel, short int *vsync, short int *sdl_12, short int *size_labyrinth_length, short int *size_labyrinth_width, short int *no_walls_removing, short int *rivals, short int *holes, short int *trap_time, short int *hole_time, short int *speed, short int *turn_speed, short int *debug, short int *visual, short int *result)
{
	//᫨ 䠩    - ந ⨥ 饣 䠩  㬮砭
	// ᮧ  䠩  ன  㬮砭
	if (!settings)
	{
		int string_lenght_1=strlen("   䠩 ஥!\n ");
		int string_lenght_2=strlen((DEFAULT_SETTINGS_FILE));
		char *error_message=calloc(string_lenght_1+string_lenght_2+1, 1);
		snprintf(error_message, string_lenght_1+string_lenght_2+1, "   䠩 ஥!\n %s", DEFAULT_SETTINGS_FILE);
		if (!(settings = fopen(DEFAULT_SETTINGS_FILE, "r")))
		{
			perror(error_message);
			printf(" ... (\"%s\")\n\n", DEFAULT_SETTINGS_FILE);
			if (change_settings_file(NULL, settings, settings_filename))
				return 1;
		}
		free(error_message);
		error_message=NULL;
	}
	if (!settings)
	{
		if (!(settings = fopen(DEFAULT_SETTINGS_FILE, "r")))
		{
			perror("஡  ᮧ 䠩 ஥\n஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫\n");
			return 1;
		}
	}
	//᫨ 䠩  (ࠧ 0 ) -  㤥  ⠭  祭ﬨ  㬮砭
	char *temp_string_1=calloc(100, 1);
	fgets(temp_string_1, 100, settings);
	if (feof(settings))
	{
		if (change_settings_file(NULL, settings, settings_filename))
			return 1;
		if (!(settings = fopen(settings_filename, "r")))
		{
			perror("஡  ᮧ 䠩 ஥\n஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫\n");
			return 1;
		}
	}
	free(temp_string_1);
	if (fseek(settings, 0, SEEK_SET))
	{
		perror(" 砥 ⠭ 䠩 ஥");
		return 1;
	}
	struct options_array *options_arrayPtr=NULL;
	while (!feof(settings))
	{
		int success=0;
		//ᨬ ࠧ 뢠 ப - 100 ᨬ
		char *option=calloc(100, 1);
		char *temp_string_1=calloc(100, 1);
		char *temp_string_2=calloc(100, 1);
		if (!option || !temp_string_1 || !temp_string_2)
		{
			puts("஡    ६ ⥭ 䠩 ஥");
			fclose(settings);
			return 2;
		}
		short int value=NULL;
		fgets(temp_string_1, 100, settings);
		//FIXME: 祭 樨    ⮫쪮  ࠧ  맮 㭪樨 change_settings_file()
		//(騥 樨 १뢠,    ᫥)
		
		//᫨ ப 稭     ᨬ
		//(਩/ ப  室  ᫥ ப/砫  ᥪ樨)-  ய᪠
		if (strspn(temp_string_1, "#\n["))
			continue;
		success=sscanf(temp_string_1, "%s = %s", option, temp_string_2);
		if (success == 1)
		{
			int string_lenght=0;
			string_lenght=strlen(temp_string_1);
			int before_equal_sign=strcspn(temp_string_1, "=");
			//᫨  ப   ࠢ⢠ - ப 㤥 ஢
			//(㭪樨 change_settings_file() 㤥 । ࢮ ᫮ ப  祭 ࠬ "-2")
			if (before_equal_sign == string_lenght)
			{
				before_equal_sign=strcspn(temp_string_1, " ");
				memset(option, 0, 100);
				strncpy(option, temp_string_1, before_equal_sign);
				if (next_element(&options_arrayPtr, option, -2))
					return 2;
				continue;
			}
			memset(option, 0, 100);
			strncpy(option, temp_string_1, before_equal_sign);
			strncpy(temp_string_2, &temp_string_1[before_equal_sign+1], string_lenght);
			//᫨   ன   ஡ -  㤥   ਧ  ப
			// ⨢ 砥 ਧ  ப ⠭   ப ᨢ,  直 砩
			//(஡   ࠧ ⮫쪮   ப)
			before_equal_sign=strcspn(option, " ");
			if (before_equal_sign < 100)
				option[before_equal_sign]='\000';
			else
				option[99]='\000';
			success=2;
			printf("Ptr: %i Lenght: %i\n", before_equal_sign, string_lenght);
		}
		if (success == 2)
		{
			//  祭, ॢ ࠧ short int,  ⠪  ᫮ ᨬ
			long int temp_int_2;
			char *tile_string[100]={""};
			temp_int_2=strtol(temp_string_2, tile_string, 10);
			printf("Int: %li String: %s Tile: %s Equal: %i\n", temp_int_2, temp_string_2, *tile_string, temp_string_2 == *tile_string);
			if ((!temp_int_2) && (temp_string_2 == *tile_string))
			{
				//᫨ ८ࠧ ப  ᫮  㤠 - ன ᢠ
				//祭 ࠢ "-1", ஥ 㤥  쭥襬 ࠧ   祭  㬮砭
				value=-1;
				if (next_element(&options_arrayPtr, option, value))
					return 2;
			}
			else if (temp_int_2)
				value=temp_int_2;
			if (value != -1)
			{
				//᫨  䠩 ஥ ᠭ ஡ ᫮/ -
				//⠪ 祭  祭  楫 ᥫ/ࠢ  㫨  祭  㬮砭
				char value_string[10]; // 10 c  㬥 筮 讥 ᫮
				snprintf(value_string, 10, "%hi;", value);
				if (strcmp(value_string, temp_string_2))
				{
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
			}
			printf("%s = %hi\n", option, value);
			//   ஢७   室   樠樨 SDL
			if (!strcmp("Height", option))
			{
				if (value < 0)
				{
					value=DEFAULT_RES_Y;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*window_height=value;
			}
			else if (!strcmp("Width", option))
			{
				if (value < 0)
				{
					value=DEFAULT_RES_X;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*window_width=value;
			}
			//᫨ 祭 Fullscreen   - 㤥 ⠭  ०
			//(祭   "0")
			//, ᫨ 祭  "1" - 㤥 ⠭ ࠭ ०
			//(祭   "1")
			else if (!strcmp("Fullscreen", option))
			{
				if (value < 0)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value > 1)
				{
					value=1;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*fullscreen=value;
			}
			//       ⮫쪮 祭 "FPS"
			// 㬮砭  稭 ⠭  ⥫ ஭ ("-1"),
			// 樠樨 SDL ࠨ    ࠭
			//祭 "FPS"   ⠭ ,      "1"
			else if (!strcmp("Refresh_rate", option))
				*refresh_rate=value; //㤥 ஢७  쭥襬   SDL
			else if (!strcmp("FPS", option))
			{
				if (!value || value < -2)
				{
					value = -1;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*fps=value;
			}
			//祭 "Hardware_Acceleration" 㪠뢠  室
			//樠樨 SDL  ⢮ ⭮ ᪮७
			//⥫ 祭 (஬ "-1")  ९ᠭ  "0" (⪫祭 ⭮ ᪮७)
			//⥫ 祭 (஬ "1")  ९ᠭ  "1" (祭 ⭮ ᪮७)
			else if (!strcmp("Hardware_Acceleration", option))
			{
				if (value < -2)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value == -1)
				{
					value=1; //祭  㬮砭
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value > 1)
				{
					value=1;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*hw_accel=value;
			}
			//祭 "VSync" 㪠뢠  室 樠樨 SDL
			// ⢮ ० ᨭ஭樨 ⨪쭮  ࠭
			//⥫ 祭 (஬ "-1")  ९ᠭ  "0" (⪫祭 ᨭ஭樨)
			//⥫ 祭 (஬ "1")  ९ᠭ  "1" (祭 ᨭ஭樨)
			else if (!strcmp("VSync", option))
			{
				if (value < -2)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value == -1)
				{
					value=1; //祭  㬮砭
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value > 1)
				{
					value=1;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*vsync=value;
			}
			//ࠬ "SDL_12_style" 㪠뢠  室 ᯮ짮 ணࠬ ᪮७
			//  API SDL 1.2 (஥ ५   ஬ 
			// 㭪樨  ४⭮ ᮢ  饬    ,
			// ஥   ࠡ   設/⥬)
			//TODO: ஢, ⠪    ᠬ 
			//⥫ 祭 ( "-1")  ९ᠭ  "0" (ᯮ짮 API SDL 2.x)
			//⥫ 祭 (஬ "1")  ९ᠭ  "1" (ᯮ짮 API SDL 1.2)
			
			// ࠬ ᮢ⨬  ࠬࠬ "Hardware_Acceleration"  "VSync",
			// ᯮ  API SDL 2.x
			//᫨ 祭      㤥 ࠢ "1",
			// 祭 ࠬ "SDL_12_style" ⠪ 㤥 ⠭  "1" -
			//᫥  ਮ, 祭 ᮢ⨬ ࠬ஢  襭  ﭨ "0"
			
			else if (!strcmp("SDL_12_style", option))
			{
				if (value < 0)
				{
					value=0; //祭  㬮砭
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value > 1)
				{
					value=1;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
					if (*hw_accel)
					{
						if (next_element(&options_arrayPtr, "Hardware_Acceleration", 0))
							return 2;
					}
					if (*vsync)
					{
						if (next_element(&options_arrayPtr, "VSync", 0))
							return 2;
					}
				}
				*sdl_12=value;
			}
			// ਭ  ஢  ।
			// DEFAULT_MIN_LENGTH/DEFAULT_MIN_WIDTH  DEFAULT_MAX_LENGTH/DEFAULT_MAX_WIDTH
			//( 㬮砭 -  5  1000 ⮪)
			//祭 訥, 祬 ᨬ쭮 ,  ࠢ  ᨬ쭮 
			//祭  쭮   ࠢ  쭮 
			//⥫ 祭  ࠢ  祭  㬮砭
			else if (!strcmp("Labyrinth_length", option))
			{
				if (value > DEFAULT_MAX_LENGTH)
				{
					value=DEFAULT_MAX_LENGTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				if (value < DEFAULT_MIN_LENGTH && value > 0)
				{
					value=DEFAULT_MIN_LENGTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				if (value < 0)
				{
					value=DEFAULT_LENGTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				*size_labyrinth_length=value+2;
			}
			else if (!strcmp("Labyrinth_width", option))
			{
				if (value > DEFAULT_MAX_WIDTH)
				{
					value=DEFAULT_MAX_WIDTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				if (value < DEFAULT_MIN_WIDTH && value > 0)
				{
					value=DEFAULT_MIN_WIDTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				if (value < 0)
				{
					value=DEFAULT_WIDTH;
					if (next_element(&options_arrayPtr, option, value))
							return 2;
				}
				*size_labyrinth_width=value+2;
			}
			//ࠬ "Not_Remove_Walls" 㪠뢠  室
			//࠭ "ࠢ쭮" (横筮) ਭ ( 祭 ࠢ "1")
			// 祭 (஬ "1")  ९ᠭ  "0" (㤠 砩 ⥭  ਭ   ᮧ)
			else if (!strcmp("Not_Remove_Walls", option))
			{
				if (value != 1 && value != 0)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*no_walls_removing=value;
			}
			//ࠬ "Rivals" 㪠뢠 饥  ⢮ ᮯ୨,    ( ப)
			//FIXME: ᨬ쭮 ⢮ ⭨   ࠭祭
			//祭      祭  㬮砭
			else if (!strcmp("Rivals", option))
			{
				if (value < 0)
				{
					value=RIVALS;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*rivals=value;
			}
			//ࠬ "Pits" 㪠뢠  ⢮   
			//TODO:    横᪨ 易  ᮡ
			//TODO:  ᤥ  ᮧ ᪮쪨 易  ᮡ  
			//  易 横᪨ - ஢ઠ   ⭮ ⢮  ந
			//祭      祭  㬮砭
			//FIXME: ᨬ쭮 ⢮   ࠭祭!
			//TODO:    ᯮᮡ  ᮡ  室 ६ ⭨
			// 砩  ਭ - ⢮      1,  ࠢ 0
			else if (!strcmp("Pits", option))
			{
				if (value < 0)
				{
					value=HOLES;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				if (value == 1) //. TODO 
				{
					value=2;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*holes=value;
			}
			//६, ஢񭭮  誥  祭  ६饭  ࠬ
			// 䠩 ன 㪠뢠  ᥪ㭤,
			//᪮ SDL API ਭ ᥪ㭤 - ந 㬭  1000
			//࠭祭  30 ᥪ㭤 易  ᨬ쭮  祭 ६ ⨯ short int - 32767
			//⥫ 祭    祭  㬮砭
			else if (!strcmp("Time_in_trap", option))
			{
				if (value < 0 || value > 30)
				{
					value=TIME_IN_TRAP;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*trap_time=value*1000;
			}
			else if (!strcmp("Time_between_holes", option))
			{
				if (value < 0 || value > 30)
				{
					value=TIME_BETWEEN_HOLES;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*hole_time=value*1000;
			}
			//ࠬ ᪮   প  (稢)
			// ப   (६饭  ⪠  )
			//TODO: ࠭祭  ᨬ쭮 祭  
			//⥫ 祭    祭  㬮砭
			else if (!strcmp("Speed_move", option))
			{
				if (value < 0)
				{
					value=SPEED_MOVE;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*speed=value;
			}
			else if (!strcmp("Speed_turn", option))
			{
				if (value < 0)
				{
					value=SPEED_TURN;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*turn_speed=value;
			}
			// ⭮襭 ࠬ஢  ਭ  ६ /㠫樨 ஥ ਭ/
			// ⮢ ᨨ ਭ ࠧ  ᫥  ஥ -
			// 祭, ஬ "1"    祭  㬮砭 ("0" -  뢠)
			else if (!strcmp("Visual", option))
			{
				if (value != 1 && value != 0)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*debug=value;
			}
			else if (!strcmp("Show_Building", option))
			{
				if (value != 1 && value != 0)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*visual=value;
			}
			else if (!strcmp("Show_Finished", option))
			{
				if (value != 1 && value != 0)
				{
					value=0;
					if (next_element(&options_arrayPtr, option, value))
						return 2;
				}
				*result=value;
			}
			//᫨ ⠭ ப  ⭮     ஥
			//( ⮬ ᫥ - ࠬ᪨  ᨭ⨪祪 訡) -  㤥 ஢
			else
			{
				if (next_element(&options_arrayPtr, option, -2))
					return 2;
			}
		}
		free(option);
		free(temp_string_1);
		free(temp_string_2);
		option=NULL;
		temp_string_1=NULL;
		temp_string_2=NULL;
	}
	//  - ஥   (   祭)  ᠭ  䠩 ஥
	// ᠬ 㤥 ᤥ, ᫨ 㦨 ⠥ ப/⠭ ன
	//( 㤥  ஢,  ⠭)
	if (options_arrayPtr)
	{
		if (change_settings_file(options_arrayPtr, settings, settings_filename))
		{
			perror(" ஥ ०.\n⠭  㤠");
			return 1;
		}
	}
	else
	{
		if (fclose(settings))
		{
			perror(" 砥    䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 1;
		}
	}
	return 0;
	//஢ઠ ४⭮ 㦥  䠩 ࠬ஢
	printf("window_height %hi\nwindow_width %hi\nfullscreen %hi\nrefresh_rate %hi\nfps %hi\nhw_accel %hi\nvsync %hi\nsdl_12 %hi\nsize_labyrinth_length %hi\nsize_labyrinth_width %hi\nno_walls_removing %hi\nrivals %hi\nholes %hi\ntrap_time %hi\nhole_time %hi\nspeed %hi\nturn_speed %hi\ndebug %hi\nvisual %hi\nresult %hi\n", *window_height, *window_width, *fullscreen, *refresh_rate, *fps, *hw_accel, *vsync, *sdl_12, *size_labyrinth_length, *size_labyrinth_width, *no_walls_removing, *rivals, *holes, *trap_time, *hole_time, *speed, *turn_speed, *debug, *visual, *result);
	//~ return 1;
}

//砥 ࠬ: ᯨ᮪ (易 ᯨ᮪/ᨢ ) ஥  
//(,  祭, 㪠⥫  ᫥騩 )  㪠⥫  䠩 ஥
int change_settings_file(struct options_array *options_arrayPtr, FILE *settings, char *settings_filename)
{	
	//᫨ ᯨ᮪ ஥    (㪠⥫ 뫠  NULL) -
	//ॡ ᮧ / १ 騩 䠩 ஥
	if (!options_arrayPtr)
	{
		//। ᨢ ப  祭  㬮砭 ( ⠪ ਥ),  ᮤࠦ  䠩 ஥
		//TODO: ஢   । ५ 祭  㬮砭 "SDL_12_style", ᥪ樨 "[DEBUG]"  .
		#define SECTION_NUMBERS 3 //⢮ ᥪ権  䠩 ஥
		char *sections[]={"[VIDEO]", "[GAME]", "[DEBUG]"};
		char *video_options[]={"Height", "Width", "Fullscreen", "Refresh_rate", "FPS", "Hardware_Acceleration", "VSync", "SDL_12_style"};
		short int video_values[]={DEFAULT_RES_Y, DEFAULT_RES_X, 0, -1, -1, 1, 1, 0};
		char *video_comments[]={"#Resolution\n#Only supported by adapter and monitor!\n",
								"", "", "",
								"#FPS is usually set to adaptor/monitor refresh rate\n#but may be changed for slowdown/acceleration of internal computing\n#If this value is \"-1\", it will be set to the refresh rate of the screen\n",
								
								"#Either 0 (no acceleration/VSync) or 1 (with acceleration/VSync)\n", "",
								
								"#Old version of software acceleration without VSync and with some bugs\n#Set to 1 for this or 0 for new version\n#If this option is set to 1, then \"Hardware_Acceleration\" and \"VSync\"\n#options will be ignored\n"};
		
		char *game_options[]={"Labyrinth_length", "Labyrinth_width", "Not_Remove_Walls", "Rivals", "Pits", "Time_in_trap", "Time_between_holes", "Speed_move", "Speed_turn"};
		short int game_values[]={DEFAULT_LENGTH, DEFAULT_WIDTH, 0, RIVALS, HOLES, TIME_IN_TRAP/1000, TIME_BETWEEN_HOLES/1000, SPEED_MOVE, SPEED_TURN};
		char *game_comments[]={"#Something between 5-1000\n", "",
			
								"#Either 1 (no walls will be removing) or 0\n#(some walls will be remove that cause to create potentially cycling labyrinth)\n",
								"#Total number of rivals (including player)\n",
								"#Total number of pits in floor\n#(for fast travel to far end of labyrinth. Or, maybe to neighbour cell)\n#Either 0 (no pits at all), either something greater 1\n",
								"#Time in seconds, no more than 30\n", "",
								
								"#Time in milliseconds (lesser is faster)\n", ""};
		
		char *debug_options[]={"Visual", "Show_Building", "Show_Finished"};
		unsigned short int debug_values[]={0, 0, 0};
		char *debug_comments[]={"#Show labyrinth in terminal/console\n#For developing/debugging or cheating only\n",
								
								"#Show process of creating skeleton of labyrinth\n",
								
								"#Show the final version of skeleton of labyrinth\n#before the game start\n"};
		
		if (settings)
			fclose(settings);
		int string_lenght_1=strlen(" 砥 ᮧ 䠩 ஥ ");
		int string_lenght_2=strlen(settings_filename);
		char *error_message=calloc(string_lenght_1+string_lenght_2+1, 1);
		snprintf(error_message, string_lenght_1+string_lenght_2+1, " 砥 ᮧ 䠩 ஥ %s", settings_filename);
		if (!(settings = fopen(settings_filename, "w")))
		{
			perror(error_message);
			puts("஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			free(error_message);
			error_message=NULL;
			return 1;
		}
		free(error_message);
		error_message=NULL;
		fprintf(settings, "%s", "#Comments are beginning with number sign '#'\n");
		fprintf(settings, "%s", "#Section titles has highlited by brakets '[]'\n");
		fprintf(settings, "%s", "#Options and values are separated by an equal sign '='\n\n");
		for (int i = 0; i < SECTION_NUMBERS; i++)
		{
			fprintf(settings, "%s\n", sections[i]);
			switch (i)
			{
				case 0:
					for (int j = 0; j < sizeof(video_values)/sizeof(short int); j++)
					{
						fprintf(settings, "%s%s = %hi;\n", video_comments[j], video_options[j], video_values[j]);
					}
					break;
				case 1:
					for (int j = 0; j < sizeof(game_values)/sizeof(short int); j++)
					{
						fprintf(settings, "%s%s = %hi;\n", game_comments[j], game_options[j], game_values[j]);
					}
					break;
				case 2:
					for (int j = 0; j < sizeof(debug_values)/sizeof(short int); j++)
					{
						fprintf(settings, "%s%s = %hi;\n", debug_comments[j], debug_options[j], debug_values[j]);
					}
					break;
				default:
					printf("  ஥  ᥪ樨 %s!", sections[i]);
					break;
			}
			fprintf(settings, "\n");
		}
		if (fclose(settings))
		{
			perror(" 砥 ᮧ 䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 1;
		}
	}
	if (options_arrayPtr)
	{
		if (settings)
			fclose(settings);
		// ।饩 १ࢭ   ᮧ   饣 䠩 ஥
		char *backup_filename=calloc(strlen(settings_filename)+strlen(".bak")+1,1);
		snprintf(backup_filename, strlen(settings_filename)+strlen(".bak")+1, "%s.bak", settings_filename);
		
		int string_lenght_1=strlen("訡 㤠 ।饩 १ࢭ \n ");
		int string_lenght_2=strlen(backup_filename);
		char *error_message=calloc(string_lenght_1+string_lenght_2+1, 1);
		snprintf(error_message, string_lenght_1+string_lenght_2+1, "訡 㤠 ।饩 १ࢭ \n %s", backup_filename);
		
		if (remove(backup_filename))
		{
			perror(error_message);
		}
		free(error_message);
		error_message=NULL;
		puts(" १ࢭ  䠩 ஥");
		if (rename(settings_filename, backup_filename))
		{
			perror("  ࠭ १ࢭ  䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 1;
		}
		if (!(settings = fopen(backup_filename, "r")))
		{
			perror(" 砥    䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 1;
		}
		FILE *tmp;
		if (!(tmp = fopen(settings_filename, "w")))
		{
			perror(" 砥    䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			fclose(settings);
			return 1;
		}
		do
		{
			char temp_string_1[100]={""};
			char temp_string_2[50]={""};
			struct options_array *last_options_arrayPtr=options_arrayPtr;
			struct options_array *previous_options_arrayPtr=options_arrayPtr;
			fgets(temp_string_1, 100, settings);
			//᫨  室 䠩  ᪮쪮  ப  -
			//  㤠 (⠭ ⮫쪮 )
			int ch=fgetc(settings);
			if (!strcmp(temp_string_1, "\n") && (ch == 10 || ch == 13))
			{
				ungetc(ch, settings);
				continue;
			}
			else
				ungetc(ch, settings);
			//ਨ,  ᥪ権   ப ࠧ  뢠  䠩,
			// 쭥襩 ࠡ⪨
			if (strspn(temp_string_1, "#\n["))
			{
				fputs(temp_string_1, tmp);
				continue;
			}
			sscanf(temp_string_1, "%s", temp_string_2);
			int success=0;
			while (last_options_arrayPtr)
			{
				int string_lenght=strlen(last_options_arrayPtr->change_option);
				//᫨ ᫥ ᨬ ஢塞 ப ᮤন  ॢ ப -   㤥 뢠  ࠢ
				if (last_options_arrayPtr->change_option[string_lenght-1] == '\n')
					string_lenght--;
				if (!strncmp(last_options_arrayPtr->change_option, temp_string_2, string_lenght))
				{
					if (last_options_arrayPtr == options_arrayPtr)
						options_arrayPtr=options_arrayPtr->next_option;
					previous_options_arrayPtr->next_option=last_options_arrayPtr->next_option;
					success=1;
					break;
				}
				if (previous_options_arrayPtr != last_options_arrayPtr)
					previous_options_arrayPtr=last_options_arrayPtr;
				last_options_arrayPtr=last_options_arrayPtr->next_option;
			}
			if (!success)
				fputs(temp_string_1, tmp);
			if (success)
			{
				//᫨  ⢥ 祭 । "-2" - ப 㤥 ஢
				//( ᨬ  ப 㤥 "#")
				if (last_options_arrayPtr->change_value == -2)
					fprintf(tmp, "#%s", temp_string_1);
				else
					fprintf(tmp, "%s = %hi;\n", last_options_arrayPtr->change_option, last_options_arrayPtr->change_value);
				free(last_options_arrayPtr);
			}
		} while (!feof(settings));
		if (options_arrayPtr)
		{
			printf("\n : (%p)\n", options_arrayPtr);
			struct options_array *last_options_arrayPtr=options_arrayPtr;
			while (last_options_arrayPtr)
			{
				printf("%s = %hi (%p)\n", last_options_arrayPtr->change_option, last_options_arrayPtr->change_value, last_options_arrayPtr->next_option);
				last_options_arrayPtr=last_options_arrayPtr->next_option;
			}
		}
		puts("");
		if (fclose(tmp))
		{
			perror(" 砥    䠩 ஥");
			puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
			return 1;
		}
		//᫨  ᯨ᪥ ஥ ⠫ - ᠭ ன,
		//   - 稭 (஢/㤠/ᠭ  訡  .)  뫨   䠩 ஥
		// ⮬ 砥 ந ⪠ ⠭  ஥   
		//  ᮮ⢥饩 ஢ ன,    ᮮ⢥饩 ᥪ樨 (ࠧ 䠩 ஥)
		if (options_arrayPtr)
		{
			puts(" ஥ ०. ⪠ ⠭...");
			repair_settings_file(options_arrayPtr, settings, settings_filename);
		}
		else
		{
			if (fclose(settings))
			{
				perror(" 砥    䠩 ஥");
				puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
				return 1;
			}
		}
	}
	return 0;
}

//᫨  ᯨ᪥ ஥ ⠫ - ᠭ ன,
//   - 稭 (஢/㤠/ᠭ  訡  .)  뫨   䠩 ஥
// ⮬ 砥 ந ⪠ ⠭  ஥   
//  ᮮ⢥饩 ஢ ன,    ᮮ⢥饩 ᥪ樨 (ࠧ 䠩 ஥)
int repair_settings_file(struct options_array *options_arrayPtr, FILE *settings, char *settings_filename)
{
	// 砥 ⠭ 㤥 ᮧ   १ࢭ  ( 饩 १ࢭ )
	if (settings)
		fclose(settings);
	char *backup_filename=calloc(strlen(settings_filename)+strlen(".bak")+1,1);
	char *backup2_filename=calloc(strlen(settings_filename)+strlen(".bak_old")+1,1);
	snprintf(backup_filename, strlen(settings_filename)+strlen(".bak")+1, "%s.bak", settings_filename);
	snprintf(backup2_filename, strlen(settings_filename)+strlen(".bak_old")+1, "%s.bak_old", settings_filename);
	
	int string_lenght_1=strlen("訡 㤠 ।饩 १ࢭ \n ");
	int string_lenght_2=strlen(backup2_filename);
	char *error_message=calloc(string_lenght_1+string_lenght_2+1, 1);
	snprintf(error_message, string_lenght_1+string_lenght_2+1, "訡 㤠 ।饩 १ࢭ \n %s", backup2_filename);
		
	if (remove(backup2_filename))
	{
		perror(error_message);
	}
	free(error_message);
	error_message=NULL;
	puts(" १ࢭ   १ࢭ  䠩 ஥");
	if (rename(backup_filename, backup2_filename))
	{
		perror(" 砥 ࠭ । १ࢭ  䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 1;
	}
	//~ if (remove("settings.ini.bak"))
	//~ {
		//~ perror("訡 㤠 १ࢭ \n settings.ini.bak");
	//~ }
	puts(" १ࢭ  䠩 ஥");
	if (rename(settings_filename, backup_filename))
	{
		perror(" 砥 ࠭ १ࢭ  䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 1;
	}
	if (!(settings = fopen(backup_filename, "r")))
	{
		perror(" 砥 ⠭ 䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 1;
	}
	FILE *tmp;
	if (!(tmp = fopen(settings_filename, "w")))
	{
		perror(" 砥 ⠭ 䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		fclose(settings);
		return 1;
	}
	char *video_options[]={"Height", "Width", "Fullscreen", "Refresh_rate", "FPS", "Hardware_Acceleration", "VSync", "SDL_12_style", ""};
	char *game_options[]={"Labyrinth_length", "Labyrinth_width", "Not_Remove_Walls", "Rivals", "Holes", "Time_in_trap", "Time_between_holes", "Speed_move", "Speed_turn", ""};
	char *debug_options[]={"Visual", "Show_Building", "Show_Finished", ""};
	//ந 뢠 ஥  ⠭  ᢠ  ᮮ⢥騬 ᯨ᪠
	//( ᥪ/ࠧ  䠩 ஥)
	struct options_array *last_options_arrayPtr=options_arrayPtr;
	struct options_array *video_options_arrayPtr=NULL;
	struct options_array *game_options_arrayPtr=NULL;
	struct options_array *debug_options_arrayPtr=NULL;
	while (last_options_arrayPtr)
	{
		int count=0;
		while (strcmp(video_options[count], ""))
		{
			if (!strcmp(video_options[count], last_options_arrayPtr->change_option))
				next_element(&video_options_arrayPtr, last_options_arrayPtr->change_option, last_options_arrayPtr->change_value);
			count++;
		}
		count=0;
		while (strcmp(game_options[count], ""))
		{
			if (!strcmp(game_options[count], last_options_arrayPtr->change_option))
				next_element(&game_options_arrayPtr, last_options_arrayPtr->change_option, last_options_arrayPtr->change_value);
			count++;
		}
		count=0;
		while (strcmp(debug_options[count], ""))
		{
			if (!strcmp(debug_options[count], last_options_arrayPtr->change_option))
				next_element(&debug_options_arrayPtr, last_options_arrayPtr->change_option, last_options_arrayPtr->change_value);
			count++;
		}
		last_options_arrayPtr=last_options_arrayPtr->next_option;
	}
	while (!feof(settings))
	{
		char temp_string_1[100]={""};
		fgets(temp_string_1, 100, settings);
		// ६ ⥭ 室 䠩 ஥   ப  ਨ
		//ࠧ  ७   䠩  
		if (strspn(temp_string_1, "#\n"))
		{
			fputs(temp_string_1, tmp);
			continue;
		}
		// ࠧ ந  ᮮ⢥ ஥
		//     - ⠢ ᬮ७  ࠧ
		//(᫨  ) ७  ,   㤥 ⨣ ᫥騩 ࠧ   䠩
		if (strspn(temp_string_1, "["))
		{
			fputs(temp_string_1, tmp);
			if (!strncmp(temp_string_1, "[VIDEO]", 7))
				search_in_section(video_options_arrayPtr, settings, tmp);
			if (!strncmp(temp_string_1, "[GAME]", 6))
				search_in_section(game_options_arrayPtr, settings, tmp);
			if (!strncmp(temp_string_1, "[DEBUG]", 7))
				search_in_section(debug_options_arrayPtr, settings, tmp);
			continue;
		}
		fputs(temp_string_1, tmp);
	}
	if (fclose(tmp))
	{
		perror(" 砥 ⠭ 䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 1;
	}
	if (fclose(settings))
	{
		perror(" 砥 ⠭ 䠩 ஥");
		puts("஢ ࠢ 㯠  ⠫  䠩  ன   ᢮   ᪥  ࠧ, ᮤঠ騬  ⠫");
		return 1;
	}
	return 0;
}

//㭪     祭  易 ᯨ᮪ (ᨢ ) ஥  /⠭
//FIXME: 祭 樨    ⮫쪮  ࠧ  맮 㭪樨
//(騥 樨 १뢠,    ᫥)
int next_element(struct options_array **options_arrayPtr, const char *option, const short int value)
{
	struct options_array *new_options_arrayPtr=NULL;
	if (!(new_options_arrayPtr=calloc(1, sizeof(struct options_array))))
	{
		perror(" ஥ ०.\n⠭  㤠 - ஡  ");
		return 2;
	}
	strcpy(new_options_arrayPtr->change_option, option);
	new_options_arrayPtr->change_value=value;
	new_options_arrayPtr->next_option=NULL;
	if (!(*options_arrayPtr))
		*options_arrayPtr=new_options_arrayPtr;
	else
	{
		struct options_array *last_options_arrayPtr=NULL;
		last_options_arrayPtr=*options_arrayPtr;
		//᫨ ன 㦥   ᨢ,   祭    祭
		if (!strcmp(last_options_arrayPtr->change_option, new_options_arrayPtr->change_option))
		{
			last_options_arrayPtr->change_value=new_options_arrayPtr->change_value;
			return 0;
		}
		while (last_options_arrayPtr->next_option)
		{
			last_options_arrayPtr=last_options_arrayPtr->next_option;
			//᫨ ன 㦥   ᨢ,   祭    祭
			if (!strcmp(last_options_arrayPtr->change_option, new_options_arrayPtr->change_option))
			{
				last_options_arrayPtr->change_value=new_options_arrayPtr->change_value;
				return 0;
			}
		}
		last_options_arrayPtr->next_option=new_options_arrayPtr;
	}
	return 0;
}

//㭪 ᪠    ஥,  ⠭,  䠩 ஥
// 﫥   㦥 饩,  ஢ ன,
//  ᠬ  ⥪饣 ࠧ (ᥪ樨) ஥
int search_in_section(struct options_array *sectionPtr, FILE *settings, FILE *tmp)
{
	char temp_string_1[100]={""};
	fpos_t position;
	struct options_array *last_options_arrayPtr=NULL;
	while (sectionPtr)
	{
		fgetpos(settings, &position);
		fgets(temp_string_1, 100, settings);
		if (temp_string_1[0] == '#')
		{
			char temp_string_11[100]={""};
			char temp_string_12[100]={""};
			char temp_string_13[100]={""};
			char temp_string_14[100]={""};
			int success=0;
			//⪠ 童   ப, ᮤঠ ᫥騥 ਠ:
			//"ன 祭"
			//"ன = 祭"
			//ன = 祭 ;"
			// 砥 ᮢ    ਠ⮢ ࢮ ᫮ ப ( ண ᨬ -
			//  '#') ࠢ  ᯨ᪮ ஥  ⠭
			//᫨ ᮢ  - 㤥 ᠭ  (⠭) ਠ, ᫨  - ⠭  䠩
			success=sscanf(temp_string_1, "%s %s %s %s", temp_string_11, temp_string_12, temp_string_13, temp_string_14);
			if ((success < 3) \
			|| ((success == 3) && !(strcmp(temp_string_12, "="))) \
			|| ((success == 4) && !(strcmp(temp_string_12, "=")) && !(strcmp(temp_string_14, ";"))))
			{
				struct options_array *previous_options_arrayPtr=sectionPtr;
				last_options_arrayPtr=sectionPtr;
				while (last_options_arrayPtr)
				{
					int string_lenght=strlen(last_options_arrayPtr->change_option);
					if (!strncmp(last_options_arrayPtr->change_option, &temp_string_11[1], string_lenght))
					{
						fputs(temp_string_1, tmp);
						fprintf(tmp, "%s = %hi;\n", last_options_arrayPtr->change_option, last_options_arrayPtr->change_value);
						printf("⠭ ࠬ \"%s\"...\n", last_options_arrayPtr->change_option);
						if (last_options_arrayPtr == sectionPtr)
							sectionPtr=sectionPtr->next_option;
						previous_options_arrayPtr->next_option=last_options_arrayPtr->next_option;
						free(last_options_arrayPtr);
						temp_string_1[0]='\000'; // ᪫祭 㡫஢ ப   뢮 
						break;
					}
					if (previous_options_arrayPtr != last_options_arrayPtr)
						previous_options_arrayPtr=last_options_arrayPtr;
					last_options_arrayPtr=last_options_arrayPtr->next_option;
				}
				// 砩, ᫨ ᫮ 㤥 ,  ᮢ  㤥 
				fputs(temp_string_1, tmp);
			}
			//᫨ ⠭ ப  室     ਠ⮢ -  㤥 ७ᥭ  
			else
				fputs(temp_string_1, tmp);
		}
		//஢ઠ   ࠧ  砫 
		//᫨ ᫥ ⮩ ப 稭  ࠧ -
		// ⠭ ன   ࠧ  ᠭ 
		else if (!(strcmp(temp_string_1, "\n")))
		{
			fgetpos(settings, &position);
			fgets(temp_string_1, 100, settings);
			if ((temp_string_1[0] == '\010') || (temp_string_1[0] == '\013') || (temp_string_1[0] == '['))
			{
				while (sectionPtr)
				{
					fprintf(tmp, "%s = %hi;\n", sectionPtr->change_option, sectionPtr->change_value);
					printf("⠭ ࠬ \"%s\"...\n", sectionPtr->change_option);
					sectionPtr=sectionPtr->next_option;
				}
				fputs("\n", tmp); // ⮩ ப  
			}
			//⠭ 樨  ᫥饣 ४⭮ 뢠  ᫥饣 ࠧ
			fsetpos(settings, &position);
		}
		//஢ઠ   ࠧ  砫 
		//( ⠭ ன   ࠧ  ᠭ )
		else if (temp_string_1[0] == '[')
		{
			while (sectionPtr)
			{
				fprintf(tmp, "%s = %hi;\n", sectionPtr->change_option, sectionPtr->change_value);
				printf("⠭ ࠬ \"%s\"...\n", sectionPtr->change_option);
				sectionPtr=sectionPtr->next_option;
			}
			//⠭ 樨  ᫥饣 ४⭮ 뢠  ᫥饣 ࠧ
			fsetpos(settings, &position);
			break;
		}
		// ⠫ ப ७  
		else
			fputs(temp_string_1, tmp);
	}
	return 0;
}
